#!/usr/bin/perl

###############################################################################
# Greymatter 1.7.4                           
# Copyright (c)2000-2007, The Greymatter team 
# http://greymatterforum.proboards82.com/     
# By possessing this software, you agree not to hold the author responsible for 
# any problems that may arise from your installation or usage of Greymatter 
# itself, or from any content generated by yourself or others through the use of 
# this program.  You <I>may</I> freely modify and redistribute this program, so 
# long as every copyright notice (including in this manual and in the Greymatter 
# code) remains fully intact.  Finally, you may <I>not</I> sell or in any way 
# make a financial profit from this program, either in original or modified form.
# Your possession of this software signifies that you agree to these terms; 
# please delete your copy of this software if you don't agree to these terms.
# Original Creator Noah Grey
###############################################################################

## Gm 
# This script is the admin interface that will all the blog admins or 'Authors' to
# configure and manage the blog
# 
# CONVENTIONS
# 1. Return a string rather than printing, this is just more elegant.  Leave prints
#   to the calling subroutine
# 2. Private subroutines should start with the '_' character.  By private I mean
#   it will never be called outside of this package.
# 3. If you have more than 1 or 2 parameters, especially if they are not required,
#   use named parameters such as in createRadioButton.  By putting stuff in a 
#   hash we gain the flexibility to add more optional parameters without having
#   to pass in '' placeholders or modify existing code.
# 6. Use ' and " where appropriate.  If you don't have any variables or newlines
# then use ', its quicker and cleaner.  
# 7. Don't put all text on one huge long line.  It messes with some programs
# that don't do line wraps. 

# use strict;
# use warnings;
# TODO: use taint mode!!!

eval {
	($0 =~ m,(.*)/[^/]+,) && unshift (@INC, "$1");
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");
};

use lib 'libs';

use CGI::Carp qw(fatalsToBrowser);
use Gm_Constants;

require "gm-library.cgi";

# ----------------------------------------
# gathering the input & checking for login
# ----------------------------------------

%IN = %{Gm_Web::getWebParams( errHandler=>\&Gm_Web::displayAdminErrorExit )};

&gm_readconfig; # TODO COORDINATE SO ONLY DONE ONCE PER CALL
## TODO, get rid of and use Gm_Storage::getConfigs, have to get rid of uses here
my $gmConfigs = Gm_Storage::getConfigs( errHandler=>\&Gm_Web::displayAdminErrorExit );

## Check if Banned, this will not returned if they are banned, this is not handled by Security
# since Security may have its own banlist, while Gm has its own seperate banlist
Gm_Core::processBanCheck( ip=>$ENV{'REMOTE_ADDR'}, errHandler=>\&Gm_Web::displayAdminErrorExit, 
	action=>Gm_Core::text( Gm_Constants::ACCESS_ADMIN ) );

## Generisize to an html safe method, should this be after validate?? or is it XSS protection, should be in 
## logic that actually logs username/pw
## Also, this is knowing how we auth, this should be done by Gm_Security, if at all,
# once all references to authorname and authorpassword are removed from admin screens
# USE Gm_Security::getFormAuth or Gm_Security::getUrlAuth 
$IN{'authorname'} =~ s/</\&lt\;/g;
$IN{'authorname'} =~ s/>/\&gt\;/g;
$IN{'authorpassword'} =~ s/</\&lt\;/g;
$IN{'authorpassword'} =~ s/>/\&gt\;/g;


my %AUTHOR = %{ Gm_Security::auth( webparams=>\%IN,
	errHandler=>\&Gm_Web::displayAdminErrorExit ) };

### New pattern for handling these requests
handleRequest();


print Gm_Web::createRequestHeader();  ## Wrong Place, can't move until all below is refactored out



if ($IN{'thomas'} eq "rebuildupdate") { &gm_rebuildupdate; }

if ($IN{'thomas'} eq "Update Now") { &gm_versionupgrading; }

if ($IN{'thomas'} eq "gmbmpost") { &gm_addentrypopup; }

if ($IN{'thomas'} eq "Return To Main Menu") { frontPage(); }  # This should be the fall through case

### Once we have redone everything else, this can be removed since we have redone the Frontpage
#if ($IN{'thomas'} eq "Add A New Entry") { &gm_addentry; }
#if ($IN{'thomas'} eq "Edit An Entry") { &gm_editentryselection; }
if ($IN{'thomas'} eq "Configuration") { &gm_configuration; }
if ($IN{'thomas'} eq "Edit Templates") { &gm_edittemplates; }
# if ($IN{'thomas'} eq "Edit Authors") { &gm_editauthors; }
# if ($IN{'thomas'} eq "Edit Banned IP List") { &gm_editbanlist; }
#if ($IN{'thomas'} eq "Add Bookmarklets") { &gm_addbookmarklets; }
if ($IN{'thomas'} eq "Upload Files") { &gm_uploadfiles; }
if ($IN{'thomas'} eq "Rebuild Files") { &gm_rebuildfilesmenu; }
#if ($IN{'thomas'} eq "View Control Panel Log") { &gm_viewcplog; }

if ($IN{'thomas'} eq "Add This Entry") { &gm_savenewentry; }
#if ($IN{'thomas'} eq "Preview Before Posting") { &gm_previewentry; }

if ($IN{'thomas'} eq "Re-Edit This Entry") {
	if ($IN{'gmbmspecial'} eq "popupblog") { &gm_addentrypopup; } else { &gm_addentry; }
}

#if ($IN{'thomas'} eq "Change View") { &gm_editentryselection; }
#if ($IN{'thomas'} eq "Search") { &gm_editentryselection; }

#if ($IN{'thomas'} eq "Edit Selected Entry") { &gm_editthisentry; }
#if ($IN{'thomas'} eq "Open/Close Selected Entry") { &gm_changeentryopenstatus; }
#if ($IN{'thomas'} eq "Search And Replace Across All Entries") { &gm_editentrysearchandreplace; }

#if ($IN{'thomas'} eq "Edit Selected Comment") { &gm_editselectedcomment; }
#if ($IN{'thomas'} eq "Delete Selected Comment") { &gm_deleteselectedcomment; }
#if ($IN{'thomas'} eq "Delete All Selected Comments") { &gm_DeleteAllSelectedComments; }
#if ($IN{'thomas'} eq "Save Changes To This Entry") { &gm_saveentrychanges; }
#if ($IN{'thomas'} eq "Select Another Entry") { &gm_editentryselection; }

#if ($IN{'thomas'} eq "Return To Entry Selection") { &gm_editentryselection; }

#if ($IN{'thomas'} eq "Perform Search And Replace") { &gm_performsearchandreplace; }

#if ($IN{'thomas'} eq "Save Changes To This Comment") { &gm_savecommentchanges; }
#if ($IN{'thomas'} eq "Return To Entry Editing") { &gm_editthisentry; }

# if ($IN{'thomas'} eq "Add New IP") { &gm_addbannedip; }
# if ($IN{'thomas'} eq "Delete Selected IP") { &gm_deletebannedip; }

if ($IN{'thomas'} eq "Diagnostics & Repair") { &gm_diagnosticscheck; }
if ($IN{'thomas'} eq "Save Configuration") { &gm_saveconfiguration; }

if ($IN{'thomas'} eq "Perform Diagnostics & Repair") { &gm_diagnosticsperform; }
if ($IN{'thomas'} eq "Return To Configuration") { &gm_configuration; }

if ($IN{'thomas'} eq "Edit Main Index-Related Templates") { &gm_editmainindextemplates; }
if ($IN{'thomas'} eq "Edit Archive-Related Templates") { &gm_editarchivetemplates; }
if ($IN{'thomas'} eq "Edit Entry Page-Related Templates") { &gm_editentrypagetemplates; }
if ($IN{'thomas'} eq "Edit Karma & Comments-Related Templates") { &gm_editkarmacommentstemplates; }
if ($IN{'thomas'} eq "Edit Header, Footer & Sidebar Templates") { &gm_editheaderfootertemplates; }
if ($IN{'thomas'} eq "Edit Miscellaneous Templates") { &gm_editmisctemplates; }

if ($IN{'thomas'} eq "Return To Templates Menu") { &gm_edittemplates; }
if ($IN{'thomas'} eq "Save Template Changes") { &gm_savetemplatechanges; }

#if ($IN{'thomas'} eq "Edit Selected Author") { &gm_editselectedauthor; }
#if ($IN{'thomas'} eq "Delete Selected Author") { &gm_deleteselectedauthor; }
#if ($IN{'thomas'} eq "Create New Author") { &gm_createnewauthor; }

#if ($IN{'thomas'} eq "Save Changes To This Author") { &gm_saveauthorchanges; }
#if ($IN{'thomas'} eq "Return To Author Panel") { &gm_editauthors; }

if ($IN{'thomas'} eq "Upload This File") { &gm_processupload; }

if ($IN{'thomas'} eq "Rebuild Last Entry Page Only") { &gm_rebuildlastentrypageonly; }
if ($IN{'thomas'} eq "Rebuild Main Index File") { &gm_rebuildmainindexfile; }
if ($IN{'thomas'} eq "Rebuild Main Entry Pages") { &gm_rebuildmainentrypages; }
if ($IN{'thomas'} eq "Rebuild Archive Master Index") { &gm_rebuildarchivemasterindex; }
if ($IN{'thomas'} eq "Rebuild Archive Log Indexes") { &gm_rebuildarchivelogindexes; }
if ($IN{'thomas'} eq "Rebuild Archive Entry Pages") { &gm_rebuildarchiveentrypages; }
if ($IN{'thomas'} eq "Rebuild All Entry Pages") { &gm_rebuildallentrypages; }
if ($IN{'thomas'} eq "Rebuild Connected Files") { &gm_rebuildconnectedfilescheck; }
if ($IN{'thomas'} eq "Rebuild Everything") { &gm_rebuildeverything; }

# if ($IN{'thomas'} eq "Clear And Exit") {
# 	unlink ("$gmConfigs->{'gmentriespath'}/gmrightclick-$IN{'usethisauthorname'}.reg");
# 	&gm_frontpage;
# }

#if ($IN{'thomas'} eq "Reset The Control Panel Log") { &gm_resetcplog; }

if ($IN{'thomas'} eq "Include This Image In A New Entry") { &gm_addentry; }
if ($IN{'thomas'} eq "Include In Entry As A Popup Window") {
	$IN{'newentrymaintext'} = $IN{'newentrypopuptext'};
	&gm_addentry;
}
if ($IN{'thomas'} eq "Include This Link In A New Entry") { &gm_addentry; }

exit;

### This is the requst handler.  We are migrating away from looking at a 
# 'thomas' variable to determine what should be done.  Also, instead of a lot of
# if statements (which makes it hard to tell which one is executed if the variable
# is messed with) the new logic is that each area of the Admin Application will
# have a 'section' parameter and then each section will denote an 'action' such
# as 'edit', 'delete', etc.
sub handleRequest {

	if( $IN{'section'} eq 'cplog' || $IN{'cplog'} ){
		## The Control Panel Log
		$IN{'section'} = 'cplog';
		## Once navigation is by links, not buttons, can get rid of the or clause
		doCplog();
	
	} elsif( $IN{'section'} eq 'banip' || $IN{'banip'} ){
		## The Control Panel Log
		$IN{'section'} = 'banip';
		## Once navigation is by links, not buttons, can get rid of the or clause
		doBanip();
	
	} elsif( $IN{'section'} eq 'relogin' || $IN{'relogin'} ){
		## Re Authing
		$IN{'section'} = 'relogin';
		## Once navigation is by links, not buttons, can get rid of the or clause

		%AUTHOR = %{ Gm_Security::auth( webparams=>\%IN, reauth=>1,
			errHandler=>\&Gm_Web::displayAdminErrorExit ) };
	
	} elsif( $IN{'section'} eq 'login' || $IN{'login'} ){
		## just logged in
		$IN{'login'} = 'login';
		doLogin();
		
	} elsif( $IN{'section'} eq 'authors' || $IN{'authors'} ){
		## Editing Authors
		$IN{'section'} = 'authors';
		doAuthors();	

	} elsif( $IN{'section'} eq 'entries' || $IN{'entries'} ){
		## Editing Authors
		$IN{'section'} = 'entries';
		doEntries();	

	} elsif( $IN{'section'} eq 'bookmarklet' || $IN{'bookmarklet'} ){
		## Editing Authors
		$IN{'section'} = 'bookmarklet';
		viewBookmarklet();	## Since just one thing, violating do pattern

	} 
	

	#frontPage(); # eventually we are going to default to the menu or login,
	# but it would mess without fall through, where we do new stuff first and old if nothing else
}


## Front Page
# Will display the main page of Greymatter
# (opt) ARG1: Message to display to user, could be error or confirmation of action
sub frontPage {
	my $message = shift( @_ ) || Gm_Constants::EMPTY;
	
## TODO: no font tags in main menu and strip table of formatting, layout
## DONE AT TOP, REMOVE
#	my $gmConfigs = Gm_Storage::getConfigs( errHandler=>\&Gm_Web::displayAdminErrorExit );
	
	## this is taken care of by the auth mechanism, but we are double checking anyway
	## It is not Gm_Security's responsibility to tell user can't access, Security tells us, we tell user
	if( $AUTHOR{'viewadmin'} ne Gm_Constants::Y ){
		Gm_Core::writeToCplog( '<span class="error_msg">'.Gm_Core::text( 
			Gm_Constants::LOGIN_NO_ACCESS, { AUTHOR=>$AUTHOR{'author'}}).'</span>' );
		$message = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::LOGIN_ACCESS_DENY ).'</span><br />';
		#&gm_login; ## this will be auth( revalidate=>1, $message );, no, they don't have access, and they weren't prompted to give credentials?
		Gm_Web::displayAdminErrorExit( $message );
	}

	my $page = '<span class="section_title">'.Gm_Core::text( Gm_Constants::FRONTPAGE_TITLE ).
		"</span><br /><p>$message</p><p class=\"text_left\">\n";
		
	my $setnameandpwcookie = Gm_Constants::EMPTY;
# 	if( ($IN{'authorname'} eq "Alice" ) && ($IN{'authorpassword'} eq "wonderland") ){
	if( ($AUTHOR{'author'} eq 'Alice' ) && ($AUTHOR{'password'} eq 'woCCASD0Wk0IA') ){
		$setnameandpwcookie = "<SCRIPT TYPE=\"text/javascript\" ".
			"LANGUAGE=\"JavaScript\">\n<!--//\n".
			"deleteCookie(\"gmcookiename\" );\n".
			"deleteCookie(\"".Gm_Constants::GM_COOKIE_PW."\" );\n//-->\n</SCRIPT>";
	} else {
		## TODO: FIX THIS, AUTHOR CREDENTIALS ARE THE PROVIDENCE OF GM_SECURITY
		# REMEMBER LOGIN SHOULD BE DONE BY GM_SECURITY
		$setnameandpwcookie = "<SCRIPT TYPE=\"text/javascript\" ".
			"LANGUAGE=\"JavaScript\">\n<!--//\nvar now = new Date();\n".
			"fixDate(now);\nnow.setTime(now.getTime() + 365 * 24 * 60 * 60 * 1000);\n".
			"setCookie(\"gmcookiename\", \"$IN{'loginname'}\", now);\n".
			"setCookie(\"".Gm_Constants::GM_COOKIE_PW."\", \"$IN{'loginpw'}\", now);\n//-->\n</SCRIPT>";
	}
	
	if( $gmConfigs->{'gmcookiesallowed'} eq Gm_Constants::NO || !$IN{'login'} ){
		$setnameandpwcookie = Gm_Constants::EMPTY;
	}


	$page .= $setnameandpwcookie;
		
	my @actions = ();
	my $item = Gm_Constants::EMPTY;
	
	## Alice should not have 'Post New' by default
	if( $AUTHOR{'postnew'} eq Gm_Constants::Y ){	
		$item = '<input type="hidden" name="section" value="entries">'.
			'<input type=submit class="button" name="new" '.
			'value="'.Gm_Core::text( Gm_Constants::FRONTPAGE_ADDNEW ).'" style="background: #D0FFD0;" '.
			'><br />'.Gm_Core::text( Gm_Constants::FRONTPAGE_ADDNEW_DESC );
		push( @actions, $item );
	}
	
	#	my $visityoursitelink = Gm_Constants::EMPTY;	
	# THIS SHOULD BE LINK THAT LOOKS LIKE BUTTON, SEE MULTIEDIT
	## TODO this should be an action that can be pushed onto actions, 
	# but because of form, no can do for now
	unless( ! -e "$gmConfigs->{'gmlogpath'}/$gmConfigs->{'gmindexfilename'}"  ){
#		&gm_readcounter;
		my $gmCounters = Gm_Storage::getCounters( errHandler=>\&Gm_Web::displayAdminErrorExit );
		
		unless( $gmCounters->{'entrytotal'} eq '0' ){
			my $indexfilenamesmartcheck = "/$gmConfigs->{'gmindexfilename'}";
			my $indexfilenameprefix = substr($gmConfigs->{'gmindexfilename'}, 0, 6);
			if( $indexfilenameprefix eq 'index.' ) { 
				$indexfilenamesmartcheck = "/"; 
			}
				
			$item = '<a href="'.$gmConfigs->{'gmlogwebpath'}.$indexfilenamesmartcheck.'" target="NEW" '.
				'class="link_button" STYLE="background: #D0FFD0; padding: 3px 5em 3px 5em">'.
				Gm_Core::text( Gm_Constants::FRONTPAGE_VISIT ).'</a>'.
				'<br />'.Gm_Core::text( Gm_Constants::FRONTPAGE_VISIT_DESC );
			push( @actions, $item );
		}
	}

	if( $AUTHOR{'editconfigs'} eq Gm_Constants::Y ){	
		$item = '<input type=submit class="button" name="thomas" '.
			'value="'.Gm_Core::text( Gm_Constants::FRONTPAGE_CONFIG ).'"><br />'.
			Gm_Core::text( Gm_Constants::FRONTPAGE_CONFIG_DESC );
		push( @actions, $item );
	}

	## Alice should not have 'Post New' by default
	if( $AUTHOR{'editentries'} eq Gm_Constants::Y || $AUTHOR{'editentries'} eq 'O' ){	
		$item = '<input type=submit class="button" name="entries" '.
			'value="'.Gm_Core::text( Gm_Constants::FRONTPAGE_EDIT ).'"><br />'.
			Gm_Core::text( Gm_Constants::FRONTPAGE_EDIT_DESC );
		push( @actions, $item );
	}
	
	if( $AUTHOR{'edittemplates'} eq Gm_Constants::Y || $AUTHOR{'edittemplates'} eq 'O' ){	
		$item = '<input type=submit class="button" name="thomas" '.
			'value="'.Gm_Core::text( Gm_Constants::FRONTPAGE_TEMPL ).'"><br />'.
			Gm_Core::text( Gm_Constants::FRONTPAGE_TEMPL_DESC );
		push( @actions, $item );
	}

	if( $AUTHOR{'editauthors'} eq Gm_Constants::Y ){	
		$item = '<input type=submit class="button" name="authors" '.
			'value="'.Gm_Core::text( Gm_Constants::FRONTPAGE_AUTHORS ).'"><br />'.
			Gm_Core::text( Gm_Constants::FRONTPAGE_AUTHORS_DESC );
		push( @actions, $item );
	}
	
	if( $AUTHOR{'rebuild'} eq Gm_Constants::Y ){	
		$item = '<input type=submit class="button" name="thomas" '.
			'VALUE="'.Gm_Core::text( Gm_Constants::FRONTPAGE_REBUILD ).'"><br />'.
			Gm_Core::text( Gm_Constants::FRONTPAGE_REBUILD_DESC );
		push( @actions, $item );
	}

	if( $AUTHOR{'viewcplog'} eq Gm_Constants::Y ){	
		$item = '<INPUT TYPE=SUBMIT CLASS="button" NAME="cplog" '.
			'VALUE="'.Gm_Core::text( Gm_Constants::FRONTPAGE_CPLOG ).'"><br />'.
			Gm_Core::text( Gm_Constants::FRONTPAGE_CPLOG_DESC );
		push( @actions, $item );
	}

	## Alice should not have 'Post New' by default
	if( $AUTHOR{'bookmarklets'} eq Gm_Constants::Y ){	
		$item = '<INPUT TYPE=SUBMIT CLASS="button" NAME="bookmarklet" '.
		'VALUE="'.Gm_Core::text( Gm_Constants::FRONTPAGE_BMLETS ).'"><BR>'.
		Gm_Core::text( Gm_Constants::FRONTPAGE_BMLETS_DESC );
		push( @actions, $item );
	}
	
	if( $AUTHOR{'upload'} eq Gm_Constants::Y ){	
		$item = '<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" '.
			'VALUE="'.Gm_Core::text( Gm_Constants::FRONTPAGE_UPLOAD ).'"><br />'.
			Gm_Core::text( Gm_Constants::FRONTPAGE_UPLOAD_DESC );
		push( @actions, $item );
	}
	
	if( $AUTHOR{'editconfigs'} eq Gm_Constants::Y ){	
		$item = '<INPUT TYPE=SUBMIT CLASS="button" NAME="banip" '.
			'VALUE="'.Gm_Core::text( Gm_Constants::FRONTPAGE_BANNED ).'"><BR>'.
			Gm_Core::text( Gm_Constants::FRONTPAGE_BANNED_DESC );
		push( @actions, $item );
	}

	$item = '<INPUT TYPE=SUBMIT CLASS="button" NAME="relogin" '.
		'VALUE="'.Gm_Core::text( Gm_Constants::FRONTPAGE_RELOGIN ).'"><BR>'.
		Gm_Core::text( Gm_Constants::FRONTPAGE_RELOGIN_DESC ).'</FONT></FONT>';
	push( @actions, $item );
	
	$page .= '<table border="0" cellpadding="10" cellspacing="0" width="80%">';
	while( @actions ){
		my $actOne = shift( @actions );
		my $actTwo = shift( @actions );
		
		$page .= '<tr><td style="font-size: smaller; margin: 5px;" valign="top" width="50%">'.
			'<form action="gm.cgi" method=post>'.Gm_Security::getFormAuth( author=>\%AUTHOR ).
			$actOne.'</form>'.
			'</td>'."\n".'<td style="font-size: smaller; margin: 5px;" valign="top" width="50%">';
		if( $actTwo ){
			$page .= '<form action="gm.cgi" method=post>'.Gm_Security::getFormAuth( author=>\%AUTHOR ).
				$actTwo.'</form>';
		} else {
			$page .= '&nbsp;';
		}
		$page .= "</td></tr>\n";
	
	}
	$page .= '</FORM></table></p>';

	Gm_Web::displayAdminPageExit( $page );
	## NAVIGATION SHOULD BE DE-BUTTONED
	exit(0); ## will never get here, in theory
}

## LOGIN SECTION #################################################
## Handle all requests regarding logging in
sub doLogin {

	# TODO: SHOULD WE BE CHECKING PERMS IF AUTHOR CAN EVEN ACCESS ADMIN SCREEN?
	# ITS HANDLED IN MENU, BUT THAT SEEMS LAME?

	Gm_Core::writeToCplog( '<span class="status_msg">'.
		Gm_Core::text( Gm_Constants::LOGIN_LOG, { AUTHOR=>$AUTHOR{'author'} } ).'</span>' );
	&gm_versioncheck;

## DONE AT TOP, REMOVE
#	my $gmConfigs = Gm_Storage::getConfigs( errHandler=>\&Gm_Web::displayAdminErrorExit );

## Checking if a bunch of paths are empty and setting them up
	if( ($gmConfigs->{'gmcgilocalpath'} eq Gm_Constants::EMPTY) || 
		($gmConfigs->{'gmcgiwebpath'} eq Gm_Constants::EMPTY) || 
		($gmConfigs->{'gmlogpath'} eq Gm_Constants::EMPTY) || 
		($gmConfigs->{'gmentriespath'} eq Gm_Constants::EMPTY) || 
		($gmConfigs->{'gmlogwebpath'} eq Gm_Constants::EMPTY) || 
		($gmConfigs->{'gmentrieswebpath'} eq Gm_Constants::EMPTY) || 
		$gmConfigs->{'gmemoticonspath'} eq Gm_Constants::EMPTY ){

		my $loglocalpath = '';
		if( ($gmConfigs->{'gmcgilocalpath'} eq Gm_Constants::EMPTY) && 
			($gmConfigs->{'gmlogpath'} ne Gm_Constants::EMPTY) ){ 
			$gmConfigs->{'gmcgilocalpath'} = $gmConfigs->{'gmlogpath'}; 
			$loglocalpath = $gmConfigs->{'gmcgilocalpath'};
		}
		if( ($gmConfigs->{'gmcgiwebpath'} eq Gm_Constants::EMPTY) && 
			($gmConfigs->{'gmlogwebpath'} ne Gm_Constants::EMPTY) ){ 
			$gmConfigs->{'gmcgiwebpath'} = $gmConfigs->{'gmlogwebpath'}; 
		}


		if( $gmConfigs->{'gmcgilocalpath'} eq Gm_Constants::EMPTY ){
			if( $ENV{'SCRIPT_FILENAME'} ){ 
				$gmConfigs->{'gmcgilocalpath'} = $ENV{'SCRIPT_FILENAME'}; 
			} elsif( $ENV{'PATH_TRANSLATED'} ){
				$gmConfigs->{'gmcgilocalpath'} = $ENV{'PATH_TRANSLATED'};
				$gmConfigs->{'gmcgilocalpath'} =~ s/\\/\//g; 
			}
		
			my @cgilocalpathtemp = split(/\//, $gmConfigs->{'gmcgilocalpath'});
			pop(@cgilocalpathtemp);
			$gmConfigs->{'gmcgilocalpath'} = join("\/", @cgilocalpathtemp);

			$loglocalpath = $gmConfigs->{'gmcgilocalpath'};
			$loglocalpath =~ s/\/cgi-bin//g;
		}

		my @cgipath = split(/\//, $gmConfigs->{'gmcgilocalpath'});
		my $cgiwebpathextension = pop(@cgipath);

		my @logpath = split(/\//, $loglocalpath);
		my $logwebpathextension = pop(@logpath);
		
		my $logwebpathextensionnew = '/'.$logwebpathextension;
		if( $logwebpathextension eq 'public_html' ){ 
			$logwebpathextensionnew = Gm_Constants::EMPTY; 
		}
	
		if( $gmConfigs->{'gmlogpath'} eq Gm_Constants::EMPTY ){ 
			$gmConfigs->{'gmlogpath'} = $loglocalpath; 
		}
		if( $gmConfigs->{'gmentriespath'} eq Gm_Constants::EMPTY ){ 
			$gmConfigs->{'gmentriespath'} = ("$loglocalpath" . "/archives"); 
		}

		my $basewebpath = '/';
		my $basewebcgipath = '/cgi-bin/';
		if( $ENV{'HTTP_HOST'} && $ENV{'SCRIPT_URL'} ){
			$basewebpath = "http://$ENV{'HTTP_HOST'}$ENV{'SCRIPT_URL'}";
			my @bwp = split( '\/', $basewebpath );
			pop( @bwp ); # should be script
			$basewebcgipath = join( '/', @bwp );
			pop( @bwp ); # should be cgi-bin
			$basewebpath = join( '/', @bwp );
		} elsif( $ENV{'SCRIPT_URI'} ){
			$basewebpath = $ENV{'SCRIPT_URI'};
			my @bwp = split( '\/', $basewebpath );
			pop( @bwp ) if( scalar( @bwp ) > 1 ); # should be script
			$basewebcgipath = join( '/', @bwp );
			pop( @bwp ) if( scalar( @bwp ) > 1 ); # should be cgi-bin
			$basewebpath = join( '/', @bwp );
		} elsif( $ENV{'HTTP_HOST'} ){
			$basewebpath = "http://$ENV{'HTTP_HOST'}/$logwebpathextensionnew";
			$basewebcgipath = "http://$ENV{'HTTP_HOST'}/$cgiwebpathextension";		
		}
	
		if( $gmConfigs->{'gmcgiwebpath'} eq Gm_Constants::EMPTY ){ 
			$gmConfigs->{'gmcgiwebpath'} = $basewebcgipath; 
		}		
		
		if( $gmConfigs->{'gmlogwebpath'} eq Gm_Constants::EMPTY ){ 
			$gmConfigs->{'gmlogwebpath'} = $basewebpath; 
		}
		if( $gmConfigs->{'gmentrieswebpath'} eq Gm_Constants::EMPTY ){ 
			$gmConfigs->{'gmentrieswebpath'} = "$basewebpath/archives"; 
		}

		if( $gmConfigs->{'gmemoticonspath'} eq Gm_Constants::EMPTY ){ 
			$gmConfigs->{'gmemoticonspath'} = "$basewebpath/emoticons"; 
		}
		
#		&gm_writeconfig;
		Gm_Storage::setConfigs( configs=>$gmConfigs, errHandler=>\&Gm_Web::displayAdminErrorExit );
	}
##  END of path changes
	
	my $gmCounters = Gm_Storage::getCounters( errHandler=>\&Gm_Web::displayAdminErrorExit );
	my $statusnote = '<span class="status_msg">'.
		Gm_Core::text( Gm_Constants::LOGIN_WELCOME, { AUTHOR=>$AUTHOR{'author'} } ).'</span><p>';

	if( $gmCounters->{'entrytotal'} < 1 ){
			my $cploglines = Gm_Storage::getCplog( errHandler=>\&Gm_Web::displayAdminErrorExit );
			
			my $cplogtext = join (' ', @$cploglines);
			unless ($cplogtext =~ /successfully performed diagnostics/) {
			$statusnote = '<span class="status_msg">'.Gm_Core::text( Gm_Constants::LOGIN_FIRST ).'</span><p>';
		}
	}
	frontPage( $statusnote );
	
	exit(0);
}


## CPLOG SECTION #################################################
## Handle all requests from the control panel page
## and verify that author can access this section
sub doCplog {

	## Checking authorization of author, since cplog has no granularity, can check here
	### TODO: CALL AUTH WITH FLAG TO WORK ON CPLOG, OR CHECK AUTHOR PERMS
	## TODO: Move this to auth, auth should return users perms, or it should take a flag to 
	# indicate which perms to check with this being handed off to a generic permDenied func
	if( $AUTHOR{'viewcplog'} ne Gm_Constants::Y ){
		Gm_Core::writeToCplog( '<span class="error_msg">'.Gm_Core::text( 
			Gm_Constants::CPLOG_NO_ACCESS, { AUTHOR=>$AUTHOR{'author'} }).'</span>' );
		my $statusnote = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::CPLOG_ACCESS_DENY ).
			'</span><br />';
		frontPage( $statusnote );
	}

	my $status = Gm_Constants::EMPTY;
	
	if( $IN{'reset'} ){
		## clear - Should return message for frontpage, or to cplog?
		$status = resetCpLog();
		
	}

	viewCpLog( $status );
}


## View Cp Log
# Will display the control panel log
# (opt) ARG1: Message to display to user, could be error or confirmation of action
sub viewCpLog {
	my $message = shift( @_ ) || Gm_Constants::EMPTY;
	
	my $page = '<span class="section_title">'.Gm_Core::text( Gm_Constants::CPLOG_TITLE ).
		"</span><br /><p>$message</p><p class=\"text_left\">\n";
	
	my $gmlogfile = Gm_Storage::getCplog( errHandler=>\&Gm_Web::displayAdminErrorExit );
	
	my $base = '?section=cplog&'.Gm_Security::getUrlAuth( author=>\%AUTHOR );
	my ($page_nav, $short_logfile ) = Gm_Web::createPaging( data=>$gmlogfile,
		baseurl=>$base , webparams=>\%IN );
	
	$page .= join( "<br />\n", @{$short_logfile} );
	$page .= "<div class='pagenav'>$page_nav</div>\n";
	
## DONE AT TOP, REMOVE
#	my $gmConfigs = Gm_Storage::getConfigs( errHandler=>\&Gm_Web::displayAdminErrorExit );	
	my ($gmdate) = Gm_Utils::getStdDate( $gmConfigs->{'gmserveroffset'} );
#	&gm_readcounter;  ## use storage call, which this does, but we should call right one...
	my $gmCounters = Gm_Storage::getCounters( errHandler=>\&Gm_Web::displayAdminErrorExit );
	
	my $newalltimetotalkarmanumber = 0;
	my $newalltimetotalkarmavotes = 0;
	my $entriesonmainnumber = 0;
	my $karmavotesonaverage = 0;
	my $commentspostedonaverage = 0;	
	## TODO: VALIDATE NUMBERS, DON'T WANT TO CAUSE ERRORS WITH BAD DATA
	if ($gmCounters->{'entrytotal'} ne '0') {
		$newalltimetotalkarmanumber = $gmCounters->{'karmapos'} - $gmCounters->{'karmaneg'};
		$newalltimetotalkarmavotes = $gmCounters->{'karmapos'} + $gmCounters->{'karmaneg'};
		$entriesonmainnumber = $gmCounters->{'entrytotal'} - $gmCounters->{'archivetotal'};
		$karmavotesonaverage = Gm_Utils::toFirstDec( ($newalltimetotalkarmavotes / $gmCounters->{'entrytotal'}));
		$commentspostedonaverage = Gm_Utils::toFirstDec( ($gmCounters->{'commenttotal'} / $gmCounters->{'entrytotal'}));
	}

	my $totalclosedentries = $gmCounters->{'closedtotal'};
	if( $gmCounters->{'closedtotal'} < 1 ){
		$totalclosedentries = 0;
	}

	$page .= '<br /><div class="info_box"><span class="info_title">'.
		Gm_Core::text( Gm_Constants::CPLOG_INFO_TITLE, { DATE=>$gmdate } ).'</span>';

	$page .= '<p>'.Gm_Core::text( Gm_Constants::CPLOG_INFO1, { ENTRYNUMBER=>$gmCounters->{'entrytotal'},
		ENTRYOPEN=>$gmCounters->{'opentotal'}, ENTRYCLOSED=>$totalclosedentries, 
		ENTRYARCHIVE=>$gmCounters->{'archivetotal'}, ENTRYCURRENT=>$entriesonmainnumber } ).'<BR>';

	$page .= Gm_Core::text( Gm_Constants::CPLOG_INFO2, { KARMAVOTES=>$newalltimetotalkarmavotes,
		KARMAAVERAGE=>$karmavotesonaverage, KARMAPOS=>$gmCounters->{'karmapos'}, 
		KARMANEG=>$gmCounters->{'karmaneg'}, KARMATOTAL=>$newalltimetotalkarmanumber } ).'<BR>';

	$page .= Gm_Core::text( Gm_Constants::CPLOG_INFO3, { COMMENTTOTAL=>$gmCounters->{'commenttotal'},
		COMMENTAVERAGE=>$commentspostedonaverage } ).'</p></div>';
		
	$page .= '<br /><form action="gm.cgi" method="post">'.
		'<input type="hidden" name="section" value="'.$IN{'section'}.'">'.
		Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type="submit" class="button" name="reset" style="background: #FFD0D0" '.
		'value="'.Gm_Core::text( Gm_Constants::CPLOG_RESET ).'"></form><p>';
	$page .= '<form action="gm.cgi" method="post">'.Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type=SUBMIT class="button" name="thomas" value="'.
		Gm_Core::text( Gm_Constants::RETURN_MAIN_MENU ).'" style="background: #C0C0C0"></form>';
	Gm_Web::displayAdminPageExit( $page );
	## NAVIGATION SHOULD BE DE-BUTTONED
	exit(0);
}

## Reset Cp Log
# Will reset the control panel log
# RETURNS: A message to display on the view page
sub resetCpLog {
	my $message = Gm_Constants::EMPTY;
	
	Gm_Storage::setCplog( log=>[], errHandler=>\&Gm_Web::displayAdminErrorExit );
	
	Gm_Core::writeToCplog( Gm_Core::text( Gm_Constants::CPLOG_CLEARED, { AUTHOR=>$AUTHOR{'author'} } ));
	
	$message = '<span class="status_msg">'.Gm_Core::text( Gm_Constants::CPLOG_CLEAR_CONFIRM ).'</span><p>';
	
	return $message;
}


## Ban Ip SECTION #################################################
## Handle all requests from the Ban Iplist
## and verify that author can access this section
sub doBanip {

	## Access to Banip is global, no need for granularity
	### TODO: CALL AUTH WITH FLAG TO WORK ON Banip, OR CHECK AUTHOR PERMS
	## TODO: Move this to auth, auth should return users perms, or it should take a flag to 
	# indicate which perms to check with this being handed off to a generic permDenied func
	if( $AUTHOR{'editconfigs'} ne Gm_Constants::Y ){
		Gm_Core::writeToCplog( '<span class="error_msg">'.Gm_Core::text( 
			Gm_Constants::BANIP_NO_ACCESS, { AUTHOR=>$AUTHOR{'author'} }).'</span>' );
		my $statusnote = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::BANIP_ACCESS_DENY ).
			'</span><br />';
		frontPage( $statusnote );
	}
	
	my $status = Gm_Constants::EMPTY;
# TODO, SHOULD THESE BE USING CONSTANTS?
	if( $IN{'delete'} ){
		$status = deleteBannedIp();
		
	} elsif( $IN{'add'} ){
		$status = addBannedIp();
		
	}

	viewBanList( $status );

}


## View Banned IP List
# View the list of banned IP addresses
# (opt) ARG1: Message to display to user, could be error or confirmation of action
sub viewBanList {
	my $message = shift( @_ ) || Gm_Constants::EMPTY;
	
	if( $message eq Gm_Constants::EMPTY ){ 
		$message = '<div class="info_text">'.Gm_Core::text( Gm_Constants::BANIP_INFO ).'</div>'; 
	}
	
	my $page = '<span class="section_title">'.Gm_Core::text( Gm_Constants::BANIP_TITLE ).
		"</span><br /><p>$message</p><p class=\"text_left\">\n";	
	$page .= '<FORM ACTION="gm.cgi" METHOD="post"> '.
		Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<table class="info_table"><tr><th>'.Gm_Core::text( Gm_Constants::BANIP_IP ).
		'</th><th>'.Gm_Core::text( Gm_Constants::BANIP_HOST ).'</th><th>'.
		Gm_Core::text( Gm_Constants::NAME ).'</th><th width="20%">'.
		Gm_Core::text( Gm_Constants::ACTION ).'</td></tr>';

	my $gmbanlist = Gm_Storage::getBanlist( errHandler=>\&Gm_Web::displayAdminErrorExit );

	my @banlist_array = sort { $gmbanlist->{$a}{'ip'} cmp $gmbanlist->{$b}{'ip'} } keys(%$gmbanlist);

	my $base = '?section='.$IN{'section'}.'&'.Gm_Security::getUrlAuth( author=>\%AUTHOR );
	my ($page_nav, $short_banlist ) = Gm_Web::createPaging( data=>\@banlist_array,
		baseurl=>$base, webparams=>\%IN, pagesize=>(Gm_Constants::GM_PAGE_SIZE/5) );

	my $rowcolor = Gm_Web::altRowColor();
	foreach my $gmbanlistline ( @{$short_banlist} ) {
		my ($gmbannedip, $gmbannediphost, $gmbannedperson) = 
			($gmbanlist->{$gmbanlistline}{'ip'}, $gmbanlist->{$gmbanlistline}{'host'}, 
			 $gmbanlist->{$gmbanlistline}{'label'} );
	
		$gmbannedperson =~ s/</\&lt;/g;
		$gmbannedperson =~ s/>/\&gt;/g;
		$gmbannedperson =~ s/"/\&quot;/g;
	
		$rowcolor = Gm_Web::altRowColor( $rowcolor );
		$page .= "<tr $rowcolor><td>$gmbannedip</td><td>$gmbannediphost</td><td>";
		if ($gmbannedperson ne Gm_Constants::EMPTY) { 
			$page .= " $gmbannedperson"; 
		}
		$page .= '&nbsp</td><td>'.
		'<a href="'.$ENV{SCRIPT_NAME}.'?section='.$IN{'section'}.'&delete=1&'.
		'editedbanlist='.$gmbannedip.
		'&'.Gm_Security::getUrlAuth( author=>\%AUTHOR ).
		'" class="link_button" STYLE="background: #FFD0D0">'.
		Gm_Core::text( Gm_Constants::DELETE ).'</a>'.
		'</td></tr>'."\n";
	}


	$page .= "</table><div class='pagenav'>$page_nav</div><br />\n";	
	## TODO: THESE ELEMENTS SHOULD BE REVALIDATED BEFORE DOING ANYTHING WITH, LIKE IN ADDBANIP
	$page .= '<div class="info_box"><span class="info_title">'.Gm_Core::text( Gm_Constants::BANIP_ADD_TITLE ).
		'</span><br /><table width="80%" class="form_table">'.
		'<tr><th><label for="banip">'.Gm_Core::text( Gm_Constants::BANIP_IP ).
		':</label></th><td><input type="text" value="'.$IN{'editednewbannedip'}.'"'.
		'class="inputfield" maxlength="15" name="editednewbannedip" size="15" id="banip"></td></tr>';
	$page .= '<tr><th><label for="banname">'.Gm_Core::text( Gm_Constants::BANIP_ADD_NAME ).':</label></th><td>'.
		'<input type=TEXT class="inputfield" maxlength="15" name="editednewbannedperson" '.
		'size="15" id="banname" value="'.$IN{'editednewbannedperson'}.'"></td></tr>';
	$page .= '<tr><th>&nbsp</th><td> <INPUT TYPE=HIDDEN NAME="section" VALUE="'.$IN{'section'}.'">'.
		'<input type=SUBMIT class="button" name="add" '.
		'STYLE="background: #D0FFD0" value="'.Gm_Core::text( Gm_Constants::ADD ).
		'"></td></tr></table></div></form>';
		
	$page .= '<FORM ACTION="gm.cgi" METHOD=POST> '.Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<p><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" '.
		'VALUE="'.Gm_Core::text( Gm_Constants::RETURN_MAIN_MENU ).
		'" STYLE="background: #C0C0C0"></p></FORM><br />';
	## NAVIGATION SHOULD BE DE-BUTTONED
	
	Gm_Web::displayAdminPageExit( $page );
	exit(0);
}


## Add Banned Ip
# adds a given ip to the banlist of ip's
# RETURNS: A message to display on the view page
sub addBannedIp {
	my $message = Gm_Constants::EMPTY;
	
	$IN{'editednewbannedip'} =~ s/\n//g;
	$IN{'editednewbannedip'} =~ s/\|//g;
	$IN{'editednewbannedperson'} =~ s/\n//g;
	$IN{'editednewbannedperson'} =~ s/\|//g;
	
	if ($IN{'editednewbannedip'} eq Gm_Constants::EMPTY) {
		$message = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::BANIP_ENTER_IP ).'</span>';
		viewBanList( $message );
	}

## DONE AT TOP, REMOVE
#	my $gmConfigs = Gm_Storage::getConfigs( errHandler=>\&Gm_Web::displayAdminErrorExit );	
	my $gmbanlist = Gm_Storage::getBanlist( errHandler=>\&Gm_Web::displayAdminErrorExit );
	
	foreach my $gmbanlistline ( keys(%$gmbanlist)) {
		my ($checkthisip, $checkthisiphost, $checkthisperson) = 
			($gmbanlist->{$gmbanlistline}{'ip'}, $gmbanlist->{$gmbanlistline}{'host'}, 
			 $gmbanlist->{$gmbanlistline}{'label'} );
			 
		if ($checkthisip eq $IN{'editednewbannedip'}) {
			$message = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::BANIP_DUPE_IP ).'</span>';
			viewBanList( $message );
		}
	}
	
	Gm_Storage::addBanlist( ip=>$IN{'editednewbannedip'}, host=>$IN{'editednewbannedip'}, 
		label=>$IN{'editednewbannedperson'}, errHandler=>\&Gm_Web::displayAdminErrorExit );
	
	if( $gmConfigs->{'gmkeeplog'} eq Gm_Constants::YES ){

		my $who_banned = '';
		if( $IN{'editednewbannedperson'} ne Gm_Constants::EMPTY ){ 
			$who_banned = ", \"$IN{'editednewbannedperson'}\""; 
		}
		my $cpMsg = Gm_Core::text( Gm_Constants::BANIP_ADDED, { AUTHOR=>$AUTHOR{'author'},
			IP=>$IN{'editednewbannedip'}, NAME=>$who_banned } );
		Gm_Core::writeToCplog( $cpMsg );
	}
	
	$message = '<span class="status_msg">'.Gm_Core::text( Gm_Constants::BANIP_ADD_CONFIRM, 
		{ IP=>$IN{'editednewbannedip'} } ).'</span><p>';

	## Don't need once Add is seperate screen
	$IN{'editednewbannedip'} = Gm_Constants::EMPTY;
	$IN{'editednewbannedperson'} = Gm_Constants::EMPTY;

	return( $message );
}


## Delete Banned Ip
# Delete the given ip|host combination from the banlist
# RETURNS: A message to display on the view page
sub deleteBannedIp {
	my $message = Gm_Constants::EMPTY;
	
	chomp($IN{'editedbanlist'});
	
	## Any other validation?
	if ($IN{'editedbanlist'} eq Gm_Constants::EMPTY) {
		$message = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::BANIP_SELECT_IP ).'</span>';
		viewBanList( $message );
	}

	my $banIp = $IN{'editedbanlist'};
	
	# Since ip is the primary key
	my $deleted = Gm_Storage::deleteBanlist( ip=>$banIp, errHandler=>\&Gm_Web::displayAdminErrorExit );
	my $banLabel = $deleted->{'label'} ? ", \"$deleted->{'label'}\"" : ''; 
	
	if ($gmConfigs->{'gmkeeplog'} eq Gm_Constants::YES) {
		my $cpMsg = Gm_Core::text( Gm_Constants::BANIP_DELETED, { AUTHOR=>$AUTHOR{'author'},
			IP=>$banIp, LABEL=>$banLabel } );
		
		Gm_Core::writeToCplog( $cpMsg );
	}
	
	$message = '<span class="status_msg">'.Gm_Core::text( Gm_Constants::BANIP_DELETE_CONFIRM,
		{ IP=>$banIp } ).'</span>';

	return( $message );
}


## Manage Authors SECTION #################################################
## Handle all requests for managing authors
## and verify that author can access this section
## TODO: Each author should be able to change own data, including password, so there
## should be a check that the author can edit their own info.
sub doAuthors {

	## Access to auathors is global, no need for granularity
	### TODO: CALL AUTH WITH FLAG TO WORK ON Banip, OR CHECK AUTHOR PERMS
	## TODO: Move this to auth, auth should return users perms, or it should take a flag to 
	# indicate which perms to check with this being handed off to a generic permDenied func
	if( $AUTHOR{'editauthors'} ne Gm_Constants::Y ){
		Gm_Core::writeToCplog( '<span class="error_msg">'.Gm_Core::text( 
			Gm_Constants::AUTHORS_NO_ACCESS, { AUTHOR=>$AUTHOR{'author'} }).'</span>' );
		my $statusnote = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_ACCESS_DENY ).
			'</span><br />';
		frontPage( $statusnote );
	}
	
	my $status = Gm_Constants::EMPTY;
# TODO, SHOULD THESE BE USING CONSTANTS?
	if( $IN{'delete'} ){
		$status = deleteAuthor();
		
	} elsif( $IN{'add'} ){
		$status = addAuthor();
		
	} elsif( $IN{'view'} ){
		$status = viewAuthor();
		
	} elsif( $IN{'update'} ){
		## TODO:  ADD IS SAME AS UPDATE, EXCEPT FROM SCRATCH?
		$status = updateAuthor();
		
	}

	viewAuthorList( $status );

}


## View Author List
# View the list authors registerd with Gm
# (opt) ARG1: Message to display to user, could be error or confirmation of action
sub viewAuthorList {
	my $message = shift( @_ ) || Gm_Constants::EMPTY;
	
	if( $message eq Gm_Constants::EMPTY ){ 
		$message = '<span class="info_text">'.Gm_Core::text( Gm_Constants::AUTHORS_INFO ).'</span>'; 
	}

	my $page = '<span class="section_title">'.Gm_Core::text( Gm_Constants::AUTHORS_TITLE ).
		"</span><br /><p>$message</p>\n";	
	$page .= '<FORM ACTION="gm.cgi" METHOD="post"> '.
		Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<table class="info_table"><tr><th>'.
		Gm_Core::text( Gm_Constants::NAME ).'</th><th>'.
		Gm_Core::text( Gm_Constants::AUTHORS_EMAIL ).'</th><th>'.
		Gm_Core::text( Gm_Constants::AUTHORS_HOMEPAGE ).'</th><th>'.
		Gm_Core::text( Gm_Constants::AUTHORS_PRIVS ).'</th><th width="30%">'.
		Gm_Core::text( Gm_Constants::ACTION ).'</td></tr>';

	my $gmauthors = Gm_Storage::getAuthors( errHandler=>\&Gm_Web::displayAdminErrorExit );

	my @authors_array = sort { $gmauthors->{$a}{'author'} cmp $gmauthors->{$b}{'author'} } keys( %$gmauthors );
	my $alicewarning = Gm_Constants::EMPTY;

	my $base = '?section='.$IN{'section'}.'&'.Gm_Security::getUrlAuth( author=>\%AUTHOR );
	my ($page_nav, $short_authorslist ) = Gm_Web::createPaging( data=>\@authors_array,
		baseurl=>$base, webparams=>\%IN, pagesize=>(Gm_Constants::GM_PAGE_SIZE/5) );

	my $rowcolor = Gm_Web::altRowColor();
	foreach my $authorListLine ( @{$short_authorslist} ) {
		my ( $author, $password, $email, $homepage, $postnew, $editentries, $editconfigs, 
			$edittemplates, $editauthors, $rebuild, $viewcplog, $bookmarklets, $upload, 
			$viewadmin ) = ( $gmauthors->{$authorListLine}{'author'}, 
			$gmauthors->{$authorListLine}{'password'}, $gmauthors->{$authorListLine}{'email'},
			$gmauthors->{$authorListLine}{'homepage'}, $gmauthors->{$authorListLine}{'postnew'},
			$gmauthors->{$authorListLine}{'editentries'}, $gmauthors->{$authorListLine}{'editconfigs'}, 
			$gmauthors->{$authorListLine}{'edittemplates'}, $gmauthors->{$authorListLine}{'editauthors'}, 
			$gmauthors->{$authorListLine}{'rebuild'}, $gmauthors->{$authorListLine}{'viewcplog'}, 
			$gmauthors->{$authorListLine}{'bookmarklets'}, $gmauthors->{$authorListLine}{'upload'}, 
			$gmauthors->{$authorListLine}{'viewadmin'});
	
		if ( $author eq 'Alice' && ($password eq 'wonderland' || $password eq 'woCCASD0Wk0IA') ){
			$alicewarning = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_ALICE_ALERT ).
			'</span><br />';
		}
	
		$author =~ s/</\&lt;/g;
		$author =~ s/>/\&gt;/g;
		$author =~ s/"/\&quot;/g;
	
		$rowcolor = Gm_Web::altRowColor( $rowcolor );
		
		$page .= "<tr $rowcolor><td>$author</td><td>$email</td><td>$homepage</td>";
		
		## figuring privilages
		my $privs = Gm_Core::text( Gm_Constants::AUTHORS_CUSTOM_ACCESS );
		if( $postnew eq Gm_Constants::Y && $editentries eq Gm_Constants::Y && 
			$editconfigs eq Gm_Constants::Y && $edittemplates eq Gm_Constants::Y && 
			$editauthors eq Gm_Constants::Y && $rebuild eq Gm_Constants::Y && 
			$viewcplog eq Gm_Constants::Y && $bookmarklets eq Gm_Constants::Y && 
			$upload eq Gm_Constants::Y && $viewadmin eq Gm_Constants::Y ){
			$privs = Gm_Core::text( Gm_Constants::AUTHORS_ALL_ACCESS );
			
		} elsif( $postnew eq Gm_Constants::Y && $editentries eq 'O' && 
			$editconfigs eq Gm_Constants::N && $edittemplates eq Gm_Constants::N && 
			$editauthors eq Gm_Constants::N && $rebuild eq Gm_Constants::N && 
			$viewcplog eq Gm_Constants::N && $bookmarklets eq Gm_Constants::Y && 
			$upload eq Gm_Constants::N && $viewadmin eq Gm_Constants::Y ){
			$privs = Gm_Core::text( Gm_Constants::AUTHORS_OWN_SHORT );
			
		} elsif( $postnew eq Gm_Constants::N && $editentries eq Gm_Constants::N && 
			$editconfigs eq Gm_Constants::N && $edittemplates eq Gm_Constants::N && 
			$editauthors eq Gm_Constants::N && $rebuild eq Gm_Constants::N && 
			$viewcplog eq Gm_Constants::N && $bookmarklets eq Gm_Constants::N && 
			$upload eq Gm_Constants::N && $viewadmin eq Gm_Constants::N ){
			$privs = Gm_Core::text( Gm_Constants::AUTHORS_NO_ACCESS );
			
		}
		$page .= "<td>$privs</td><td>\n";
		
		## Edit, Delete buttons
		$page .= '<a href="'.$ENV{SCRIPT_NAME}.'?section='.$IN{'section'}.'&delete=1&'.
		'selectedauthor='.$author.
		'&'.Gm_Security::getUrlAuth( author=>\%AUTHOR ).
		'" class="link_button" STYLE="background: #FFD0D0">'.
		Gm_Core::text( Gm_Constants::DELETE ).'</a>';
		
		$page .= ' &#160; <a href="'.$ENV{SCRIPT_NAME}.'?section='.$IN{'section'}.'&view=1&'.
		'selectedauthor='.$author.
		'&'.Gm_Security::getUrlAuth( author=>\%AUTHOR ).
		'" class="link_button" STYLE="background: #D0FFD0">'.
		Gm_Core::text( Gm_Constants::EDIT ).'</a>';
		
		$page .= '</td></tr>'."\n";
	}


	$page .= "</table><div class='pagenav'>$page_nav</div><br />\n";	
	$page .= "<p>$alicewarning</p>\n";
	
	## TODO: THESE ELEMENTS SHOULD BE REVALIDATED BEFORE DOING ANYTHING WITH
	
	$page .= '<div class="info_box"><span class="info_title">'.Gm_Core::text( Gm_Constants::AUTHORS_ADD_TITLE ).
		'</span><p>'.Gm_Core::text( Gm_Constants::AUTHORS_ADD_INFO ).'</p>';

	$page .= '<table width="80%" class="form_table">'.
		'<tr><th><label for="name">'.Gm_Core::text( Gm_Constants::NAME ).':</label></th>'.
		'<td><input type="text" class="inputfield" maxlength="25" name="newauthorname" size="15" '.
		'id="name" value="'.$IN{'newauthorname'}.'"></td></tr>';
	$page .= '<tr><th><label for="pw">'.Gm_Core::text( Gm_Constants::PW ).':</label></th>'.
		'<td><input type="text" class="inputfield" maxlength="25" name="newauthorpassword" size="15" '.
		'id="pw" value="'.$IN{'newauthorpassword'}.'"></td></tr>';
	$page .= '<tr><th><label for="email">'.Gm_Core::text( Gm_Constants::AUTHORS_EMAIL ).':</label></th>'.
		'<td><input type="text" class="inputfield" maxlength="30" name="newauthoremail" size="15" '.
		'id="email" value="'.$IN{'newauthoremail'}.'"></td></tr>';
	unless( $IN{'newauthorhomepage'} ){ ## setting default value
		$IN{'newauthorhomepage'} = 'http://';
	}
	$page .= '<tr><th><label for="homepage">'.Gm_Core::text( Gm_Constants::AUTHORS_HOMEPAGE ).':</label></th>'.
		'<td><input type="text" class="inputfield" maxlength="30" name="newauthorhomepage" size="15" '.
		'id="homepage" value="'.$IN{'newauthorhomepage'}.'"></td></tr>';		
	
	unless( $IN{'newauthoraccess'} ){
		$IN{'newauthoraccess'} = 'all';
	}
	$page .= '<tr><th>'.Gm_Core::text( Gm_Constants::AUTHORS_DEF_ACCESS ).':</th>'.
		'<td>'.Gm_Web::createRadioButton( name=>'newauthoraccess', value=>'all', id=>'all_access',
		checked=>$IN{'newauthoraccess'} ).
		'<label for="all_access">'.Gm_Core::text( Gm_Constants::AUTHORS_ALL_ACCESS ).'</label>&#160; '.
		Gm_Web::createRadioButton( name=>'newauthoraccess', value=>'none', id=>'no_access',
		checked=>$IN{'newauthoraccess'} ).
		'<label for="no_access">'.Gm_Core::text( Gm_Constants::AUTHORS_NO_ACCESS ).'</label><br /> '.
		Gm_Web::createRadioButton( name=>'newauthoraccess', value=>'postedit', id=>'own_access',
		checked=>$IN{'newauthoraccess'} ).
		'<label for="own_access">'.Gm_Core::text( Gm_Constants::AUTHORS_OWN_ACCESS ).'</label>'.
		'</td></tr>';		
		
	$page .= '<tr><th>&nbsp</th><td><INPUT TYPE=HIDDEN NAME="section" VALUE="'.$IN{'section'}.'">'.
		'<input type=SUBMIT class="button" name="add" '.
		'STYLE="background: #D0FFD0" value="'.Gm_Core::text( Gm_Constants::ADD ).
		'"></td></tr></table></div></form>';
		
	$page .= '<FORM ACTION="gm.cgi" METHOD=POST> '.Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<p><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" '.
		'VALUE="'.Gm_Core::text( Gm_Constants::RETURN_MAIN_MENU ).
		'" STYLE="background: #C0C0C0"></p></FORM><br />';
	## NAVIGATION SHOULD BE DE-BUTTONED
	
	Gm_Web::displayAdminPageExit( $page );
	exit(0);
}


## Add Author
# adds a given author to Greymatter's registered authors list
# RETURNS: A message to display on the view page
## NOTE: should part of this be generized and put in Core?  Something that doesn't presume where its being
# called from so it can be reused with normal user self-registration?
# ALSO:  can this and updateAuthor be abstracted to reduce duplicate error checking?
sub addAuthor {
	my $message = Gm_Constants::EMPTY;

	if( ($IN{'newauthorname'} eq Gm_Constants::EMPTY) || 
		($IN{'newauthorpassword'} eq Gm_Constants::EMPTY) ){
		$message = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_ENTER_NAME_PW ).'</span>';

		## should this be return?  we are limiting its use to just on web, specically author page.  Make this function generic so users can register?
		viewAuthorList( $message ); 
	}

	if( ($IN{'newauthorname'} =~ /^\s+/) || ($IN{'newauthorpassword'} =~ /^\s+/) || 
		($IN{'newauthorname'} =~ /\s+$/) || ($IN{'newauthorpassword'} =~ /\s+$/) ) {
		$message = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_NOWS_NAME_PW ).'</span>';
		viewAuthorList( $message );
	}

	## We are removing spaces temporily, so that we can use perl regex shorthand 
	$IN{'newauthorname'} =~ s/ /THISISASPACE/g;
	$IN{'newauthorpassword'} =~ s/ /THISISASPACE/g;
	
	if (($IN{'newauthorname'} =~ /\W/) || ($IN{'newauthorpassword'} =~ /\W/)) {
		$message = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_BAD_NAME_PW ).'</span>';
		viewAuthorList( $message );
	}
	## Now we are restoring to proper form
	$IN{'newauthorname'} =~ s/THISISASPACE/ /g;
	$IN{'newauthorpassword'} =~ s/THISISASPACE/ /g;

	$IN{'newauthoremail'} = Gm_Utils::trimFrontWs( $IN{'newauthoremail'} );
	$IN{'newauthoremail'} = Gm_Utils::trimBackWs( $IN{'newauthoremail'} );
	$IN{'newauthorhomepage'} = Gm_Utils::trimFrontWs( $IN{'newauthorhomepage'} );
	$IN{'newauthorhomepage'} = Gm_Utils::trimBackWs( $IN{'newauthorhomepage'} );

	my $gmauthors = Gm_Storage::getAuthors( errHandler=>\&Gm_Web::displayAdminErrorExit );

	## just checking if author name exisits, note this works because of keys we are using
	# would have to change if we made keys a numeric id or something (but name better be unique)
	if ( exists( $gmauthors->{$IN{'newauthorname'}}) ) {
		my $cpMsg = Gm_Core::text( Gm_Constants::AUTHORS_DUPE_LOG, { AUTHOR=>$AUTHOR{'author'},
			NAME=>$IN{'newauthorname'} } );
		Gm_Core::writeToCplog( $cpMsg );
		
		$message = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_DUPE_NAME ).'</span>';
		viewAuthorList( $message );
	}

	## old code failed to account for https urls
	if( $IN{'newauthorhomepage'} !~ m/^http/i ){ 
		# If it doesn't start with http, lets add it for them
		$IN{'newauthorhomepage'} = "http://$IN{'newauthorhomepage'}"; 
	}

	## default was unchanged, so we just leave as blank
	if( $IN{'newauthorhomepage'} eq 'http://' ){ 
		$IN{'newauthorhomepage'} = Gm_Constants::EMPTY; 
	}

	my ($skip, $wday, $mon, $mday, $JSYear, $hour, $min, $sec, $AMPM ) = 
		Gm_Utils::getStdDate( $gmConfigs->{'gmserveroffset'} );
	my $montwo = Gm_Utils::toTwoDigit( $mon );
	my $mdaytwo = Gm_Utils::toTwoDigit( $mday );
	# TODO STANDARDIZE HOW DATES ARE STORED (WITH LEADING 0 OR NOT)

	## This should be abstracted out to security, such as setAuthorCredentials
	## Also, authors should have a field, credential id, that is a unique identifier
	# that is determined by Gm_Security
	$IN{'newauthorpassword'} = crypt($IN{'newauthorpassword'}, time());

	my %newAuthor = ();
	$newAuthor{'author'} = $IN{'newauthorname'};
	$newAuthor{'password'} = $IN{'newauthorpassword'};
	$newAuthor{'email'} = $IN{'newauthoremail'};
	$newAuthor{'homepage'} = $IN{'newauthorhomepage'};
	$newAuthor{'created'} = "$montwo\/$mdaytwo\/$JSYear";
	$newAuthor{'posttotal'} = '0';

	if ($IN{'newauthoraccess'} eq Gm_Constants::ALL) {
		$newAuthor{'postnew'} = Gm_Constants::Y;
		$newAuthor{'editentries'} = Gm_Constants::Y;
		$newAuthor{'editconfigs'} = Gm_Constants::Y;
		$newAuthor{'edittemplates'} = Gm_Constants::Y;
		$newAuthor{'editauthors'} = Gm_Constants::Y;
		$newAuthor{'rebuild'} = Gm_Constants::Y;
		$newAuthor{'viewcplog'} = Gm_Constants::Y;
		$newAuthor{'bookmarklets'} = Gm_Constants::Y;
		$newAuthor{'upload'} = Gm_Constants::Y;
		$newAuthor{'viewadmin'} = Gm_Constants::Y;
	} elsif ($IN{'newauthoraccess'} eq 'postedit') {
		# Some perms
		$newAuthor{'postnew'} = Gm_Constants::Y;
		$newAuthor{'editentries'} = 'O';
		$newAuthor{'editconfigs'} = Gm_Constants::N;
		$newAuthor{'edittemplates'} = Gm_Constants::N;
		$newAuthor{'editauthors'} = Gm_Constants::N;
		$newAuthor{'rebuild'} = Gm_Constants::N;
		$newAuthor{'viewcplog'} = Gm_Constants::N;
		$newAuthor{'bookmarklets'} = Gm_Constants::Y;
		$newAuthor{'upload'} = Gm_Constants::N;
		$newAuthor{'viewadmin'} = Gm_Constants::Y;
	} else {
		# No perms
		$newAuthor{'postnew'} = Gm_Constants::N;
		$newAuthor{'editentries'} = Gm_Constants::N;
		$newAuthor{'editconfigs'} = Gm_Constants::N;
		$newAuthor{'edittemplates'} = Gm_Constants::N;
		$newAuthor{'editauthors'} = Gm_Constants::N;
		$newAuthor{'rebuild'} = Gm_Constants::N;
		$newAuthor{'viewcplog'} = Gm_Constants::N;
		$newAuthor{'bookmarklets'} = Gm_Constants::N;
		$newAuthor{'upload'} = Gm_Constants::N;
		$newAuthor{'viewadmin'} = Gm_Constants::N;
	}

	Gm_Storage::addAuthor( %newAuthor, errHandler=>\&Gm_Web::displayAdminErrorExit );

	Gm_Core::writeToCplog( Gm_Core::text( Gm_Constants::AUTHORS_ADD_LOG, { AUTHOR=>$AUTHOR{'author'},
		NAME=>$IN{'newauthorname'} } ) );

	$message = '<span class="status_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_ADD_CONFIRM, 
	{ NAME=>$IN{'newauthorname'} } ).'</span><p>';

	$IN{'newauthorname'} = Gm_Constants::EMPTY;
	$IN{'newauthorpassword'} = Gm_Constants::EMPTY;
	$IN{'newauthoremail'} = Gm_Constants::EMPTY;
	$IN{'newauthorhomepage'} = Gm_Constants::EMPTY;

	## we are just adding, no control flow
	return( $message );
}


## Delete Author
# Delete the given author from the list of authors
# RETURNS: A message to display on the view page
sub deleteAuthor {
	my $message = Gm_Constants::EMPTY;

	my $gmauthors = Gm_Storage::getAuthors( errHandler=>\&Gm_Web::displayAdminErrorExit );

	if( !defined( $IN{'selectedauthor'} ) || !exists( $gmauthors->{$IN{'selectedauthor'}}) ){
		$message = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_SELECT_NAME ).'</span>';
		viewAuthorList( $message );
	}

	if( scalar( keys(%$gmauthors)) == 1 ){
		$message = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_NO_DELETE ).'</span>';
		viewAuthorList( $message );
	}

	Gm_Storage::deleteAuthor( author=>$IN{'selectedauthor'}, errHandler=>\&Gm_Web::displayAdminErrorExit );

	Gm_Core::writeToCplog( Gm_Core::text( Gm_Constants::AUTHORS_DELETE_LOG, { AUTHOR=>$AUTHOR{'author'},
		NAME=>$IN{'selectedauthor'} } ) );

	if( $IN{'selectedauthor'} eq $AUTHOR{'author'} ){
		%AUTHOR = %{ Gm_Security::auth( webparams=>\%IN, reauth=>1,
			errHandler=>\&Gm_Web::displayAdminErrorExit ) };
	} else {
		$message = '<span class="status_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_DELETE_CONFIRM, 
			{ NAME=>$IN{'selectedauthor'} }  ).'</span>';
		viewAuthorList( $message );
	}

}


## View Author
# Edit a particular author
# (opt) ARG1: Message to display to user, could be error or confirmation of action
sub viewAuthor {
	my $message = shift( @_ ) || Gm_Constants::EMPTY;

	my $gmauthors = Gm_Storage::getAuthors( errHandler=>\&Gm_Web::displayAdminErrorExit );

	if ( !defined( $IN{'selectedauthor'} ) || !exists( $gmauthors->{$IN{'selectedauthor'}}) ) {
		$message = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_SELECT_NAME ).'</span>';
		viewAuthorList( $message );
	}

	my $selectedauthor = $gmauthors->{$IN{'selectedauthor'}};

	if( $selectedauthor->{'homepage'} eq Gm_Constants::EMPTY ){ 
		$selectedauthor->{'homepage'} = "http://"; 
	}

	if( $message eq Gm_Constants::EMPTY ){ 
		$message = '<span class="info_text">'.Gm_Core::text( Gm_Constants::AUTHORS_STATS, 
			{ CREATED=>$selectedauthor->{'created'}, ENTRIES=>$selectedauthor->{'posttotal'} } ).'</span>'; 
	} 
	
	my $page = '<span class="section_title">'.Gm_Core::text( Gm_Constants::AUTHORS_EDIT_TITLE, 
			{ AUTHOR=>$selectedauthor->{'author'} } )."</span><br /><p>$message</p>\n";	
			
	$page .= '<form action="gm.cgi" method="post"> '.
		Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type="hidden" name="selectedauthor" value="'.$selectedauthor->{'author'}."\">\n";
		
# 		'<input type="hidden" name="authororiginalpassword" value="'.$selectedauthor->{'password'}."\">\n".
# 		'<input type="hidden" name="authororiginaldate" value="'.$selectedauthor->{'created'}."\">\n".
# 		'<input type="hidden" name="authororiginalentries" value="'.$selectedauthor->{'posttotal'}."\">\n".
# 		'<input type="hidden" name="editedauthornumber" value="'.$selectedauthor->{'author'}."\">\n";

	my $authorName =  defined( $IN{'editedname'} ) ? 
		$IN{'editedname'} : $selectedauthor->{'author'};
	my $authorPassword =  defined( $IN{'editedpassword'} ) ? 
		$IN{'editedpassword'} : $selectedauthor->{'password'};
	my $authorEmail =  defined( $IN{'editedemail'} ) ? 
		$IN{'editedemail'} : $selectedauthor->{'email'};
	my $authorHomepage =  defined( $IN{'editedhomepage'} ) ? 
		$IN{'editedhomepage'} : $selectedauthor->{'homepage'};

	$page .= '<table width="80%" class="form_table">'.
		'<tr><th><label for="name">'.Gm_Core::text( Gm_Constants::NAME ).':</label></th>'.
		'<td><input type="text" class="inputfield" maxlength="25" name="editedname" size="15" '.
		'id="name" value="'.$authorName.'"></td></tr>';
	$page .= '<tr><th><label for="pw">'.Gm_Core::text( Gm_Constants::PW ).':</label></th>'.
		'<td><input type="password" class="inputfield" maxlength="25" name="editedpassword" size="15" '.
		'id="pw" value="'.$authorPassword.'"></td></tr>';
	$page .= '<tr><th><label for="email">'.Gm_Core::text( Gm_Constants::AUTHORS_EMAIL ).':</label></th>'.
		'<td><input type="text" class="inputfield" maxlength="30" name="editedemail" size="15" '.
		'id="email" value="'.$authorEmail.'"></td></tr>';
	unless( $authorHomepage ){ ## setting default value
		$authorHomepage = 'http://';
	}
	$page .= '<tr><th><label for="homepage">'.Gm_Core::text( Gm_Constants::AUTHORS_HOMEPAGE ).':</label></th>'.
		'<td><input type="text" class="inputfield" maxlength="30" name="editedhomepage" size="15" '.
		'id="homepage" value="'.$authorHomepage.'"></td></tr>';		

	my $authorPostnew =  defined( $IN{'editedentryaccess'} ) ? 
		$IN{'editedentryaccess'} : $selectedauthor->{'postnew'};
	my $authorEditEntry =  defined( $IN{'editedentryeditaccess'} ) ? 
		$IN{'editedentryeditaccess'} : $selectedauthor->{'editentries'};
	my $authorConfigure =  defined( $IN{'editedconfigureaccess'} ) ? 
		$IN{'editedconfigureaccess'} : $selectedauthor->{'editconfigs'};
	my $authorTemplates =  defined( $IN{'editedtemplateaccess'} ) ? 
		$IN{'editedtemplateaccess'} : $selectedauthor->{'edittemplates'};
	my $authorAuthors =  defined( $IN{'editedauthoraccess'} ) ? 
		$IN{'editedauthoraccess'} : $selectedauthor->{'editauthors'};
	my $authorRebuild =  defined( $IN{'editedrebuildaccess'} ) ? 
		$IN{'editedrebuildaccess'} : $selectedauthor->{'rebuild'};
	my $authorCplog =  defined( $IN{'editedcplogaccess'} ) ? 
		$IN{'editedcplogaccess'} : $selectedauthor->{'viewcplog'};
	my $authorBookmark =  defined( $IN{'editedbookmarkletaccess'} ) ? 
		$IN{'editedbookmarkletaccess'} : $selectedauthor->{'bookmarklets'};
	my $authorUpload =  defined( $IN{'editeduploadaccess'} ) ? 
		$IN{'editeduploadaccess'} : $selectedauthor->{'upload'};
	my $authorLogin =  defined( $IN{'editedloginaccess'} ) ? 
		$IN{'editedloginaccess'} : $selectedauthor->{'viewadmin'};


	$page .= '<tr class="form_long"><th>'.Gm_Core::text( Gm_Constants::AUTHORS_CAN_POST ).'</th>'.
		'<td>'.Gm_Web::createRadioButton( name=>'editedentryaccess', value=>'Y', id=>'new_entries_yes',
		checked=>$authorPostnew ).
		'<label for="new_entries_yes">'.Gm_Core::text( Gm_Constants::YES ).'</label>&#160; '.
		Gm_Web::createRadioButton( name=>'editedentryaccess', value=>'N', id=>'new_entries_no',
		checked=>$authorPostnew ).
		'<label for="new_entries_no">'.Gm_Core::text( Gm_Constants::NO ).'</label>'.
		'</td></tr>';	

	$page .= '<tr class="form_long"><th>'.Gm_Core::text( Gm_Constants::AUTHORS_CAN_EDIT ).'</th>'.
		'<td>'.Gm_Web::createRadioButton( name=>'editedentryeditaccess', value=>'Y', id=>'edit_entries_yes',
		checked=>$authorEditEntry ).
		'<label for="edit_entries_yes">'.Gm_Core::text( Gm_Constants::YES ).'</label>&#160; '.
		Gm_Web::createRadioButton( name=>'editedentryeditaccess', value=>'N', id=>'edit_entries_no',
		checked=>$authorEditEntry ).
		'<label for="edit_entries_no">'.Gm_Core::text( Gm_Constants::NO ).'</label><br /> '.
		Gm_Web::createRadioButton( name=>'editedentryeditaccess', value=>'O', id=>'edit_entries_own',
		checked=>$authorEditEntry ).
		'<label for="edit_entries_own">'.Gm_Core::text( Gm_Constants::AUTHORS_ONLY_OWN ).'</label>'.
		'</td></tr>';	

	$page .= '<tr class="form_long"><th>'.Gm_Core::text( Gm_Constants::AUTHORS_CAN_CONFIG ).'</th>'.
		'<td>'.Gm_Web::createRadioButton( name=>'editedconfigureaccess', value=>'Y', id=>'configure_yes',
		checked=>$authorConfigure ).
		'<label for="configure_yes">'.Gm_Core::text( Gm_Constants::YES ).'</label>&#160; '.
		Gm_Web::createRadioButton( name=>'editedconfigureaccess', value=>'N', id=>'configure_no',
		checked=>$authorConfigure ).
		'<label for="configure_no">'.Gm_Core::text( Gm_Constants::NO ).'</label>'.
		'</td></tr>';	

	$page .= '<tr class="form_long"><th>'.Gm_Core::text( Gm_Constants::AUTHORS_CAN_TEMPLATES ).'</th>'.
		'<td>'.Gm_Web::createRadioButton( name=>'editedtemplateaccess', value=>'Y', id=>'edit_templates_yes',
		checked=>$authorTemplates ).
		'<label for="edit_templates_yes">'.Gm_Core::text( Gm_Constants::YES ).'</label>&#160; '.
		Gm_Web::createRadioButton( name=>'editedtemplateaccess', value=>'N', id=>'edit_templates_no',
		checked=>$authorTemplates ).
		'<label for="edit_templates_no">'.Gm_Core::text( Gm_Constants::NO ).'</label><br /> '.
		Gm_Web::createRadioButton( name=>'editedtemplateaccess', value=>'O', id=>'edit_templates_own',
		checked=>$authorTemplates ).
		'<label for="edit_templates_own">'.Gm_Core::text( Gm_Constants::AUTHORS_ONLY_HEAD ).'</label>'.
		'</td></tr>';	

	$page .= '<tr class="form_long"><th>'.Gm_Core::text( Gm_Constants::AUTHORS_CAN_AUTHORS ).'</th>'.
		'<td>'.Gm_Web::createRadioButton( name=>'editedauthoraccess', value=>'Y', id=>'edit_author_yes',
		checked=>$authorAuthors ).
		'<label for="edit_author_yes">'.Gm_Core::text( Gm_Constants::YES ).'</label>&#160; '.
		Gm_Web::createRadioButton( name=>'editedauthoraccess', value=>'N', id=>'edit_author_no',
		checked=>$authorAuthors ).
		'<label for="edit_author_no">'.Gm_Core::text( Gm_Constants::NO ).'</label>'.
		'</td></tr>';	

	$page .= '<tr class="form_long"><th>'.Gm_Core::text( Gm_Constants::AUTHORS_CAN_REBUILD ).'</th>'.
		'<td>'.Gm_Web::createRadioButton( name=>'editedrebuildaccess', value=>'Y', id=>'rebuild_yes',
		checked=>$authorRebuild ).
		'<label for="rebuild_yes">'.Gm_Core::text( Gm_Constants::YES ).'</label>&#160; '.
		Gm_Web::createRadioButton( name=>'editedrebuildaccess', value=>'N', id=>'rebuild_no',
		checked=>$authorRebuild ).
		'<label for="rebuild_no">'.Gm_Core::text( Gm_Constants::NO ).'</label>'.
		'</td></tr>';	

	$page .= '<tr class="form_long"><th>'.Gm_Core::text( Gm_Constants::AUTHORS_CAN_CPLOG ).'</th>'.
		'<td>'.Gm_Web::createRadioButton( name=>'editedcplogaccess', value=>'Y', id=>'view_cplog_yes',
		checked=>$authorCplog ).
		'<label for="view_cplog_yes">'.Gm_Core::text( Gm_Constants::YES ).'</label>&#160; '.
		Gm_Web::createRadioButton( name=>'editedcplogaccess', value=>'N', id=>'view_cplog_no',
		checked=>$authorCplog ).
		'<label for="view_cplog_no">'.Gm_Core::text( Gm_Constants::NO ).'</label>'.
		'</td></tr>';

	## TODO: THIS SHOULD BE SAME AS POST ENTRIES, JUST DIFFERENT METHOD, WHY TWO PERMS
	$page .= '<tr class="form_long"><th>'.Gm_Core::text( Gm_Constants::AUTHORS_CAN_BM ).'</th>'.
		'<td>'.Gm_Web::createRadioButton( name=>'editedbookmarkletaccess', value=>'Y', id=>'bookmarklets_yes',
		checked=>$authorBookmark ).
		'<label for="bookmarklets_yes">'.Gm_Core::text( Gm_Constants::YES ).'</label>&#160; '.
		Gm_Web::createRadioButton( name=>'editedbookmarkletaccess', value=>'N', id=>'bookmarklets_no',
		checked=>$authorBookmark ).
		'<label for="bookmarklets_no">'.Gm_Core::text( Gm_Constants::NO ).'</label>'.
		'</td></tr>';

	$page .= '<tr class="form_long"><th>'.Gm_Core::text( Gm_Constants::AUTHORS_CAN_UPLOAD ).'</th>'.
		'<td>'.Gm_Web::createRadioButton( name=>'editeduploadaccess', value=>'Y', id=>'upload_yes',
		checked=>$authorUpload ).
		'<label for="upload_yes">'.Gm_Core::text( Gm_Constants::YES ).'</label>&#160; '.
		Gm_Web::createRadioButton( name=>'editeduploadaccess', value=>'N', id=>'upload_no',
		checked=>$authorUpload ).
		'<label for="upload_no">'.Gm_Core::text( Gm_Constants::NO ).'</label>'.
		'</td></tr>';

	$page .= '<tr><th>'.Gm_Core::text( Gm_Constants::AUTHORS_CAN_LOGIN ).'</th>'.
		'<td>'.Gm_Web::createRadioButton( name=>'editedloginaccess', value=>'Y', id=>'view_admin_yes',
		checked=>$authorLogin ).
		'<label for="view_admin_yes">'.Gm_Core::text( Gm_Constants::YES ).'</label>&#160; '.
		Gm_Web::createRadioButton( name=>'editedloginaccess', value=>'N', id=>'view_admin_no',
		checked=>$authorLogin ).
		'<label for="view_admin_no">'.Gm_Core::text( Gm_Constants::NO ).'</label>'.
		'</td></tr>';

	$page .= '<tr><th>&nbsp</th><td><INPUT TYPE=HIDDEN NAME="section" VALUE="'.$IN{'section'}.'">'.
		'<input type="submit" class="button" name="update" '.
		'style="background: #D0FFD0" value="'.Gm_Core::text( Gm_Constants::AUTHORS_SAVE_CHANGES ).
		'"></td></tr></table><br /></form>';
		
	$page .= '<FORM ACTION="gm.cgi" METHOD=POST> '.Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<p><input type="submit" class="button" name="authors" '.
		'value="Return To Author Panel"></p>';
		
	$page .= '<p><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" '.
		'value="'.Gm_Core::text( Gm_Constants::RETURN_MAIN_MENU ).
		'" style="background: #C0C0C0"></p></FORM><br />';
	## NAVIGATION SHOULD BE DE-BUTTONED
	
	Gm_Web::displayAdminPageExit( $page );
	exit(0);

}


## Update Author
# updates a given author
# RETURNS: A message to display on the view page
## NOTE: should part of this be generized and put in Core?  Something that doesn't presume where its being
# called from so it can be reused with normal user self-registration?
# ALSO:  can this and addAuthor be abstracted to reduce duplicate error checking?
sub updateAuthor {
	my $message = Gm_Constants::EMPTY;

	$IN{'editedname'} =~ s/\|//g;
	$IN{'editedpassword'} =~ s/\|//g;
	$IN{'editedemail'} =~ s/\|//g;
	$IN{'editedhomepage'} =~ s/\|//g;

	$IN{'editedname'} = Gm_Utils::trimFrontWs( $IN{'editedname'} );
	$IN{'editedname'} = Gm_Utils::trimBackWs( $IN{'editedname'} );
	$IN{'editedpassword'} = Gm_Utils::trimFrontWs( $IN{'editedpassword'} );
	$IN{'editedpassword'} = Gm_Utils::trimBackWs( $IN{'editedpassword'} );

## TODO: NAME AND PASSWORD REQUIREMENTS SHOULD BE SAME AS WHEN ADDING, ALSO, LET SOME NON-ALPHANUMS FOR PW

	if (($IN{'editedname'} eq Gm_Constants::EMPTY) || ($IN{'editedpassword'} eq Gm_Constants::EMPTY)) {

		## TODO: we should be returning this in a hash { error=>@arry of errors, msg=>@array of messages)
		# then can decide if get errors back, whether to goto list or single view
		$message = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_ENTER_NAME_PW ).'</span>';
		viewAuthor( $message );
	}

	my $gmauthors = Gm_Storage::getAuthors( errHandler=>\&Gm_Web::displayAdminErrorExit );

	if( ($IN{'selectedauthor'} ne $IN{'editedname'}) && 
			( exists( $gmauthors->{$IN{'editedname'}} )) ){ 

		my $cpMsg = Gm_Core::text( Gm_Constants::AUTHORS_OVERWRITE_LOG, { AUTHOR=>$AUTHOR{'author'}, 
			NEWNAME=>$IN{'editedname'}, NAME=>$IN{'selectedauthor'} } );
		Gm_Core::writeToCplog( $cpMsg );
		$message = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_OVERWRITE_NAME ).'</span>';
		viewAuthor( $message );
	}


# TODO: THIS IN{AUTHORNAME} SHOULD BE AUTHOR{NAME} OR SOMETHING

	if( ($IN{'editedname'} ne $IN{'selectedauthor'}) ){
		Gm_Core::writeToCplog( Gm_Core::text( Gm_Constants::AUTHORS_NEWNAME_LOG, { AUTHOR=>$AUTHOR{'author'}, 
			NEWNAME=>$IN{'editedname'}, NAME=>$IN{'selectedauthor'} } ) );
	}

	if( $IN{'editedhomepage'} !~ m/^http/i ){ 
		# If it doesn't start with http, lets add it for them
		$IN{'editedhomepage'} = "http://$IN{'editedhomepage'}"; 
	}
	if( $IN{'editedhomepage'} eq 'http://' ){ 
		$IN{'editedhomepage'} = Gm_Constants::EMPTY; 
	}

	my $selectedauthor = $gmauthors->{$IN{'selectedauthor'}};
	my %updatedInfo = ();

	if( $IN{'editedname'} ne $selectedauthor->{'author'}){
		$updatedInfo{'author'} = $IN{'editedname'};
	}

	if( $IN{'editedpassword'} ne $selectedauthor->{'password'}){
		## TODO: THIS SHOULD BE A SECURITY FUNCTION.  
		$updatedInfo{'password'} = crypt($IN{'editedpassword'},$IN{'editedpassword'});
	}
	
	if( $IN{'editedemail'} ne $selectedauthor->{'email'}){
		$updatedInfo{'email'} = $IN{'editedemail'};
	}
	
	if( $IN{'editedhomepage'} ne $selectedauthor->{'homepage'}){
		$updatedInfo{'homepage'} = $IN{'editedhomepage'};
	}
	
	if( $IN{'editedentryaccess'} ne $selectedauthor->{'postnew'}){
		$updatedInfo{'postnew'} = $IN{'editedentryaccess'};
	}
	
	if( $IN{'editedentryeditaccess'} ne $selectedauthor->{'editentries'}){
		$updatedInfo{'editentries'} = $IN{'editedentryeditaccess'};
	}
	
	if( $IN{'editedconfigureaccess'} ne $selectedauthor->{'editconfigs'}){
		$updatedInfo{'editconfigs'} = $IN{'editedconfigureaccess'};
	}
	
	if( $IN{'editedtemplateaccess'} ne $selectedauthor->{'edittemplates'}){
		$updatedInfo{'edittemplates'} = $IN{'editedtemplateaccess'};
	}
	
	if( $IN{'editedauthoraccess'} ne $selectedauthor->{'editauthors'}){
		$updatedInfo{'editauthors'} = $IN{'editedauthoraccess'};
	}
	
	if( $IN{'editedrebuildaccess'} ne $selectedauthor->{'rebuild'}){
		$updatedInfo{'rebuild'} = $IN{'editedrebuildaccess'};
	}
	
	if( $IN{'editedcplogaccess'} ne $selectedauthor->{'viewcplog'}){
		$updatedInfo{'viewcplog'} = $IN{'editedcplogaccess'};
	}
	
	if( $IN{'editedbookmarkletaccess'} ne $selectedauthor->{'bookmarklets'}){
		$updatedInfo{'bookmarklets'} = $IN{'editedbookmarkletaccess'};
	}
	
	if( $IN{'editeduploadaccess'} ne $selectedauthor->{'upload'}){
		$updatedInfo{'upload'} = $IN{'editeduploadaccess'};
	}
	
	if( $IN{'editedloginaccess'} ne $selectedauthor->{'viewadmin'}){
		$updatedInfo{'viewadmin'} = $IN{'editedloginaccess'};
	}

	if( scalar( keys( %updatedInfo )) < 1 ){
		# hmm, no updates submitted
		$message = '<span class="status_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_NO_CHANGES, 
			{ NAME=>$selectedauthor->{'author'} } ).'</span><p>';
	} else {
		Gm_Storage::updateAuthor( key=>$selectedauthor->{'author'}, %updatedInfo, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
		
		if ($IN{'selectedauthor'} eq $AUTHOR{'author'}) {
			$AUTHOR{'author'} = $IN{'editedname'};
			$AUTHOR{'password'} = $IN{'editedpassword'};
		}
		

		Gm_Core::writeToCplog( Gm_Core::text( Gm_Constants::AUTHORS_EDIT_LOG, 
			{ AUTHOR=>$AUTHOR{'author'}, NAME=>$IN{'editedname'} } )  );

		$message = '<span class="status_msg">'.Gm_Core::text( Gm_Constants::AUTHORS_EDIT_CONFIRM, 
			{ NAME=>$IN{'editedname'} } ).'</span><p>';
	}

	## we are just adding, no control flow
	return( $message );
}

## Manage Entries SECTION #################################################
## Handle all requests for editing entries
## and verify that author can access this section
sub doEntries {

	## Access to entries is global, no need for granularity
	### TODO: MAKE THIS TEXT STRING TAKE A 'SECTION' VAR, SO CAN REUSE FOR OTHER SECTIONS...
	### TODO: CALL AUTH WITH FLAG TO WORK ON Banip, OR CHECK AUTHOR PERMS
	## TODO: Move this to auth, auth should return users perms, or it should take a flag to 
	# indicate which perms to check with this being handed off to a generic permDenied func
	if( $AUTHOR{'editentries'} ne Gm_Constants::Y && $AUTHOR{'editentries'} ne 'O' &&
		$AUTHOR{'postnew'} ne Gm_Constants::Y ){
		Gm_Core::writeToCplog( '<span class="error_msg">'.Gm_Core::text( 
			Gm_Constants::ENTRIES_NO_ACCESS, { AUTHOR=>$AUTHOR{'author'}}).'</span>' );
		my $statusnote = '<span class="error_msg">'.Gm_Core::text( Gm_Constants::ENTRIES_ACCESS_DENY ).
			'</span><br />';
		frontPage( $statusnote );
	}

## move other perm stuff here?
	
	my $status = Gm_Constants::EMPTY;
# TODO, SHOULD THESE BE USING CONSTANTS?
## Maybe should check if entry id, then call entry specific stuff then pass message to 
# viewEntry
	if( $IN{'view'} ){
		$status = editEntry();  ## this handles update, but not add
		
	} elsif( $IN{'preview'} ){
		$status = viewPreview();
		
	} elsif( $IN{'new'} ){
		$status = newEntry(); ## integrate into edit TODO
		
	} elsif( $IN{'update'} ){
		$status = updateEntry();  ## this handles save new as well
		
	} elsif( $IN{'openclose'} ){
		$status = changeEntryStatus();
		
	} elsif( $IN{'search'} ){
		$status = searchEntryList();
		
	} elsif( $IN{'viewsearchreplace'} ){
		$status = viewSearchAndReplace();
		
	} elsif( $IN{'searchreplace'} ){
		$status = entrySearchAndReplace();
		
	} elsif( $IN{'deletecomments'} ){
		$status = deleteEntryComments();
		
	} elsif( $IN{'updatecomment'} ){
		$status = updateEntryComment();
		
	} elsif( $IN{'viewcomment'} ){
		$status = viewEntryComment();
		
	}

	filterEntryList( $status );
}


## Filter Entry List
# A method that filters the entry list for user permissions and sorting
# (opt) ARG1: Message to display to user, could be error or confirmation of action
sub filterEntryList {
	my $message = shift( @_ ) || Gm_Constants::EMPTY;	

	if( $IN{'entryselectionview'} eq Gm_Constants::EMPTY ){ 
		$IN{'entryselectionview'} = $gmConfigs->{'gmdefaultentrylistview'}; 
	}

#		&gm_readcounter;
	my $gmCounters = Gm_Storage::getCounters( errHandler=>\&Gm_Web::displayAdminErrorExit );

	my $entriesList = Gm_Storage::getEntrylist( errHandler=>\&Gm_Web::displayAdminErrorExit );

	my @sortedKeys = keys( %$entriesList );
	## default to date sort
	unless( defined( $IN{'sortby'} ) ){
		$IN{'sortby'} = 'date';
	}
	@sortedKeys = sort {
			lc($entriesList->{$a}{$IN{'sortby'}}) cmp lc($entriesList->{$b}{$IN{'sortby'}}) || $b <=> $a;
		} @sortedKeys;

	my @filteredEntries = ();
	foreach my $elkey ( @sortedKeys ){
		my $addEntry = Gm_Constants::EMPTY;
		my $entry = $entriesList->{$elkey};
	
		if( $IN{'entryselectionview'} eq Gm_Constants::MAIN ){
			## Main view, which is the open entries
			if( $entry->{'id'} > $gmCounters->{'archivetotal'} || $entry->{'id'} eq $gmCounters->{'stayattopentry'} ){
				$addEntry = Gm_Constants::Y;
			}
		} elsif( $IN{'entryselectionview'} eq Gm_Constants::MORE ){
			## all the extended entries
			if(	$entry->{'extended'} eq Gm_Constants::Y ){
				$addEntry = Gm_Constants::Y;
			}
		} elsif( $IN{'entryselectionview'} eq 'onlyyou' ){
			## all the extended entries
			if(	$AUTHOR{'author'} eq $entry->{'author'} ){
				$addEntry = Gm_Constants::Y;
			}
		} elsif( $IN{'entryselectionview'} eq Gm_Constants::OPEN ){
			## all the open entries
			if(	$entry->{'status'} eq 'O' ){
				$addEntry = Gm_Constants::Y;
			}
		} elsif( $IN{'entryselectionview'} eq Gm_Constants::CLOSED ){
			## all the closed entries
			if(	$entry->{'status'} eq 'C' ){
				$addEntry = Gm_Constants::Y;
			}
		} elsif( $IN{'entryselectionview'} eq Gm_Constants::ALL ){
			## all the entries
			$addEntry = Gm_Constants::Y;
		}

		## so do we add?
		if( $addEntry ){
			## First check if view is constrained by only seeing own entries
			if( ($AUTHOR{'editentries'} eq 'O' && $AUTHOR{'author'} eq $entry->{'author'}) ||
				$AUTHOR{'editentries'} eq Gm_Constants::Y ){
				push( @filteredEntries, $entry );
			}
		}
	
	}  ## END foreach elkey

	viewEntries( \@filteredEntries, $message );
}

## Filter Entry List
# A method that filters the entry list for user permissions and sorting
# (opt) ARG1: Message to display to user, could be error or confirmation of action
sub searchEntryList {
	my $message = Gm_Constants::EMPTY;	

	my $baseUrl = 'search=1&entrysearch='.$IN{'entrysearch'};

	if( $IN{'entrysearch'} ne Gm_Constants::EMPTY ){
		$message = '<p><span class="status_msg">All entries containing "'.
			$IN{'entrysearch'}.'"</span></p>';
		## Crude way to show search results
		$IN{'entryselectionview'} = 'searchresults';
		$IN{'entrysearch'} = Gm_Utils::toStoreSafe($IN{'entrysearch'});
	} else {
		$message = '<p><span class="error_msg">Please enter a search term.</span></p>';
		viewEntries( [], $message );
	}
	
	my $entriesList = Gm_Storage::getEntrylist( errHandler=>\&Gm_Web::displayAdminErrorExit );

	my @sortedKeys = keys( %$entriesList );
	## default to date sort
	unless( defined( $IN{'sortby'} ) ){
		$IN{'sortby'} = 'date';
	}
	@sortedKeys = sort {
			lc($entriesList->{$a}{$IN{'sortby'}}) cmp lc($entriesList->{$b}{$IN{'sortby'}}) || $b <=> $a;
		} @sortedKeys;

	my @filteredEntries = ();
	foreach my $elkey ( @sortedKeys ){
		my $addEntry = Gm_Constants::EMPTY;
		my $entry = $entriesList->{$elkey};
	
		my $entryVars = Gm_Core::getEntryVariables( entryid=>$entry->{'id'}, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
		if( ($entryVars->{'thisentryauthor'} =~ m/$IN{'entrysearch'}/i) || 
		($entryVars->{'thisentrysubject'} =~ m/$IN{'entrysearch'}/i) || 
		($entryVars->{'thisentrymusic'} =~ m/$IN{'entrysearch'}/i) || 
		($entryVars->{'thisentrymood'} =~ m/$IN{'entrysearch'}/i) || 
		($entryVars->{'thisentrymainbody'} =~ m/$IN{'entrysearch'}/i) || 
		($entryVars->{'thisentrymorebody'} =~ m/$IN{'entrysearch'}/i) || 
		($entryVars->{'thisentrycomments'} =~ m/$IN{'entrysearch'}/i)) {
			$addEntry = Gm_Constants::Y;
		}

		## so do we add?
		if( $addEntry ){
			## First check if view is constrained by only seeing own entries
			if( ($AUTHOR{'editentries'} eq 'O' && $AUTHOR{'author'} eq $entry->{'author'}) ||
				$AUTHOR{'editentries'} eq Gm_Constants::Y ){
				push( @filteredEntries, $entry );
			}
		}
	
	}  ## END foreach elkey

	viewEntries( \@filteredEntries, $message, $baseUrl );
}


## View Entries
# A private method to view the list of given entries, used by several differenet functions
# ARG1: the list of entries to display, from the entrylist
# ARG2: a message to display
# ARG3: url params, to attach to the base url, in the format of 'key=value&key2=value2'
# (opt) ARG2: Message to display to user, could be error or confirmation of action
sub viewEntries {
	my $filteredEntries = shift( @_ ) || [];
	my $message = shift( @_ ) || Gm_Constants::EMPTY;
	my $addUrl = shift( @_ ) || 'sortby='.$IN{'sortby'}.'&entryselectionview='.$IN{'entryselectionview'};

	my $gmCounters = Gm_Storage::getCounters( errHandler=>\&Gm_Web::displayAdminErrorExit );

	if( $gmCounters->{'entrytotal'} eq '0' ){
		$message = '<span class="error_msg">There are no entries yet!</span><br />';

		frontPage( $message );
	}


	if( $message eq Gm_Constants::EMPTY ){
		$message = '<span class="info_text">Select an entry to edit '.
			'or review.  "Closed" entries are considered deleted and are no longer visible '.
			'on your site, but can be reopened at any time.</span>';
	}

	## special message if can only view own
	if( $AUTHOR{'editentries'} eq 'O' ){
		$message .= '<br /><span class="status_msg">You only have access to edit your own entries.</span>';
	}

	my $gmentrylist = Gm_Storage::getEntrylist( errHandler=>\&Gm_Web::displayAdminErrorExit );

	my @gmsortkeys = keys( %$gmentrylist );
	## default to date sort
	unless( defined( $IN{'sortby'} ) ){
		$IN{'sortby'} = 'date';
	}
	@gmsortkeys = sort {
			lc($gmentrylist->{$a}{$IN{'sortby'}}) cmp lc($gmentrylist->{$b}{$IN{'sortby'}}) || $b <=> $a;
		} @gmsortkeys;

	my $page = '<span class="section_title">Entry Selection</span><br /><p>'.$message."</p><br />\n";	
	$page .= "\n\n".'<form action="gm.cgi" METHOD="post"> '.Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type="hidden" name="section" value="'.$IN{'section'}.'">';
		
		
	$page .= '<P><label for="sortby"><b>Sort by:</b></label> ';

	unless( $IN{'sortby'} ){
		$IN{'sortby'} = 'date';
	}
	$page .= Gm_Web::createRadioButton( name=>'sortby', value=>'date',
		checked=>$IN{'sortby'} ).' Date &#160;';
	$page .= Gm_Web::createRadioButton( name=>'sortby', value=>'subject',
		checked=>$IN{'sortby'} ).' Subject &#160;';
	$page .= Gm_Web::createRadioButton( name=>'sortby', value=>'author',
		checked=>$IN{'sortby'} ).' Author';
		
	$page .= ' <label for="entryselectionview"><b>List:</b></label> <SELECT NAME="entryselectionview" '.
		"CLASS=\"selectlist\">\n";
	if( $IN{'entryselectionview'} eq 'searchresults' ){
		$page .= "<OPTION VALUE=\"$gmConfigs->{'gmdefaultentrylistview'}\" SELECTED> \(Search results\)\n";
	}

	$page .=  Gm_Web::createOption( value=>Gm_Constants::MAIN, label=>"Current entries ($gmConfigs->{'gmindexdays'} day(s))",
		checked=>$IN{'entryselectionview'} );
	$page .= Gm_Web::createOption( value=>'onlyyou', label=>'All entries by you',
		checked=>$IN{'entryselectionview'} );
	$page .= Gm_Web::createOption( value=>Gm_Constants::MORE, label=>'All extended entries',
		checked=>$IN{'entryselectionview'} );
	$page .= Gm_Web::createOption( value=>Gm_Constants::OPEN, label=>'All open entries',
		checked=>$IN{'entryselectionview'} );
	$page .= Gm_Web::createOption( value=>Gm_Constants::CLOSED, label=>'All closed entries',
		checked=>$IN{'entryselectionview'} );
	$page .= Gm_Web::createOption( value=>Gm_Constants::ALL, label=>'All entries',
		checked=>$IN{'entryselectionview'} );

	$page .= '</SELECT> &#160; <INPUT TYPE=SUBMIT CLASS="button" NAME="filterentries" VALUE="Change View" '.
		'STYLE="width: 100; height: 22"></p></form>'."\n";
		
		
	$page .= '<table class="info_table"><tr><th>#</th><th>Status</th><th>Date'.
		'</th><th>Subject</th><th>Author</th><th>Action</th></tr>';

	my $base = '?section='.$IN{'section'}.'&'.Gm_Security::getUrlAuth( author=>\%AUTHOR ).
		'&'.$addUrl;
	my ($page_nav, $filteredEntries ) = Gm_Web::createPaging( data=>$filteredEntries,
		baseurl=>$base, webparams=>\%IN, pagesize=>(Gm_Constants::GM_PAGE_SIZE/5) );
	
	## TODO: CONVERT TO NOTICE ARRAY, JUST PUSH MESSAGES
	my %statusKey = ();
	
	my $rowcolor = Gm_Web::altRowColor();
	foreach my $entry ( @$filteredEntries ){	
		my @status = ();
		if( $entry->{'status'} eq 'C' ){
			push( @status, 'C' );
			$statusKey{'C'} = 'Closed entry.';
		} else {
			push( @status, 'O' );
			$statusKey{'O'} = 'Open entry.';
		}

		if( $entry->{'extended'} eq Gm_Constants::Y ){
			push( @status, 'E' );
			$statusKey{'E'} = 'Extended entry (contains "more" text).';
		}
		
		if( $entry->{'id'} eq $gmCounters->{'stayattopentry'} ){
			push( @status, 'S' );
			$statusKey{'S'} = 'Entry currently marked to stay at the top of the main index.';
		}
		
	
		if( $entry->{'subject'} eq Gm_Constants::EMPTY ){ 
			$entry->{'subject'} = '(no subject)'; 
		}

		$rowcolor = Gm_Web::altRowColor( $rowcolor );
		#  $entry->{'createt'}
		$page .= "<tr $rowcolor><td>$entry->{'id'}</td><td>".join( ', ', @status )." </td><td>".
			"$entry->{'created'}</td><td style=\"text-align:left; padding-left: .75em;\"> ".
			"$entry->{'subject'}</td><td>$entry->{'author'}</td><td>";
			
		## Edit, Delete buttons
		my $buttonText = 'Close';
		if( $entry->{'status'} eq 'C' ){
			$buttonText = 'Open'
		}
		$page .= '<a href="'.$ENV{SCRIPT_NAME}.'?section='.$IN{'section'}.'&openclose=1'.
			'&entryid='.$entry->{'id'}.'&'.Gm_Security::getUrlAuth( author=>\%AUTHOR ).
			'&entryselectionview='.$IN{'entryselectionview'}.
			'" class="link_button" STYLE="background: #FFD0D0">'.$buttonText.'</a>';
		
		$page .= ' &#160; <a href="'.$ENV{SCRIPT_NAME}.'?section='.$IN{'section'}.'&view=1'.
			'&entryid='.$entry->{'id'}.'&'.Gm_Security::getUrlAuth( author=>\%AUTHOR ).
			'&entryselectionview='.$IN{'entryselectionview'}.
			'" class="link_button" STYLE="background: #D0FFD0">'.
			Gm_Core::text( Gm_Constants::EDIT ).'</a>';
		
		$page .= "</td></tr>";

	}

	$page .= "</table><div class='pagenav'>$page_nav</div>\n<br />\n\n";

	## Search page
	$page .= "\n\n".'<p><form action="gm.cgi" METHOD="post"> '.Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type="hidden" name="section" value="'.$IN{'section'}.'"><table class="form_table" width="60%">'.
		'<tr><td>'.
		"\n<INPUT TYPE=TEXT NAME=\"entrysearch\" value=\"$IN{'entrysearch'}\" CLASS=\"inputfield\" SIZE=25 >\n".
		"</td><td><input type=submit class=\"button\" name=\"search\" value=\"Search\" ".
		"STYLE=\"width: 70; height: 22\"></td></tr></table>".
		'</form></p>'."\n";
	
	## Footnotes
	$page .= '<p><span class="info_text">'.join( '<br />', 
		map  { "$_ = $statusKey{$_}" } sort( keys( %statusKey ))  ).'</span></p>';
		
	## Search and replace
	$page .= "\n\n".'<p><form action="gm.cgi" METHOD="post"> '.Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type="hidden" name="section" value="'.$IN{'section'}.'">'.
		'<INPUT TYPE=SUBMIT CLASS="button" NAME="viewsearchreplace" STYLE="background: #D0FFD0; '.
		'width: 485" VALUE="Search And Replace Across All Entries"></form></p>'."\n";
	## de-button	
	$page .= "\n\n".'<p><form action="gm.cgi" METHOD="post"> '.Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type="hidden" name="section" value="'.$IN{'section'}.'">'.
		'<input type=submit class="button" name="new" style="background: #D0FFD0;" '.
		'value="'.Gm_Core::text( Gm_Constants::FRONTPAGE_ADDNEW ).'"></form></p>'."\n";
	$page .= "\n\n".'<P><FORM ACTION="gm.cgi" METHOD="post"> '.Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="'.Gm_Core::text( Gm_Constants::RETURN_MAIN_MENU ).
		'" STYLE="background: #C0C0C0"></form></p>';

#	$statusnote = Gm_Constants::EMPTY;

	Gm_Web::displayAdminPageExit( $page );
	exit(0);
}


## Open Close Entry
# A method to open and close an entry
# RETURNS: A message to display on the view page
sub changeEntryStatus {
	my $message = Gm_Constants::EMPTY;

	if ($IN{'entryid'} eq Gm_Constants::EMPTY) {
		$message = '<span class="error_msg">You must select an entry to open or close.</span>';
#		&gm_editentryselection;
		return( $message ); ## should default to filterEntries
	}
	
	&gm_readconfig;
#	&gm_readtemplates;  ## why?
#		&gm_readcounter;
	my $gmCounters = Gm_Storage::getCounters( errHandler=>\&Gm_Web::displayAdminErrorExit );

	my $thisentrynumberpadded = Gm_Utils::toEntryPadded( $IN{'entryid'} );

	my $gmEntry = Gm_Storage::getEntry( id=>$IN{'entryid'},
		errHandler=>\&Gm_Web::displayAdminErrorExit );

	## TODO: refactor out usage of variables, make work directly off of entry
	my $thisentrynumber = $gmEntry->{'entryinfo'}{'id'};
	my $thisentryauthor = $gmEntry->{'entryinfo'}{'author'};
	my $thisentrysubject = $gmEntry->{'entryinfo'}{'subject'};
	my $thisentryopenstatus = $gmEntry->{'entryinfo'}{'status'};


	if( ($AUTHOR{'author'} ne $thisentryauthor) && ($AUTHOR{'editentries'} eq 'O') ){
		Gm_Core::writeToCplog( "$AUTHOR{'author'} attempted to change the open/closed status ".
			"on entry #$thisentrynumber (by $thisentryauthor) without authorization" );
		$message = '<span class="error_msg">You don\'t have access to open/close entries '.
			'you didn\'t create.</span>';
#		&gm_editentryselection;
		return( $message ); ## should default to filterEntries
	}

	if( $thisentryopenstatus eq Gm_Constants::OPEN ){
		$gmCounters->{'opentotal'}--;
		$gmCounters->{'closedtotal'}++;
		$thisentryopenstatus = Gm_Constants::CLOSED;
	} else {
		$gmCounters->{'opentotal'}++;
		$gmCounters->{'closedtotal'}--;
		$thisentryopenstatus = Gm_Constants::OPEN;
	}

#	&gm_writecounter;
	Gm_Storage::setCounters( list=>$gmCounters, errHandler=>\&Gm_Web::displayAdminErrorExit );

	$gmEntry->{'entryinfo'}{'status'} = $thisentryopenstatus;
	Gm_Storage::setEntry( entry=>$gmEntry, errHandler=>\&Gm_Web::displayAdminErrorExit );
	
	## Updating entry list with new status, but all we know is that we are flipping it
	# so we have to get old one then update with new value
	my $gmentrylist = Gm_Storage::getEntrylist( errHandler=>\&Gm_Web::displayAdminErrorExit );
	my %updatedInfo = ();
	
	if( $gmentrylist->{$thisentrynumber}{'status'} eq 'O' ){
		$updatedInfo{'status'} = 'C';
	} else {
		$updatedInfo{'status'} = 'O';
	}
	
	Gm_Storage::updateEntrylist( key=>$thisentrynumber, %updatedInfo, 
		errHandler=>\&Gm_Web::displayAdminErrorExit );


	my $openCloseStatus = 'closed';
	if( $thisentryopenstatus eq Gm_Constants::OPEN ){
		$openCloseStatus = 'reopened';
	}
	Gm_Core::writeToCplog( "$AUTHOR{'author'} $openCloseStatus an entry (#$thisentrynumber: $thisentrysubject)" );
	$message = "<span class=\"status_msg\">Entry #$thisentrynumber ($thisentrysubject) has been ".
		"$openCloseStatus.<BR>Be sure to rebuild your files for the changes to be visible on your site.</span>";

#&gm_editentryselection;

 return( $message );
}

## View Search And Replace
# View the form that searches and replaces across entries
# (opt) ARG1: Message to display to user, could be error or confirmation of action
sub viewSearchAndReplace {
	my $message = shift( @_ ) || Gm_Constants::EMPTY;

	if( $AUTHOR{'editentries'} eq 'O' ){
		$message = '<span class="error_msg">You must have access to edit all entries to do this.</span>';
		return( $message ); ## should default to filterEntries
	}

	if( $message eq Gm_Constants::EMPTY ){
		$message = '<p><span class="info_text">Enter whatever exact text or other information you wish to search '.
			'across entries for in the<BR>first box, and whatever you wish to replace it with '.
			'in the second box (leave the Replace<BR>box blank to delete all instances of your '.
			'search term).  Keep in mind that a search-and-replace<BR>will make permanent changes '.
			'to the contents of ALL entries that contain your search term.</span></p>';
	}

	my $page = '<span class="section_title">Search And Replace</span><br /><p>'."$message</p>\n";	

	$page .= '<CENTER><FORM ACTION="gm.cgi" METHOD=POST>'.
		Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type="hidden" name="section" value="'.$IN{'section'}.'">';

	$page .= '<table width="80%" class="form_table"><tr><th width="30%"><label for="search">Search For:</label>'.
		'</th><td><input type="text" class="inputfield" name="srsearchterm" id="search" value="'.
		$IN{'srsearchterm'}.'"></td></tr>';
	$page .= '<tr><th><label for="replace">Replace With:</label></th><td>'.
		'<input type="text" class="inputfield" name="srreplaceterm" id="replace" value="'.$IN{'srreplaceterm'}.'">'.
		'</td></tr>';

	$page .= '<tr><th>&nbsp</th><td><input type="checkbox" id="ignorecase" name="srcaseinsensitive" value="yes"';
	if( $IN{'srcaseinsensitive'} ){
		$page .= ' CHECKED';
	}
	$page .= '><label for="ignorecase">Make "Search For" term case-insensitive?</label></td></tr>';

	$page .= '<tr><th>&nbsp</th><td><INPUT TYPE=SUBMIT CLASS="button" NAME="searchreplace" '.
		'STYLE="background: #D0FFD0;" VALUE="Perform Search And Replace"></td></tr></table><br />'.
#		'<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Entry Selection"> '.
		'<INPUT TYPE=SUBMIT CLASS="button" NAME="entries" VALUE="Return To Entry Selection"> '.
		'<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" '.
		'STYLE="background: #C0C0C0"></FORM><P>';

	Gm_Web::displayAdminPageExit( $page );
	exit(0);
}

## Entry Search and Replace
# Searches through all the entries doing the given replace
## TODO: THIS SHOULD DO A REBUILD ONCE ITS DONE, HAVE TO MANUALLY REBUILD
sub entrySearchAndReplace {
	my $message = Gm_Constants::EMPTY;

	if( $AUTHOR{'editentries'} eq 'O' ){
		$message = '<span class="error_msg">You must have access to edit all entries to do this.</span>';
		return( $message ); ## should default to filterEntries
	}
	
	## Validating fields
	my @validation = ();
	if( $IN{'srsearchterm'} eq Gm_Constants::EMPTY ){
		push( @validation, 'You must enter a search term.' );
		
	}
	if( $IN{'srreplaceterm'} eq Gm_Constants::EMPTY ){
		push( @validation, 'You must enter a replacement.' );
		
	}
	if( @validation ){
		viewSearchAndReplace( '<span class="error_msg">'.join( '<br />', @validation ).'<span>' );
	}

	my $gmCounters = Gm_Storage::getCounters( errHandler=>\&Gm_Web::displayAdminErrorExit );

	my $currententrycounter = $gmCounters->{'entrytotal'};	
	my $entriesaffected = 0;
	my $rebuildentrylist = Gm_Constants::NO;

	my @affectedEntries = ();

## TODO: DO WE NEED A GENERIC ENTRY LOOPING MECHANISM, THAT WE COULD GIVE A DECORATOR TO?
## Also, should be starting at 1
	do {

		my $currententrycounterpadded = Gm_Utils::toEntryPadded( $currententrycounter );
		my $resaveentry = Gm_Constants::NO;
	
		## getting the entry
		my $gmEntry = Gm_Storage::getEntry( id=>$currententrycounter,
			errHandler=>\&Gm_Web::displayAdminErrorExit );
		
		## TODO: refactor out usage of variables, make work directly off of entry
		my $thisentrynumber = $gmEntry->{'entryinfo'}{'id'};
		my $thisentryauthor = $gmEntry->{'entryinfo'}{'author'};
		my $thisentrysubject = $gmEntry->{'entryinfo'}{'subject'};
		my $thisentryweekdaynumber = $gmEntry->{'entryinfo'}{'weekday'};
		my $thisentrymonth = $gmEntry->{'entryinfo'}{'month'};
		my $thisentryday = $gmEntry->{'entryinfo'}{'day'};
		my $thisentryyearyear = $gmEntry->{'entryinfo'}{'year'};
		my $thisentryhour = $gmEntry->{'entryinfo'}{'hour'};
		my $thisentryminute = $gmEntry->{'entryinfo'}{'minute'};
		my $thisentrysecond = $gmEntry->{'entryinfo'}{'second'};
		my $thisentryampm = $gmEntry->{'entryinfo'}{'ampm'};
		my $thisentrypositivekarma = $gmEntry->{'entryinfo'}{'karmapos'};
		my $thisentrynegativekarma = $gmEntry->{'entryinfo'}{'karmaneg'};
		my $thisentrycommentsnumber = $gmEntry->{'entryinfo'}{'commenttotal'};
		my $thisentryallowkarma = $gmEntry->{'entryinfo'}{'karma'};
		my $thisentryallowcomments = $gmEntry->{'entryinfo'}{'comments'};
		my $thisentryopenstatus = $gmEntry->{'entryinfo'}{'status'};
		my $thisentrymusic = $gmEntry->{'entryinfo'}{'music'};
		my $thisentrymood = $gmEntry->{'entryinfo'}{'mood'};
		my $thisentryemoticonsallowed = $gmEntry->{'entryinfo'}{'emoticons'};
	
## TODO: WORK ON AUTHOR INFO AS WELL	
		if( $IN{'srcaseinsensitive'} eq Gm_Constants::YES ){
			if( $thisentrysubject =~ m/$IN{'srsearchterm'}/i ||
				$thisentrymusic =~ m/$IN{'srsearchterm'}/i ||
				$thisentrymood =~ m/$IN{'srsearchterm'}/i ){
				
				$thisentrysubject =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/ig;
				$thisentrymusic =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/ig;
				$thisentrymood =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/ig;
				$gmEntry->{'entryinfo'}{'subject'} = $thisentrysubject;
				$gmEntry->{'entryinfo'}{'music'} = $thisentrymusic;
				$gmEntry->{'entryinfo'}{'mood'} = $thisentrymood;
				$resaveentry = Gm_Constants::YES;
				$rebuildentrylist = Gm_Constants::YES;
			}
		} else {
			if( $thisentrysubject =~ m/$IN{'srsearchterm'}/ ||
				$thisentrymusic =~ m/$IN{'srsearchterm'}/ ||
				$thisentrymood =~ m/$IN{'srsearchterm'}/ ){
				
				$thisentrysubject =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/g;
				$thisentrymusic =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/g;
				$thisentrymood =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/g;
				$gmEntry->{'entryinfo'}{'subject'} = $thisentrysubject;
				$gmEntry->{'entryinfo'}{'music'} = $thisentrymusic;
				$gmEntry->{'entryinfo'}{'mood'} = $thisentrymood;		
				$resaveentry = Gm_Constants::YES;
				$rebuildentrylist = Gm_Constants::YES;
			}
		}

		## do main and extended text
		if( $IN{'srcaseinsensitive'} eq Gm_Constants::YES ){
			if( $gmEntry->{'maintext'} =~ m/$IN{'srsearchterm'}/i ||
				$gmEntry->{'extendedtext'} =~ m/$IN{'srsearchterm'}/i ){
				$gmEntry->{'maintext'} =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/ig;
				$gmEntry->{'extendedtext'} =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/ig;			
				$resaveentry = Gm_Constants::YES;
			}		
		} else {
			if( $gmEntry->{'maintext'} =~ m/$IN{'srsearchterm'}/ ||
				$gmEntry->{'extendedtext'} =~ m/$IN{'srsearchterm'}/ ){
				$gmEntry->{'maintext'} =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/g;
				$gmEntry->{'extendedtext'} =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/g;			
				$resaveentry = Gm_Constants::YES;
			}
		}
		
		## looping through comments
		for( my $i = 0; $i < scalar( @{$gmEntry->{'comments'}} ); $i++ ){
			if( $IN{'srcaseinsensitive'} eq Gm_Constants::YES ){
				if( $gmEntry->{'comments'}[$i]{'name'} =~ m/$IN{'srsearchterm'}/i ||
					$gmEntry->{'comments'}[$i]{'email'} =~ m/$IN{'srsearchterm'}/i ||
					$gmEntry->{'comments'}[$i]{'homepage'} =~ m/$IN{'srsearchterm'}/i ||
					$gmEntry->{'comments'}[$i]{'comment'} =~ m/$IN{'srsearchterm'}/i ){
					
					$gmEntry->{'comments'}[$i]{'name'} =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/gi;
					$gmEntry->{'comments'}[$i]{'email'} =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/gi;
					$gmEntry->{'comments'}[$i]{'homepage'} =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/gi;
					$gmEntry->{'comments'}[$i]{'comment'} =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/gi;
					
					$resaveentry = Gm_Constants::YES;
				}
			} else {
				if( $gmEntry->{'comments'}[$i]{'name'} =~ m/$IN{'srsearchterm'}/ ||
					$gmEntry->{'comments'}[$i]{'email'} =~ m/$IN{'srsearchterm'}/ ||
					$gmEntry->{'comments'}[$i]{'homepage'} =~ m/$IN{'srsearchterm'}/ ||
					$gmEntry->{'comments'}[$i]{'comment'} =~ m/$IN{'srsearchterm'}/ ){
					
					$gmEntry->{'comments'}[$i]{'name'} =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/g;
					$gmEntry->{'comments'}[$i]{'email'} =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/g;
					$gmEntry->{'comments'}[$i]{'homepage'} =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/g;
					$gmEntry->{'comments'}[$i]{'comment'} =~ s/$IN{'srsearchterm'}/$IN{'srreplaceterm'}/g;
					
					$resaveentry = Gm_Constants::YES;
				}
			}
		}
	
		if( $resaveentry eq Gm_Constants::YES ){
			Gm_Storage::setEntry( entry=>$gmEntry, errHandler=>\&Gm_Web::displayAdminErrorExit );
			$entriesaffected++;

			$gmEntry->{'entryinfo'}{'created'} = Gm_Utils::toTwoDigit( $gmEntry->{'entryinfo'}{'month'} ).
				'/'.Gm_Utils::toTwoDigit( $gmEntry->{'entryinfo'}{'day'} ).'/'.
				$gmEntry->{'entryinfo'}{'year'};
			if( $gmEntry->{'entryinfo'}{'status'} eq Gm_Constants::OPEN ){
				$gmEntry->{'entryinfo'}{'status'} = 'O';
			} else {
				$gmEntry->{'entryinfo'}{'status'} = 'C';
			}
			if( $gmEntry->{'extendedtext'} ){
				$gmEntry->{'entryinfo'}{'extended'} = Gm_Constants::Y;
			} else {
				$gmEntry->{'entryinfo'}{'extended'} = Gm_Constants::N;
			}
			push( @affectedEntries, $gmEntry->{'entryinfo'} );
		}
	
		$currententrycounter--;
	} until $currententrycounter < 1;

	## TODO: THIS CODE DUPLICATES IN GM_DIAGNOSTICSPERFORM
	## SHOULD BE GENERIC REBUILD ENTRYLIST - CORE
	if( $rebuildentrylist eq Gm_Constants::YES ){
		Gm_Core::reconstructEntrylist( errHandler=>$errHandler );
	}

	if( scalar( @affectedEntries ) < 1 ){
		Gm_Core::writeToCplog("$AUTHOR{'author'} searched all entries for \"$IN{'srsearchterm'}\" and ".
			"replaced it with \"$IN{'srreplaceterm'}\" (no entries affected)");
		$message = '<span class="error_msg">The search term was not found.</span>';
		$IN{'entryselectionview'} = 'searchresults';
	} else {
		Gm_Core::writeToCplog("$AUTHOR{'author'} searched all entries for \"$IN{'srsearchterm'}\" ".
			"and replaced it with \"$IN{'srreplaceterm'}\" ($entriesaffected entries affected)" );
		$message = '<span class="status_msg">The search-and-replace was completed successfully '.
			'('.scalar( @affectedEntries ).' entries affected).  All affected entries are listed below.</span>';
		$IN{'entryselectionview'} = 'searchresults';
	}
	
	## adding base url to show all entries changed, becaue pagin won't work!
	$IN{'page'} = 'all';
	viewEntries( \@affectedEntries, $message );
}


## New Entry
# Start a new entry
# (opt) ARG1: Message to display to user, could be error or confirmation of action
sub newEntry {
	my $message = shift( @_ ) || Gm_Constants::EMPTY;

	&gm_readcounter;  ## used below
	
	## < 1 ?
	if ($newentrynumber eq '0') {
		_checkIfDiagRun('<span class="error_msg">Please run "Diagnostics & Repair" '.
			'in the Configuration screen before posting your first entry.</span>');
	}

	if ($message eq Gm_Constants::EMPTY) {
		$message = '<span class="section_title">Add A New Entry</span><br /><p><span class="info_text">'.
			'This is the form by which you add new entries to your weblog/journal.  You can make this '.
			'either a standard or extended entry; standard entries contain only main text (the first '.
			'box), while extended entries also have "more" text (the second box).  Standard & extended '.
			'entries can be handled and formatted in distinct ways via your templates.</span></p>'."\n";
	}

	my %newEntry = ();
	$newEntry{'entryinfo'}{'id'} = 'new';
	$newEntry{'entryinfo'}{'karma'} = $gmConfigs->{'gmallowkarmadefault'};
	$newEntry{'entryinfo'}{'comments'} = $gmConfigs->{'gmallowcommentsdefault'};
	$newEntry{'entryinfo'}{'status'} = Gm_Constants::OPEN;
	$newEntry{'entryinfo'}{'emoticons'} = Gm_Constants::YES;

	## calling view entry with empty entry, message of explanation, 1 for new entry
	viewEntry( \%newEntry, $message, 1  );	
}


## Edit Entry
# Edit an existing entry
# (opt) ARG1: Message to display to user, could be error or confirmation of action
sub editEntry {
	my $message = shift( @_ ) || Gm_Constants::EMPTY;

	if ($IN{'entryid'} eq Gm_Constants::EMPTY) {
		$message = '<span class="error_msg">You must select an entry to edit.</span>';
		return( $message ); ## should default to filterEntries
		
	} elsif( $IN{'entryid'} eq 'new' ){
		newEntry();
		
	}

&gm_readconfig;  # already done globally, but might be still used
&gm_readtemplates;  ## used?
&gm_readcounter;  ## used?

	my $thisentrynumberpadded = Gm_Utils::toEntryPadded( $IN{'entryid'} );

	my $gmEntry = Gm_Storage::getEntry( id=>$IN{'entryid'}, 
		errHandler=>\&Gm_Web::displayAdminErrorExit );
	
	my $thisentrynumber = $gmEntry->{'entryinfo'}{'id'};
	my $thisentryauthor = $gmEntry->{'entryinfo'}{'author'};
 	my $thisentryampm = $gmEntry->{'entryinfo'}{'ampm'};
	my $thisentrymonth = $gmEntry->{'entryinfo'}{'month'};
	my $thisentryday = $gmEntry->{'entryinfo'}{'day'};
	my $thisentryyearyear = $gmEntry->{'entryinfo'}{'year'};
	my $thisentryhour = $gmEntry->{'entryinfo'}{'hour'};
	my $thisentryminute = $gmEntry->{'entryinfo'}{'minute'};
	my $thisentrysecond = $gmEntry->{'entryinfo'}{'second'};

	if( $AUTHOR{'author'} ne $thisentryauthor && 
		$AUTHOR{'editentries'} eq 'O' ){
	#	gm_writetocplog("$IN{'authorname'} attempted to edit entry #$IN{'entryselectionlist'} (by $thisentryauthor) without authorization");
		Gm_Core::writeToCplog("$AUTHOR{'author'} attempted to edit entry #$IN{'entryid'} ".
			"(by $thisentryauthor) without authorization");
		$message = '<span class="error_msg">You don\'t have access to edit entries you '.
			'didn\'t create.</span>';

		return( $message ); ## should default to filterEntries
	}

	my $thisentrymonthmonth = Gm_Utils::toTwoDigit( $thisentrymonth );
	my $thisentrydayday = Gm_Utils::toTwoDigit( $thisentryday );
	my $thisentryhourhour = Gm_Utils::toTwoDigit( $thisentryhour );
	my $thisentryminuteminute = Gm_Utils::toTwoDigit( $thisentryminute );
	my $thisentrysecondsecond = Gm_Utils::toTwoDigit( $thisentrysecond );


	if( $message eq Gm_Constants::EMPTY ){ 
		$message = '<span class="section_title">Editing Entry #'.$thisentrynumber.
			': Posted by '.$thisentryauthor.' on '.$thisentrymonthmonth.'/'.$thisentrydayday.
			'/'.$thisentryyearyear.' '.$thisentryhourhour.':'.$thisentryminuteminute.':'.
			$thisentrysecondsecond.' '.$thisentryampm.'</span>'; 
	}

	viewEntry( $gmEntry, $message );
}


## View Entry
# Edit a particular entry, or provide the blank form for a new entry
# ARG 1: A gm entry as returned by getEntry
# (opt) ARG2: Message to display to user, could be error or confirmation of action
# (opt) ARG3: Is this a new entry? True for yes, False for no
sub viewEntry {
	my $gmEntry = shift( @_ ) || {};
	my $message = shift( @_ ) || Gm_Constants::EMPTY;
	my $newEntry = shift( @_ ) || Gm_Constants::FALSE;


#	if ($IN{'entryselectionlist'} eq Gm_Constants::EMPTY) {
# 	if ($IN{'entryid'} eq Gm_Constants::EMPTY) {
# 		$message = '<span class="error_msg">You must select an entry to edit.</span>';
# 		return( $message ); ## should default to filterEntries
# 	}

&gm_readconfig;  # already done globally, but might be still used
&gm_readtemplates;  ## used?
&gm_readcounter;  ## used?

#$thisentrynumberpadded = Gm_Utils::toEntryPadded( $IN{'entryselectionlist'} );
#	$thisentrynumberpadded = Gm_Utils::toEntryPadded( $IN{'entryid'} );

#my $gmEntry = Gm_Storage::getEntry( id=>$IN{'entryselectionlist'}, 
#	my $gmEntry = Gm_Storage::getEntry( id=>$IN{'entryid'}, 
#		errHandler=>\&Gm_Web::displayAdminErrorExit );
	
	my $thisentrynumber = $gmEntry->{'entryinfo'}{'id'};
	my $thisentryauthor = $gmEntry->{'entryinfo'}{'author'};
	my $thisentrysubject = defined( $IN{'revisedentrysubject'} ) ? 
		$IN{'revisedentrysubject'} : $gmEntry->{'entryinfo'}{'subject'};
	my $thisentrymusic = defined( $IN{'revisedentrymusic'} ) ? 
		$IN{'revisedentrymusic'} : $gmEntry->{'entryinfo'}{'music'};
	my $thisentrymood = defined( $IN{'revisedentrymood'} ) ? 
		$IN{'revisedentrymood'} : $gmEntry->{'entryinfo'}{'mood'};
	my $thisentryweekdaynumber = $gmEntry->{'entryinfo'}{'weekday'};
	my $thisentrymonth = $gmEntry->{'entryinfo'}{'month'};
	my $thisentryday = $gmEntry->{'entryinfo'}{'day'};
	my $thisentryyearyear = $gmEntry->{'entryinfo'}{'year'};
	my $thisentryhour = $gmEntry->{'entryinfo'}{'hour'};
	my $thisentryminute = $gmEntry->{'entryinfo'}{'minute'};
	my $thisentrysecond = $gmEntry->{'entryinfo'}{'second'};
	my $thisentryampm = $gmEntry->{'entryinfo'}{'ampm'};
	my $thisentrypositivekarma = $gmEntry->{'entryinfo'}{'karmapos'};
	my $thisentrynegativekarma = $gmEntry->{'entryinfo'}{'karmaneg'};
	my $thisentrycommentsnumber = $gmEntry->{'entryinfo'}{'commenttotal'};
	my $thisentryallowkarma = defined( $IN{'revisedentryallowkarma'} ) ? 
		$IN{'revisedentryallowkarma'} : $gmEntry->{'entryinfo'}{'karma'};
	my $thisentryallowcomments = defined( $IN{'revisedentryallowcomments'} ) ? 
		$IN{'revisedentryallowcomments'} : $gmEntry->{'entryinfo'}{'comments'};
	my $thisentryopenstatus = defined( $IN{'revisedentryopenstatus'} ) ? 
		$IN{'revisedentryopenstatus'} : $gmEntry->{'entryinfo'}{'status'};
	my $thisentryemoticonsallowed = defined( $IN{'revisedentryemoticonsallowed'} ) ? 
		$IN{'revisedentryemoticonsallowed'} : $gmEntry->{'entryinfo'}{'emoticons'};

#	if( ($IN{'authorname'} ne $thisentryauthor) && ($gmentryeditaccess eq 'mineonly') ){
	if( ($AUTHOR{'author'} ne $thisentryauthor) && ($AUTHOR{'editentries'} eq 'O') ){
	#	gm_writetocplog("$IN{'authorname'} attempted to edit entry #$IN{'entryselectionlist'} (by $thisentryauthor) without authorization");
		Gm_Core::writeToCplog("$AUTHOR{'author'} attempted to edit entry #$IN{'entryid'} ".
			"(by $thisentryauthor) without authorization");
		$message = '<span class="error_msg">You don\'t have access to edit entries you '.
			'didn\'t create.</span>';

		return( $message ); ## should default to filterEntries
	}

# 	my $thisentrymonthmonth = Gm_Utils::toTwoDigit( $thisentrymonth );
# 	my $thisentrydayday = Gm_Utils::toTwoDigit( $thisentryday );
# 	my $thisentryhourhour = Gm_Utils::toTwoDigit( $thisentryhour );
# 	my $thisentryminuteminute = Gm_Utils::toTwoDigit( $thisentryminute );
# 	my $thisentrysecondsecond = Gm_Utils::toTwoDigit( $thisentrysecond );

	my $thisentrymainbody = defined( $IN{'revisedentrymaintext'} ) ? 
		$IN{'revisedentrymaintext'} : $gmEntry->{'maintext'};
	my $thisentrymorebody = defined( $IN{'revisedentrymoretext'} ) ? 
		$IN{'revisedentrymoretext'} : $gmEntry->{'extendedtext'};

	$thisentrymainbody = Gm_Utils::toWebSafe($thisentrymainbody);
	$thisentrymorebody = Gm_Utils::toWebSafe($thisentrymorebody);
	$thisentrysubject = Gm_Utils::toWebSafe($thisentrysubject);
	$thisentrymusic = Gm_Utils::toWebSafe($thisentrymusic);
	$thisentrymood = Gm_Utils::toWebSafe($thisentrymood);


	# emoticons code display added
	my ( $emoticonsmaincode, $emoticonsmorecode ) = _emoticonsCode();

	my $page = "<p>$message</p>\n";	

	$page .= '<script language="JavaScript">
function commentEmoticonMain(code){
	var cache = document.editentry.revisedentrymaintext.value;

	document.editentry.revisedentrymaintext.value = cache + " " + code;
	document.editentry.revisedentrymaintext.focus();
}

function commentEmoticonMore(code){
	var cache = document.editentry.revisedentrymoretext.value;

	document.editentry.revisedentrymoretext.value = cache + " " + code;
	document.editentry.revisedentrymoretext.focus();
}

/* Rewritten to work on cases when just a single object, 
  ARG1: name of ckeckboxes to deselect/select
  ARG2: element whose checkboxing we are to mimic
*/
function checkAll(checkname, exby) {

    var objs = document.getElementsByName( checkname );
    for (i = 0; i < objs.length; i++){
        objs[i].checked = exby.checked? true:false;
    }
}';

	$page .= '
/* Sets the size of the cooki object 
  ARG1: id of textarea to set size of
  ARG2: size to save
*/
function setSizeCookie( elemName, size ){	
	var now = new Date();
  fixDate(now);
  now.setTime(now.getTime() + 365 * 24 * 60 * 60 * 1000);
  setCookie( "gmpref_"+elemName, size, now);
}

/* Sets the element to hide and the span to control it 
  ARG1: id of span to hide
  ARG2: id of span to modify
*/
function setHideCookie( elemName, controllerName ){	
	var cookieString = getCookie( "gmpref_hidden");
	var foo = cookieString.indexOf( elemName+"|");
	if( cookieString.indexOf( elemName+"|") < 0 ){
		// time to add to end
		var cookieVals = cookieString.split(",");
		cookieVals.push( elemName+"|"+controllerName );
		cookieString = cookieVals.join(",");
		
		// setting cookie
		var now = new Date();
		fixDate(now);
		now.setTime(now.getTime() + 365 * 24 * 60 * 60 * 1000);
		setCookie( "gmpref_hidden", cookieString, now);
	}
}

/* Sets the element to show and the span to control it, actually removes from hide cookie 
  ARG1: id of span to hide
  ARG2: id of span to modify
*/
function setShowCookie( elemName, controllerName ){	
	var cookieString = getCookie( "gmpref_hidden");
	if( cookieString.indexOf( elemName+"|") >= 0 ){
		// time to add to end
		var newPairs = new Array();
		var cookieStrings = cookieString.split(",");
		for( var i=0;i< cookieStrings.length;i++ ){
			var cookiePairs = cookieStrings[i].split("|");
			var a = cookiePairs[0];
			var b = cookiePairs[0].length;
			if( cookiePairs[0].length > 1 && cookiePairs[0] != elemName ){
				newPairs[ cookieStrings[i] ] = "1";
			}
		}
		for( var j in newPairs ){
			newPairs.push( j );
		}
		cookieString = newPairs.join(",");
		
		// setting cookie
		var now = new Date();
		fixDate(now);
		now.setTime(now.getTime() + 365 * 24 * 60 * 60 * 1000);
		setCookie( "gmpref_hidden", cookieString, now);
	}
}

/* Will change the size of the given element 
  ARG1: name of element to resize
  ARG2: "l" for larger, else will shrink to minimuim of 4 rows
*/
function sizer( toSize, action ){
	if( document.getElementById && document.getElementById(toSize) != null ){
		var subject = document.getElementById( toSize );
			
		if( action.toLowerCase() != "l" ){
			if( subject.rows > 4 ){
				subject.rows -= 4;
			}
		} else {
			// default is to grow
			subject.rows += 4;
		}';

	if( $gmConfigs->{'gmcookiesallowed'} eq Gm_Constants::YES ){		
			$page .= "\n setSizeCookie( toSize, subject.rows );\n";
	}
	
	$page .= '	}
}

// Set the size absolutely, used by initing
function setSize( toSize, theSize ){
	if( document.getElementById && document.getElementById(toSize) != null ){
		var subject = document.getElementById( toSize );
			
		if( theSize > 3 ){
			subject.rows = theSize;
		}
	}
}


/* Will change the size of the given element 
  ARG1: id of span to hide
  ARG2: id of span that is the controller, the hide/show link
*/
function hider( toFlip, toLink ){
	if( document.getElementById && document.getElementById(toFlip) != null ){
		var subject = document.getElementById( toFlip );
		var controller = document.getElementById( toLink ); 
		if( subject.className != "hidden" ){
			_hideShow( "hidden", "Show", subject, controller );';

	if( $gmConfigs->{'gmcookiesallowed'} eq Gm_Constants::YES ){		
			$page .= "\n setHideCookie( toFlip, toLink );\n";
	}
	
	$page .= '
		} else {
			_hideShow( "", "Hide", subject, controller );';
	## always leave this call, but comment out guts of setShowCookie
	if( $gmConfigs->{'gmcookiesallowed'} eq Gm_Constants::YES ){		
			$page .= "\n setShowCookie( toFlip, toLink );\n";
	}
	
	$page .= '
		}
	}
	
	function _hideShow( className, theText, sub, con ){
		sub.className=className;
		var link = document.createElement("a");
		link.href = \'javascript:hider(\\\'\'+ toFlip +\'\\\', \\\'\'+ toLink +\'\\\');\';
		link.appendChild( document.createTextNode( theText ));
		
		while( con.hasChildNodes() ){
			con.removeChild( con.firstChild );
		}
		con.appendChild( link );
	}
}';


	$page .= '
var supportAE = (document.attachEvent)? true : false;

function add( tagopen, tagend, tarea ){	
	var tArea = document.getElementById( tarea );
	var sct = tArea.scrollTop;
	var topen = (tagopen)? tagopen : "";
	var end = (tagend)? tagend : "";
	var sl;
		
	if(supportAE){		
		tArea.focus();
		var curSelect = document.selection.createRange();
		curSelect.text = topen + curSelect.text + end;
	
		} else if(!supportAE && typeof tArea.selectionStart != "undefined"){		
			var selStart = tArea.value.substr(0, tArea.selectionStart);
			var selEnd = tArea.value.substr(tArea.selectionEnd, tArea.value.length);
			var curSelection = tArea.value.replace(selStart, "").replace(selEnd, "");

			sl = selStart + topen + curSelection + end;
			tArea.value = sl + selEnd;
	
			tArea.setSelectionRange(sl.length, sl.length);
			tArea.focus();
			tArea.scrollTop = sct;
	} else {		
		tArea.value += topen + end; 
	}
}

// Link requires add to work
function link( tarea ){
	gminsertlink = prompt( "What do you want to link to?", "http://" );
	if( gminsertlink == null ) return;
	
	add( \'<a href="\' + gminsertlink + \'">\', \'</a>\', tarea );
}

';

	
	if( $gmConfigs->{'gmcookiesallowed'} eq Gm_Constants::YES ){
		$page .= '
function init(){
	// can we make t his generic, so that we do not hardcode main_text, more_text?
	// also, rename to get preference, getPreferences because we could be doing ajack 
	// stuff to store it on the server, so then we would need just setPreference
  var size = getCookie( "gmpref_main_text");
	if( size > 3){
  	setSize( "main_text", size );
  }
  size = getCookie( "gmpref_more_text");
  if( size > 3){
	  setSize( "more_text", size );
	}
	var hid = getCookie( "gmpref_hidden");
	var cookieStrings = hid.split(",");
	for( var i=0;i< cookieStrings.length;i++ ){
		var cookieParts = cookieStrings[i].split("|");
		// should be calling a function to hide, not the toggle function
		hider( cookieParts[0], cookieParts[1] );
	}
}

window.onload = init;
';
	}	
	
	$page .= '</script>';

	$page .= '<FORM ACTION="gm.cgi" method="post" name="editentry">'.
		Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type="hidden" name="section" value="'.$IN{'section'}.'">'.
		'<input type=hidden name="entryid" value="'.$thisentrynumber.'">'.
		'<input type=hidden name="entryselectionview" value="'.$IN{'entryselectionview'}.'">'; 

	$page .= "\n".'<table width="95%" class="form_table"><tr>'.
		'<th width="20%"><label for="subject">Subject:</label></th>'.
		'<td><input type=text name="revisedentrysubject" '.
		'value="'.$thisentrysubject.'" class="inputfield" id="subject"></td></tr>';
		
	$page .= "\n".'<tr><th>'.
		'<label for="music">Music:</label></th><td></font><input type=text '.
		'name="revisedentrymusic" value="'.$thisentrymusic.
		'" class="inputfield" id="music"></td></tr>'."\n";
		
	$page .= "\n".'<tr><th>'.
		'<label for="mood">Mood:</label></th><td><input type=text '.
		'name="revisedentrymood" value="'.$thisentrymood.
		'" class="inputfield" id="mood"></td></tr>'."\n";

	$page .= "\n".'<tr class="section_head"><th><label for="main_text">Main Entry Text'.
		'</label></th><td>&nbsp;</td></tr>'.
		'<tr><td colspan="2"><table class="form_table" width="100%"><tr><th width="12%">'.
		$emoticonsmaincode;
	if( $inlineformatting eq Gm_Constants::ENTRIES || $inlineformatting eq Gm_Constants::BOTH ){
		## TODO: GENERISIZE THIS TO A CALL, GET EDITING MENU, SO THAT ITS EASILY OVERRIDDEN
		$page .= '<input type="button" onClick="javascript:add(\'**\',\'**\', \'main_text\' );" '.
			' value="Bold" style="font-size: small;" />';
		$page .= '<input type="button" onClick="javascript:add(\'//\',\'//\', \'main_text\' );" '.
			' value="Ital" style="font-size: small; font-style: italic;" />';
		$page .= '<input type="button" onClick="javascript:add(\'__\',\'__\', \'main_text\' );" '.
			' value="Under" style="font-size: small; text-decoration: underline;" />';
	}			
			
	$page .= '<input type="button" onClick="javascript:link( \'main_text\' );" '.
		' value="Link" style="font-size: small;" />';

	$page .= ' </th><td><textarea name="revisedentrymaintext" id="main_text"'.
		'cols="60" rows="8" class="inputfield">'.$thisentrymainbody.'</textarea><br />';
	
	## TODO: THIS SHOULD BE A JAVASCRIPT PRINT STATEMENT, SO THAT if js no enabled, no problem
	$page .= _sizerCodeEntry('main_text').'</td></tr></table></td></tr>';


	$page .= "\n".'<tr class="section_head"><th><label for="more_text">Extended Text</label></th><td>'.
		_hiderCodeEntry('moreHidden', 'moreHider').
		'</td></tr><tr><td colspan="2">'.
		'<span id="moreHidden"><table class="form_table" width="100%">'.
		'<tr><th width="12%">'.$emoticonsmorecode;
	if( $inlineformatting eq Gm_Constants::ENTRIES || $inlineformatting eq Gm_Constants::BOTH ){
		## TODO: GENERISIZE THIS TO A CALL, GET EDITING MENU, SO THAT ITS EASILY OVERRIDDEN
		$page .= '<input type="button" onClick="javascript:add(\'**\',\'**\', \'more_text\' );" '.
			' value="Bold" style="font-size: small;" />';
		$page .= '<input type="button" onClick="javascript:add(\'//\',\'//\', \'more_text\' );" '.
			' value="Ital" style="font-size: small; font-style: italic;" />';
		$page .= '<input type="button" onClick="javascript:add(\'__\',\'__\', \'more_text\' );" '.
			' value="Under" style="font-size: small; text-decoration: underline;" />';
	}	

	$page .= '<input type="button" onClick="javascript:link( \'more_text\' );" '.
		' value="Link" style="font-size: small;" />';

	$page .= '</th><td><textarea id="more_text"'.
		'name="revisedentrymoretext" cols="60" rows="8" class="inputfield">'.
		$thisentrymorebody.'</textarea>'.
		_sizerCodeEntry('more_text').'</td></tr></table></span>'.
		'</td></tr>';

	## TODO: make this helper subroutine
	## Comment Stuff
	unless( $newEntry ){
		$page .= "\n".'<tr class="section_head"><th>Comments</th><td>'.
			_hiderCodeEntry('commentHidden', 'commentHider').'</td></tr>';
		$page .= '<tr><td colspan="2"><span id="commentHidden">';
		if( $thisentrycommentsnumber > 0 ){
			$page .= '<table style="font-size:small; width: 92%;"><tr>';
			$page .= '<th style="text-align: center; background: #B0B0D0;">#</th>'.
				'<th style="text-align: center; background: #B0B0D0; background: #B0B0D0;">'.
				'<input type="checkbox" name="all" id="check_uncheck_all" '.
				'onClick="checkAll(\'multideletecommentselection\',this)"></th>'.
				'<th style="text-align: center; background: #B0B0D0;">Comment</th>'.
				'<th style="text-align: center; background: #B0B0D0;" width="24%">Action</th></tr>';
			
			my $rowcolor = Gm_Web::altRowColor();
			
		# 	do {
		my $thiscommentnumber = 0;
		foreach my $entryComment ( @{$gmEntry->{'comments'}} ){
			
	# 		if ($alternatecommentrow eq $alternatecommentrowone) {
	# 			$alternatecommentrow = $alternatecommentrowtwo;
	# 		} else {
	# 			$alternatecommentrow = $alternatecommentrowone;
	# 		}
			$rowcolor = Gm_Web::altRowColor( $rowcolor );
		
			$thiscommentnumber++;	
		# 	$thiscommentnumber = $commentcounter - 3;
		# 	($thiscommentauthor, $thiscommentauthorip, $thiscommentauthoremailabsolute, $thiscommentauthorhomepageabsolute, $thiscommentweekdaynumber, $thiscommentmonth, $thiscommentday, $thiscommentyearyear, $thiscommenthour, $thiscommentminute, $thiscommentsecond, $thiscommentampm, $thiscommenttext) = split (/\|/, $entrylines[$commentcounter]);
			my $thiscommentauthor = $entryComment->{'name'};
			my $thiscommentauthorip = $entryComment->{'ip'};
			my $thiscommentauthoremailabsolute = $entryComment->{'email'};
			my $thiscommentauthorhomepageabsolute = $entryComment->{'homepage'};
			my $thiscommentweekdaynumber = $entryComment->{'weekday'};
			my $thiscommentmonth = $entryComment->{'month'};
			my $thiscommentday = $entryComment->{'day'};
			my $thiscommentyearyear = $entryComment->{'year'};
			my $thiscommenthour = $entryComment->{'hour'};
			my $thiscommentminute = $entryComment->{'minute'};
			my $thiscommentsecond = $entryComment->{'second'};
			my $thiscommentampm = $entryComment->{'ampm'};
			my $thiscommenttext = $entryComment->{'comment'};
			
			my $thiscommentmonthmonth = Gm_Utils::toTwoDigit( $thiscommentmonth );
			my $thiscommentdayday = Gm_Utils::toTwoDigit( $thiscommentday );
			my $thiscommenthourhour = Gm_Utils::toTwoDigit( $thiscommenthour );
			my $thiscommentminuteminute = Gm_Utils::toTwoDigit( $thiscommentminute );
			my $thiscommentsecondsecond = Gm_Utils::toTwoDigit( $thiscommentsecond );
			
			## IS THIS WEBSAVING?  TODO: CAN USE WEB FUNCTION HERE?
			$thiscommenttext =~ s/</\&lt;/g;
			$thiscommenttext =~ s/>/\&gt;/g;
			$thiscommenttext =~ s/\|\*\|/\n/g;
			$thiscommenttext =~ s/\n/<BR>/g;
			$thiscommenttext =~ s/<BR><BR>/<P>/g;
			# $thiscommenttext =~ s/  / &#160;/g;
			
			my $rowStyle = $rowcolor;
			$rowStyle =~ s/;"/;text\-align\: center;"/; ## lame I know, alternate row color shouldn't put in style 
			$page .= "\n".'<tr><td '.$rowStyle.'>'.
				$thiscommentnumber.'</td><td '.$rowStyle.'">'.
				'<INPUT TYPE="checkbox" NAME="multideletecommentselection" VALUE="'.$thiscommentnumber.'"></TD>';
	
			$page .= '<td '.$rowcolor.'">';
	# 		$page .= '<TD '.$rowcolor.'">'.
	# 			$gmfonttag.' Posted by '.$thiscommentauthor.' ('.
	# 			$thiscommentauthorip.') @ '.$thiscommentmonthmonth.'/'.$thiscommentdayday.'/'.
	# 			$thiscommentyearyear.' '.$thiscommenthourhour.':'.$thiscommentminuteminute.
	# 			':'.$thiscommentsecondsecond.' '.$thiscommentampm.'</b><br />'.$thiscommenttext.' ';		
			$page .= '<table style="font-size:small; width: 100%">'.
				'<tr class="form_long"><th width="20%">Author:</th><td>'.$thiscommentauthor.' ('.
				$thiscommentauthorip.')</td></tr>'.
				'<tr class="form_long"><th>Date:</th><td>'.$thiscommentmonthmonth.'/'.$thiscommentdayday.'/'.
				$thiscommentyearyear.' '.$thiscommenthourhour.':'.$thiscommentminuteminute.
				':'.$thiscommentsecondsecond.' '.$thiscommentampm.'</td></tr>';
			
			if( $thiscommentauthoremailabsolute ne Gm_Constants::EMPTY ){
				$page .= "\n"."<tr class=\"form_long\"><th>E-Mail:</th><td>".
				"<a href=\"mailto:$thiscommentauthoremailabsolute\">".
				"$thiscommentauthoremailabsolute</a></td></tr>";
			}
			if( $thiscommentauthorhomepageabsolute ne Gm_Constants::EMPTY ){
				$page .= "\n"."<tr class=\"form_long\"><th>Homepage:</th><td>".
				"<a href=\"$thiscommentauthorhomepageabsolute\">".
				"$thiscommentauthorhomepageabsolute</a></td></tr>";
			}
	
			$page .= "\n".'<tr><th>Comment: </th><td>'.$thiscommenttext.'</td></tr></table>';
	
			$page .= '</td>';
	
			$page .= '<TD VALIGN=TOP ALIGN=CENTER '.$rowcolor.'">';
	
			## The delete link 
	# 		$page .= '<a href="'.$ENV{SCRIPT_NAME}.'?thomas=Delete+Selected+Comment&'.
	# 			'revisedentrycommentselection='.$thiscommentnumber.'&revisedentryauthor='.$thisentryauthor.
	# 			'&revisedentrynumber='.$thisentrynumber.'&'.Gm_Security::getUrlAuth( author=>\%AUTHOR ).
	# 			'&entryselectionview='.$IN{entryselectionview}.'&revisedentrysubject='.$thisentrysubject.
	# 			'" class="link_button" STYLE="background: #FFD0D0">Delete</a> &#160; ';
			$page .= '<a href="'.$ENV{SCRIPT_NAME}.'?section='.$IN{'section'}.'&deletecomments=1'.
				'&multideletecommentselection='.$thiscommentnumber.
				'&entryid='.$thisentrynumber.'&'.Gm_Security::getUrlAuth( author=>\%AUTHOR ).
				'&entryselectionview='.$IN{entryselectionview}.
				'" class="link_button" STYLE="background: #FFD0D0">Delete</a> &#160; ';
				
			## The edit link - this should just be passing the entry id, not all the entry info ...
	# 		$page .= ' <a href="'.$ENV{SCRIPT_NAME}.'?thomas=Edit+Selected+Comment&'.
	# 			'revisedentrycommentselection='.$thiscommentnumber.'&revisedentryauthor='.$thisentryauthor.
	# 			'&revisedentrynumber='.$thisentrynumber.'&revisedentrysubject='.$thisentrysubject.'&'.
	# 			Gm_Security::getUrlAuth( author=>\%AUTHOR ).'&entryselectionview='.$IN{entryselectionview}.
	# 			'" class="link_button"> Edit</a>'.
	# 			'</td></tr>';
			$page .= ' <a href="'.$ENV{SCRIPT_NAME}.'?section='.$IN{'section'}.'&viewcomment=1'.
				'&revisedentrycommentselection='.$thiscommentnumber.'&revisedentryauthor='.$thisentryauthor.
				'&entryid='.$thisentrynumber.'&'.Gm_Security::getUrlAuth( author=>\%AUTHOR ).
				'&entryselectionview='.$IN{entryselectionview}.
				'" class="link_button"> Edit</a>'.
				'</td></tr>';
			
		# 	$commentcounter++;
			
		}
		# 	} until $commentcounter > $commentcountermax;
			
	
			$page .= '<td>&nbsp;</td><td colspan="4"><input type="checkbox" name="all" id="check_uncheck_all" '.
				'onClick="checkAll(\'multideletecommentselection\',this)">'.
				'<label for="check_uncheck_all">Check/Uncheck All</label>  '.
				'&nbsp;&nbsp;&nbsp;';
			$page .= '<input type="submit" class="button" name="deletecomments" style="background: '.
				'#FFD0D0" value="Delete All Selected Comments"></td>';
			$page .= '</tr></table><br />';
		} else {
			$page .= 'The entry has no comments.';
		}
		$page .= '</span></td></tr>';
	
	} ## END of Comment stuff

	## Karma Stuff
	unless( $newEntry ){
		$page .= "\n".'<tr class="section_head"><th>Karma</th><td>'.
			_hiderCodeEntry('karmaHidden', 'karmaHider').'</td></tr>'.
			'<tr><td colspan="2"><span id="karmaHidden">';
		
		my @karmaPos = ();
		my @karmaNeg = ();
	
		foreach my $entryVote ( keys( %{$gmEntry->{'karmavotes'}} ) ){ 
			if( $gmEntry->{'karmavotes'}{$entryVote} eq 'P' ){ 		
				push( @karmaPos, $entryVote ); 
			} elsif( $gmEntry->{'karmavotes'}{$entryVote} eq Gm_Constants::N ){ 		
				push( @karmaNeg, $entryVote ); 
			}
		}
	
		$page .= "\n".'<table  style="font-size:small; width: 92%;"><tr class="form_long">'.
			'<th width="20%" nowrap>'.scalar(@karmaPos).' Positive karma '.
			'votes from (IPs): </th><td>'.join( ', ', @karmaPos).'</td></tr>';
		$page .= '<tr><th width="20%" nowrap>'.scalar(@karmaNeg).' Negative karma '.
			'votes from (IPs): </th><td>'.join( ', ', @karmaNeg).'</td></tr></table>';
	
		$page .= "</span></td></tr>\n";
	} ## END of Karma stuff

	## The Options	
	$page .= "\n".'<tr class="section_head"><th>Options</th><td>'.
		_hiderCodeEntry('optionsHidden', 'optionsHider').
		'</td></tr><tr><td colspan="2"><span id="optionsHidden">';
	$page .= '<table  style="font-size:small; width: 92%;">';
	
	
	if( $allowkarmaorcomments eq Gm_Constants::KARMA ||
		$allowkarmaorcomments eq Gm_Constants::BOTH ){
		$page .= "\n".'<tr class="form_long"><th>Allow karma voting on this entry:</th><td>';
		$page .= Gm_Web::createRadioButton( name=>'revisedentryallowkarma', value=>Gm_Constants::YES,
			checked=>$thisentryallowkarma, id=>'allow_karma_yes' ).'<label for="allow_karma_yes"> Yes </label>';
		$page .= Gm_Web::createRadioButton( name=>'revisedentryallowkarma', value=>Gm_Constants::NO,
			checked=>$thisentryallowkarma, id=>'allow_karma_no' ).
			'<label for="allow_karma_no"> No </label></td></tr>';
	} else {
		## TODO: GET RID OF THIS, WE WILL CHECK THE PERMS WHEN SAVING, NOT A HIDDEN FORM FIELD (UNTRUSTED)
		$page .= '<input type=hidden name="revisedentryallowkarma" value="no">'; ## BAD
	}

	if( $allowkarmaorcomments eq Gm_Constants::COMMENTS || 
		$allowkarmaorcomments eq Gm_Constants::BOTH ){
		$page .= "\n".'<tr class="form_long"><th>Allow comments to be posted to this entry:</th><td>';
		$page .= Gm_Web::createRadioButton( name=>'revisedentryallowcomments', value=>Gm_Constants::YES,
			checked=>$thisentryallowcomments, id=>'allow_comments_yes' ).
			'<label for="allow_comments_yes"> Yes </label>';
		$page .= Gm_Web::createRadioButton( name=>'revisedentryallowcomments', value=>Gm_Constants::NO,
			checked=>$thisentryallowcomments , id=>'allow_comments_no' ).
			'<label for="allow_comments_no"> No </label></td></tr>';
	} else {
		## TODO: GET RID OF THIS, WE WILL CHECK THE PERMS WHEN SAVING, NOT A HIDDEN FORM FIELD (UNTRUSTED)
		$page .= '<input type=hidden name="revisedentryallowkarma" value="no">';
	}

	if( $emoticonsallowed eq Gm_Constants::ENTRIES || 
		$emoticonsallowed eq Gm_Constants::BOTH ){
		$page .= "\n".'<tr class="form_long"><th>Allow emoticons to be used in this entry:</th><td>';
		$page .= Gm_Web::createRadioButton( name=>'revisedentryemoticonsallowed', value=>Gm_Constants::YES,
			checked=>$thisentryemoticonsallowed, id=>'allow_emoticons_yes' ).
			'<label for="allow_emoticons_yes"> Yes </label>';
		$page .= Gm_Web::createRadioButton( name=>'revisedentryemoticonsallowed', value=>Gm_Constants::NO,
			checked=>$thisentryemoticonsallowed, id=>'allow_emoticons_no' ).
			'<label for="allow_emoticons_no"> No </label></td></tr>';
	} else {
		## TODO: GET RID OF THIS, WE WILL CHECK THE PERMS WHEN SAVING, NOT A HIDDEN FORM FIELD (UNTRUSTED)
		$page .= '<INPUT TYPE=HIDDEN NAME="revisedentryemoticonsallowed" VALUE="no">';
	}

	## Stay at Top
	my $keep_top = Gm_Constants::NO;
	if( (defined( $IN{'revisedentrystayattop'} ) && $IN{'revisedentrystayattop'} eq Gm_Constants::YES) || 
		(!defined( $IN{'revisedentrystayattop'} ) && $newstayattopnumber eq $thisentrynumber) ){
		$keep_top = Gm_Constants::YES;
	}
	## setting controlling width here since it will be on every page
	$page .= "\n".'<tr class="form_long"><th width="40%">Keep this entry at the top '.
		'of the main page:</th><td>';
	$page .= Gm_Web::createRadioButton( name=>'revisedentrystayattop', value=>Gm_Constants::YES,
		checked=>$keep_top, id=>'keep_top_yes' ).
		'<label for="keep_top_yes"> Yes </label>';
	$page .= Gm_Web::createRadioButton( name=>'revisedentrystayattop', value=>Gm_Constants::NO,
		checked=>$keep_top, id=>'keep_top_no' ).
		'<label for="keep_top_no"> No </label></td></tr>';

	## We could hide this, but why shouldn't people be able to create new closed entries?
	## TODO: UPDATE FOR 'DRAFT' STATUS
	$page .= "\n".'<tr><th>This entry is:</th><td>';
	$page .= Gm_Web::createRadioButton( name=>'revisedentryopenstatus', value=>Gm_Constants::OPEN,
		checked=>$thisentryopenstatus, id=>'set_entry_open' ).
			'<label for="set_entry_open"> Open </label>';
	$page .= Gm_Web::createRadioButton( name=>'revisedentryopenstatus', value=>Gm_Constants::CLOSED,
		checked=>$thisentryopenstatus, id=>'set_entry_closed' ).
			'<label for="set_entry_closed"> Closed </label></td></tr></table>';
	$page .= '</span></td></tr>';

	## just move auto rebuild stuff here...
	my $autorebuildcheckbox = Gm_Constants::EMPTY;
	my @isRebuildChecked = ();
	if( $newEntry ){
		$autorebuildcheckbox = '<input type=hidden name="autorebuild" value="indexandentry">';	
	} else {

		if( $AUTHOR{'rebuild'} eq Gm_Constants::Y ){
			$autorebuildcheckbox = '<p>';
	
			if( $automaticrebuilddefault eq Gm_Constants::YES && !$IN{'autorebuild_org'} ){
				push( @isRebuildChecked, 'indexandentry' );
			}
			if( $IN{'autorebuild'} ){
				push( @isRebuildChecked, $IN{'autorebuild'} );
			}
			$autorebuildcheckbox .= Gm_Web::createCheckbox( name=>'autorebuild', 
				value=>'indexandentry', id=>'auto_rebuild', checked=>\@isRebuildChecked );
			$autorebuildcheckbox .= '<input type=hidden name="autorebuild_org" value="1">';
			$autorebuildcheckbox .= ' <label for="auto_rebuild">Automatically rebuild '.
				'main index and this entry\'s page after saving</label><br />'.
				'<span class="info_text">After clicking Save, expect '. 
				'a wait of up to several minutes if leaving this box checked.  DO NOT '. 
				'interrupt Greymatter while it\'s rebuilding!</span></p>';
		}
	}
	
	$page .= "\n".'<tr><th>&nbsp;</th><td>'.
		"<p>$autorebuildcheckbox </p></td></tr>";
	$page .= "\n".'<tr><td></td>&nbsp;<td><input type=reset class="cancel_button button_hov" '.
		'value="Undo Changes" name="entries"> '.
		'<input type=submit class="other_button button_hov" name="preview" value="Preview Before Posting"> '.
		'<input type=submit class="accept_button button_hov" name="update" '.
		' value="Post Entry"> </td></tr></table><p>';
		
	$page .= '<input type=submit class="button" name="entries" value="View Another Entry"><p></form>';
	$page .= "\n\n".'<p><form action="gm.cgi" method="post"> '.Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type=submit class="button" name="thomas" VALUE="'.Gm_Core::text( Gm_Constants::RETURN_MAIN_MENU ).
		'" STYLE="background: #C0C0C0"></form></p>';


	Gm_Web::displayAdminPageExit( $page );
	## NAVIGATION SHOULD BE DE-BUTTONED
	exit(0); ## will never get here, in theory
}



## View Preview
# Previe a particular entry, whether new or existing
sub viewPreview {
	my $message = shift( @_ ) || Gm_Constants::EMPTY;
#&gm_validate;

# if ($gmentryaccess ne Gm_Constants::YES) {
# 	gm_writetocplog("$IN{'authorname'} attempted to add an entry without authorization");
# 	$statusnote = qq(<b><font color="#FF0000">You don't have access to add entries.</FONT></b><P>);
# 	&gm_frontpage;
# }

	my $newentrysubject = Gm_Utils::toStoreSafe( $IN{'revisedentrysubject'} );
	my $newentrymaintext = Gm_Utils::toStoreSafe( $IN{'revisedentrymaintext'} );
	my $newentrymoretext = Gm_Utils::toStoreSafe( $IN{'revisedentrymoretext'} );
	my $newentrymusic = Gm_Utils::toStoreSafe( $IN{'revisedentrymusic'} );
	my $newentrymood = Gm_Utils::toStoreSafe( $IN{'revisedentrymood'} );

	my $newentrysubjectdeloused = Gm_Utils::toWebSafe( $newentrysubject );
	my $newentrymaintextdeloused = Gm_Utils::toWebSafe( $newentrymaintext );
	my $newentrymoretextdeloused = Gm_Utils::toWebSafe( $newentrymoretext );
	my $newentrymusicdeloused = Gm_Utils::toWebSafe( $newentrymusic );
	my $newentrymooddeloused = Gm_Utils::toWebSafe( $newentrymood );

	$newentrysubjectdeloused =~ s/\n/\|\*\|/g;
	$newentrymaintextdeloused =~ s/\n/\|\*\|/g;
	$newentrymoretextdeloused =~ s/\n/\|\*\|/g;
	$newentrymusicdeloused =~ s/\n/\|\*\|/g;
	$newentrymooddeloused =~ s/\n/\|\*\|/g;
	
	$newentrymaintext =~ s/\|\*\|/<BR>/g;
	$newentrymoretext =~ s/\|\*\|/<BR>/g;
	$newentrymaintext =~ s/\n/<BR>/g;
	$newentrymoretext =~ s/\n/<BR>/g;
	$newentrymaintext =~ s/<BR><BR>/<\/P><P ALIGN=JUSTIFY>/g;
	$newentrymoretext =~ s/<BR><BR>/<\/P><P ALIGN=JUSTIFY>/g;

	&gm_readcounter; ## refactor out

	my $entryVars = ();

	## TODO:  PREVIEW IS ONLY PSUEDO WORKING, IT WILL USE THE TEXT AND MORE TEXT, BUT IT WON'T DO
	# PROPER REPLACEMENT ON GM TAGS SUCH AS {{MINUTE}} BECAUSE ITS USING THE PREVIOUS ENTRY AS
	# A TEMPLATE, THIS NEEDS TO BE REWORKED SO THAT MORE DATA CAN BE PASSED IN, OR THAT 
	# ENTRY VARIABLES CAN BE SIGNIFIED TO ASSUME NOW FOR TIMES.  NOTE THIS IS A VERY LARGE ISSUE
	# FOR EXAMPLE, {{PREVIOUS}} TAG WILL POINT TO THE 2ND TO LAST ENTRY, NOT LAST ENTRY
	unless( $newentrynumber < 1 ){
		$entryVars = Gm_Core::getEntryVariables( entryid=>$newentrynumber, previewMain=>$newentrymaintext,
			 previewMore=>$newentrymoretext, errHandler=>\&Gm_Web::displayAdminErrorExit );
			
		$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
			template=>$entryVars->{'thisentrymainbody'}, errHandler=>\&Gm_Web::displayAdminErrorExit);
			
		$newentrymaintext = $entryreturn;
		unless( $newentrymoretext eq Gm_Constants::EMPTY ){
			$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
				template=>$entryVars->{'thisentrymorebody'}, errHandler=>\&Gm_Web::displayAdminErrorExit);
				
			$newentrymoretext = $entryreturn;
		}
	}

	my $showmoretext = Gm_Constants::EMPTY;
	if( $newentrymoretext ne Gm_Constants::EMPTY ){ 
		$showmoretext = "</P><P ALIGN=CENTER><CENTER>\n<B>[extended text]</B>\n</CENTER></P>".
			"<P ALIGN=JUSTIFY>\n$newentrymoretext\n"; 
	}

	if( $statusnote eq Gm_Constants::EMPTY ){
		if( $newentrysubject ne Gm_Constants::EMPTY ){
			$message = '<span class="section_title">Previewing "'.$newentrysubject.'"</span>'.
				'<br /><span class="info_text">Click "Add This Entry" below to add this entry '.
				'to your site, or click "Re-Edit This Entry" to re-edit it.</span>';
		} else {
			$message = '<span class="section_title">Previewing New Entry</span><br />'.
				'<span class="info_text">Click "Add This Entry" below to add this entry to '.
				'your site, or click "Re-Edit This Entry" to re-edit it.</span>';
		}
	}

	my $page = "<p>$message</p>\n";	
	$page .= "<p class=\"text_left\">$newentrymaintext $showmoretext</p>\n";
	$page .= '<p class="text_left"><form action="gm.cgi" method=post>'.
		Gm_Security::getFormAuth( author=>\%AUTHOR )."\n".
		'<input type="hidden" name="section" value="'.$IN{'section'}.'">'."\n".
		'<input type=hidden name="entryid" value="'.$IN{'entryid'}.'">'."\n".
		'<input type=hidden name="revisedentrysubject" value="'.$newentrysubjectdeloused.'">'."\n".
		'<input type=hidden name="revisedentrymaintext" value="'.$newentrymaintextdeloused.'">'."\n".
		'<input type=hidden name="revisedentrymoretext" value="'.$newentrymoretextdeloused.'">'."\n".
		'<input type=hidden name="revisedentryallowkarma" value="'.$IN{'revisedentryallowkarma'}.'">'."\n".
		'<input type=hidden name="revisedentryallowcomments" value="'.$IN{'revisedentryallowcomments'}.'">'."\n".
		'<input type=hidden name="revisedentryemoticonsallowed" value="'.$IN{'revisedentryemoticonsallowed'}.'">'."\n".
		'<input type=hidden name="revisedentrystayattop" value="'.$IN{'revisedentrystayattop'}.'">'."\n".
		'<input type=hidden name="revisedentrymusic" value="'.$IN{'revisedentrymusic'}.'">'."\n".
		'<input type=hidden name="revisedentrymood" value="'.$IN{'revisedentrymood'}.'">'."\n".
		'<input type=hidden name="autorebuild" value="'.$IN{'autorebuild'}.'">'."\n".
		'<input type=hidden name="revisedentryopenstatus" value="'.$IN{'revisedentryopenstatus'}.'">'."\n".
		'<input type=hidden name="gmbmspecial" value="'.$IN{'gmbmspecial'}.'">'."\n". ## do we need?
		'<input type=submit class="button" name="view" value="Re-Edit This Entry"> '."\n".
		'<input type=submit class="button" name="update" style="background: #D0FFD0" VALUE="Post Entry">'."\n".
		'</form></p>';
	$page .= "\n\n".'<p><form action="gm.cgi" method="post"> '.Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type=submit class="button" name="thomas" VALUE="'.Gm_Core::text( Gm_Constants::RETURN_MAIN_MENU ).
		'" STYLE="background: #C0C0C0"></form></p>';
		
	Gm_Web::displayAdminPageExit( $page );
	## NAVIGATION SHOULD BE DE-BUTTONED
	exit(0); ## will never get here, in theory

}


## Update Entry
# save the changes for a particular entry that has been updated
sub updateEntry {
	my $message = Gm_Constants::EMPTY;
	my $newEntry = Gm_Constants::FALSE;
#&gm_validate;

## Already done
# if ($gmentryeditaccess eq Gm_Constants::NO) {
# 	gm_writetocplog("$IN{'authorname'} attempted to edit entry #$IN{'revisedentrynumber'} without authorization");
# 	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to edit entries.</FONT></B><P>);
# 	&gm_frontpage;
# }

## BAD! don't trust the user input for author name or revised entry name
# if (($IN{'authorname'} ne $IN{'revisedentryauthor'}) && ($gmentryeditaccess eq "mineonly")) {
# 	gm_writetocplog("$IN{'authorname'} attempted to edit entry #$IN{'entryselectionlist'} (by $IN{'revisedentryauthor'}) without authorization");
# 	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to edit entries you didn't create.</FONT></B><P>);
# 	&gm_editentryselection;
# }

	if( $IN{'entryid'} eq Gm_Constants::EMPTY ){
		$message = '<span class="error_msg">You must select an entry to edit.</span>';
		return( $message ); ## should default to filterEntries
	}

	## Why are we doing this???
	$IN{'revisedentrysubject'} = Gm_Utils::toStoreSafe($IN{'revisedentrysubject'});
	$IN{'revisedentrysubject'} = Gm_Utils::toConfigSafe($IN{'revisedentrysubject'});

#	if( $IN{'revisedentrymaintext'} eq Gm_Constants::EMPTY ){
	if( $IN{'revisedentrymaintext'} eq Gm_Constants::EMPTY ){
		$message = '<span class="error_msg">You left the main text field blank.  Please '.
			'try again.</span>';
		##$IN{'entryselectionlist'} = $IN{'revisedentrynumber'};  ## shouldn't need this if use entryid
		#&gm_editthisentry;
		if( $IN{'entryid'} eq 'new' ){
			newEntry( $message );
		} else {
			editEntry( $message );
		}
	}

	&gm_readconfig; ## already global
	&gm_readtemplates; ## don't need
	&gm_readcounter; ## REfactor to use Storage directly
	


	my $gmEntry = {};

	if( $IN{'entryid'} eq 'new' ){
		## Setting up new values	
	#&gm_readcounter; ## already done
	
		$newentrynumber++;
		&gm_writecounter;  ### WE really, really shouldn't do this until the file has been saved!!!
		$IN{'entryid'} = $newentrynumber;
		$newEntry = Gm_Constants::TRUE;
	
	# $newentrynumberpadded = sprintf ("%8d", $newentrynumber);
	# $newentrynumberpadded =~ tr/ /0/;
		my $newentrynumberpadded = Gm_Utils::toEntryPadded( $newentrynumber ); 
	
	#&gm_readconfig;  ## laready done
		my ($basedate, $wday, $mon, $mday, $JSYear, $hour, $min, $sec, $AMPM ) = 
			Gm_Utils::getStdDate( $serveroffset );
		my $shortyear = substr($JSYear, -2, 2);
			
		my $montwo = Gm_Utils::toTwoDigit( $mon );
		my $mdaytwo = Gm_Utils::toTwoDigit( $mday );
		my $hourtwo = Gm_Utils::toTwoDigit( $hour );
		my $mintwo = Gm_Utils::toTwoDigit( $min );
	
	#	my %gmEntry = ();
		$gmEntry->{'entryinfo'}{'id'} = $newentrynumber;
		$gmEntry->{'entryinfo'}{'author'} = $AUTHOR{'author'};
		$gmEntry->{'entryinfo'}{'weekday'} = $wday;
		$gmEntry->{'entryinfo'}{'month'} = $mon;
		$gmEntry->{'entryinfo'}{'day'} = $mday;
		$gmEntry->{'entryinfo'}{'year'} = $JSYear;
		$gmEntry->{'entryinfo'}{'hour'} = $hour;
		$gmEntry->{'entryinfo'}{'minute'} = $min;
		$gmEntry->{'entryinfo'}{'second'} = $sec;
		$gmEntry->{'entryinfo'}{'ampm'} = $AMPM;
		$gmEntry->{'entryinfo'}{'karmapos'} = 0;
		$gmEntry->{'entryinfo'}{'karmaneg'} = 0;
		$gmEntry->{'entryinfo'}{'commenttotal'} = 0;
		$gmEntry->{'karmavotes'} = { '0.0.0.0' => 'I' };
		$gmEntry->{'comments'} = [];

		
	} else {
		$gmEntry = Gm_Storage::getEntry( id=>$IN{'entryid'},
			errHandler=>\&Gm_Web::displayAdminErrorExit );
	}

	# ($thisentrynumber, $thisentryauthor, $thisentrysubject, $thisentryweekdaynumber, $thisentrymonth, $thisentryday, $thisentryyearyear, $thisentryhour, $thisentryminute, $thisentrysecond, $thisentryampm, $thisentrypositivekarma, $thisentrynegativekarma, $thisentrycommentsnumber, $thisentryallowkarma, $thisentryallowcomments, $thisentryopenstatus, $thisentrymusic, $thisentrymood, $thisentryemoticonsallowed) = split (/\|/, $entrylines[0]);
	my $thisentrynumber = $gmEntry->{'entryinfo'}{'id'};
	my $thisentryauthor = $gmEntry->{'entryinfo'}{'author'};
	my $thisentrysubject = $gmEntry->{'entryinfo'}{'subject'};
	my $thisentryweekdaynumber = $gmEntry->{'entryinfo'}{'weekday'};
	my $thisentrymonth = $gmEntry->{'entryinfo'}{'month'};
	my $thisentryday = $gmEntry->{'entryinfo'}{'day'};
	my $thisentryyearyear = $gmEntry->{'entryinfo'}{'year'};
	my $thisentryhour = $gmEntry->{'entryinfo'}{'hour'};
	my $thisentryminute = $gmEntry->{'entryinfo'}{'minute'};
	my $thisentrysecond = $gmEntry->{'entryinfo'}{'second'};
	my $thisentryampm = $gmEntry->{'entryinfo'}{'ampm'};
	my $thisentrypositivekarma = $gmEntry->{'entryinfo'}{'karmapos'};
	my $thisentrynegativekarma = $gmEntry->{'entryinfo'}{'karmaneg'};
	my $thisentrycommentsnumber = $gmEntry->{'entryinfo'}{'commenttotal'};
	my $thisentryallowkarma = $gmEntry->{'entryinfo'}{'karma'};
	my $thisentryallowcomments = $gmEntry->{'entryinfo'}{'comments'};
	my $thisentryopenstatus = $gmEntry->{'entryinfo'}{'status'};
	my $thisentrymusic = $gmEntry->{'entryinfo'}{'music'};
	my $thisentrymood = $gmEntry->{'entryinfo'}{'mood'};
	my $thisentryemoticonsallowed = $gmEntry->{'entryinfo'}{'emoticons'};
	
#	$thisentrynumberpadded = Gm_Utils::toEntryPadded( $IN{'revisedentrynumber'} );
	my $thisentrynumberpadded = Gm_Utils::toEntryPadded( $IN{'entryid'} );

### NEW
#	if( ($IN{'authorname'} ne $thisentryauthor) && ($gmentryeditaccess eq 'mineonly') ){
	if( $newEntry ){
		if( $selectedauthor->{'postnew'} eq Gm_Constants::Y  ){
			Gm_Core::writeToCplog("$AUTHOR{'author'} attempted to add an entry without authorization");
			$message = '<span class="error_msg">You don\'t have access to add entries.</span>';
			#&gm_frontpage;
			frontPage( $message );
		}
	} else {
		if( $AUTHOR{'author'} ne $thisentryauthor && $AUTHOR{'editentries'} eq 'O' ){
		#	gm_writetocplog("$IN{'authorname'} attempted to edit entry #$IN{'entryselectionlist'} (by $thisentryauthor) without authorization");
			Gm_Core::writeToCplog("$AUTHOR{'author'} attempted to edit entry #$IN{'entryid'} ".
				"(by $thisentryauthor) without authorization");
			$message = '<span class="error_msg">You don\'t have access to edit entries you '.
				'didn\'t create.</span>';
	#		&gm_editentryselection;
			return( $message ); ## should default to filterEntries
		}
	}
# chomp ($thisentryemoticonsallowed);

	## are they opening or closing this entry, gm counter variables REPLACE
	if( $thisentryopenstatus eq Gm_Constants::OPEN && 
		$IN{'revisedentryopenstatus'} eq Gm_Constants::CLOSED ){
		$newalltimeopenentriesnumber--;
		$newalltimeclosedentriesnumber++;
	}
	if( $thisentryopenstatus eq Gm_Constants::CLOSED && 
		$IN{'revisedentryopenstatus'} eq Gm_Constants::OPEN ){
		$newalltimeopenentriesnumber++;
		$newalltimeclosedentriesnumber--;
	}

	my $thisentryyear = substr($thisentryyearyear, -2, 2);

	$thisentryweekday = (Gm_Constants::DAYS)[$thisentryweekdaynumber];
	$thisentrymonthword = (Gm_Constants::MONTHS_SHORT)[$thisentrymonth-1];

	$thisentrymonthmonth = Gm_Utils::toTwoDigit( $thisentrymonth );
	$thisentrydayday = Gm_Utils::toTwoDigit( $thisentryday );
	$thisentryhourhour = Gm_Utils::toTwoDigit( $thisentryhour );
	$thisentryminuteminute = Gm_Utils::toTwoDigit( $thisentryminute );
	$thisentrysecondsecond = Gm_Utils::toTwoDigit( $thisentrysecond );
	
	$IN{'revisedentrysubject'} = Gm_Utils::toStoreSafe($IN{'revisedentrysubject'});
	$IN{'revisedentrysubject'} = Gm_Utils::toConfigSafe($IN{'revisedentrysubject'}); ## why only one?
	$IN{'revisedentrymaintext'} = Gm_Utils::toStoreSafe($IN{'revisedentrymaintext'});
	$IN{'revisedentrymoretext'} = Gm_Utils::toStoreSafe($IN{'revisedentrymoretext'});
	$IN{'revisedentrymusic'} = Gm_Utils::toStoreSafe($IN{'revisedentrymusic'});
	$IN{'revisedentrymood'} = Gm_Utils::toStoreSafe($IN{'revisedentrymood'});
	
	$IN{'revisedentrysubject'} = Gm_Utils::sanitizeInput($IN{'revisedentrysubject'});
	$IN{'revisedentrymaintext'} = Gm_Utils::sanitizeInput($IN{'revisedentrymaintext'});
	$IN{'revisedentrymoretext'} = Gm_Utils::sanitizeInput($IN{'revisedentrymoretext'});
	$IN{'revisedentrymusic'} = Gm_Utils::sanitizeInput($IN{'revisedentrymusic'});
	$IN{'revisedentrymood'} = Gm_Utils::sanitizeInput($IN{'revisedentrymood'});

	## TODO: MAKE STUFF WORK DIRECTLY OFF OF THE GMENTRY INSTEAD OF USING TEMP VARS
	$gmEntry->{'entryinfo'}{'id'} = $thisentrynumber;
	$gmEntry->{'entryinfo'}{'author'} = $thisentryauthor;
	$gmEntry->{'entryinfo'}{'subject'} = $IN{'revisedentrysubject'};
	$gmEntry->{'entryinfo'}{'weekday'} = $thisentryweekdaynumber;
	$gmEntry->{'entryinfo'}{'month'} = $thisentrymonth;
	$gmEntry->{'entryinfo'}{'day'} = $thisentryday;
	$gmEntry->{'entryinfo'}{'year'} = $thisentryyearyear;
	$gmEntry->{'entryinfo'}{'hour'} = $thisentryhour;
	$gmEntry->{'entryinfo'}{'minute'} = $thisentryminute;
	$gmEntry->{'entryinfo'}{'second'} = $thisentrysecond;
	$gmEntry->{'entryinfo'}{'ampm'} = $thisentryampm;
	$gmEntry->{'entryinfo'}{'karmapos'} = $thisentrypositivekarma;
	$gmEntry->{'entryinfo'}{'karmaneg'} = $thisentrynegativekarma;
	$gmEntry->{'entryinfo'}{'commenttotal'} = $thisentrycommentsnumber;
	
	## TODO: DON'T USE THESE VALUES FROM WEB FORM UNLESS ITS ALLOWED BY THE AUTHORS PERMISSIONS
	# CLEAN UP VIEWENTRY TO REMOVE HIDDEN FIELDS
	$gmEntry->{'entryinfo'}{'karma'} = $IN{'revisedentryallowkarma'};
	$gmEntry->{'entryinfo'}{'comments'} = $IN{'revisedentryallowcomments'};
	$gmEntry->{'entryinfo'}{'status'} = $IN{'revisedentryopenstatus'};
	$gmEntry->{'entryinfo'}{'music'} = $IN{'revisedentrymusic'};
	$gmEntry->{'entryinfo'}{'mood'} = $IN{'revisedentrymood'};
	$gmEntry->{'entryinfo'}{'emoticons'} = $IN{'revisedentryemoticonsallowed'};
	
	$gmEntry->{'maintext'} = $IN{'revisedentrymaintext'};
	$gmEntry->{'extendedtext'} = $IN{'revisedentrymoretext'};

	Gm_Storage::setEntry( entry=>$gmEntry, 'new'=>$newEntry, 
		errHandler=>\&Gm_Web::displayAdminErrorExit );

	my $revisedentrymorestatus = Gm_Constants::N;
	if( $IN{'revisedentrymoretext'} ne Gm_Constants::EMPTY ){ 
		$revisedentrymorestatus = Gm_Constants::Y; 
	}
	my $revisedentrymarkopen = 'O';
	if( $IN{'revisedentryopenstatus'} eq Gm_Constants::CLOSED ){ 
		$revisedentrymarkopen = 'C'; 
	}


	## Needed in case its a new entry
	my $shortyear = substr( $thisentryyearyear, -2, 2 );
	my $montwo = Gm_Utils::toTwoDigit( $thisentrymonth );
	my $mdaytwo = Gm_Utils::toTwoDigit( $thisentryday );
	my $hourtwo = Gm_Utils::toTwoDigit( $thisentryhour );
	my $mintwo = Gm_Utils::toTwoDigit( $thisentryminute );

	my %updatedInfo = ();
	$updatedInfo{'id'} = $thisentrynumber; ## for new
	$updatedInfo{'author'} = $thisentryauthor; ## for new
	$updatedInfo{'subject'} = $IN{'revisedentrysubject'};
	$updatedInfo{'created'} = "$montwo\/$mdaytwo\/$shortyear"; ## for new
	$updatedInfo{'createt'} = "$hourtwo\:$mintwo $thisentryampm";	## for new
	$updatedInfo{'status'} = $revisedentrymarkopen;
	$updatedInfo{'extended'} = $revisedentrymorestatus;
	$updatedInfo{'music'} = $IN{'revisedentrymusic'};
	$updatedInfo{'mood'} = $IN{'revisedentrymood'};
	$updatedInfo{'emoticons'} = $IN{'revisedentryemoticonsallowed'};
	
	if( $newEntry ){
		Gm_Storage::addEntrylist( %updatedInfo, errHandler=>\&Gm_Web::displayAdminErrorExit );
	} else {
		Gm_Storage::updateEntrylist( key=>$IN{'entryid'}, %updatedInfo, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
	}

	if( $IN{'revisedentrystayattop'} eq Gm_Constants::NO && 
		$newstayattopnumber eq $thisentrynumber ){ 
		$newstayattopnumber = 0; 
	}

	if( $IN{'revisedentrystayattop'} eq Gm_Constants::YES ){ 
		$newstayattopnumber = $thisentrynumber; 
	}

	&gm_writecounter; ## replace this with storage call

	$recordentrysubject = $IN{'revisedentrysubject'};
	if( $recordentrysubject eq Gm_Constants::EMPTY ){ 
		$recordentrysubject = "[no subject]"; 
	}

	if( $newEntry ){
		Gm_Core::writeToCplog("$AUTHOR{'author'} added a new entry (#$IN{'entryid'}: $recordentrysubject)");
	} else {
		Gm_Core::writeToCplog("$AUTHOR{'author'} edited an entry (#$IN{'entryid'}: $recordentrysubject)");
	}

	## TODO: REPLACE WITH A CALL TO CORE
	if ($IN{'autorebuild'} eq 'indexandentry') {
		&gm_readconfig;
		&gm_readcounter;
		&gm_readtemplates;
		&gm_generatemainindex;
	#	&gm_getentryvariables($IN{'revisedentrynumber'});	
		my $entryVars = Gm_Core::getEntryVariables( entryid=>$IN{'entryid'}, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
	
		if (($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) && 
			($gmConfigs->{'gmgenerateentrypages'} eq Gm_Constants::YES)) {
			if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
	# 			&gm_formatentry($gmmoreentrypagetemplate);
				$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
					template=>$gmmoreentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
			} else {
	# 			&gm_formatentry($gmentrypagetemplate);
				$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
					template=>$gmentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
			}

			Gm_Storage::saveFile( loc=>"$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix", 
				content=>[$entryreturn], ch_mod=>'0666', errHandler=>\&Gm_Web::displayAdminErrorExit,
				'new'=>1 );		
		} else {
			unlink ("$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix");
		}
		if( $newEntry ){
			$message = '<span class="status_msg">Your new entry has been added.</span>';	
		} else {
			$message = '<span class="status_msg">Entry #'.$IN{'entryid'}.' ('.$recordentrysubject.
				') has been edited and the main index & this entry\'s page have been rebuilt.</span>';
		}
	} else {
		$message = '<span class="status_msg">Entry #'.$IN{'entryid'}.' ('.$recordentrysubject.
			') has been edited. Be sure to rebuild your files for the changes to be visible '.
			'on your site.</span>';
	}

	
	
	if( $newEntry ){	
		if( $gmConfigs->{'gmgenerateentrypages'} eq Gm_Constants::YES ){
		
		# 	&gm_readconfig;
		# #	&gm_getentryvariables($newentrynumber);
		# 	$entryVars = Gm_Core::getEntryVariables( entryid=>$newentrynumber, 
		#   	errHandler=>\&Gm_Web::displayAdminErrorExit );
		# 	if ($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) {
		# 		if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
		# # 			&gm_formatentry($gmmoreentrypagetemplate);
		# 			$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
		# 				template=>$gmmoreentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
		# 		} else {
		# # 			&gm_formatentry($gmentrypagetemplate);
		# 			$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
		# 				template=>$gmentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
		# 		}
		# # 		open (THISFILE, ">$EntriesPath/$thisentrynumberpadded.$entrysuffix") || &gm_dangermouse("Can't write file to $EntriesPath/$thisentrynumberpadded.$entrysuffix - please run Diagnostics & Repair in the Configuration screen.");
		# # 		print THISFILE $entryreturn;
		# # 		close (THISFILE);
		# # 		chmod (0666, "$EntriesPath/$newentrynumberpadded.$entrysuffix");
		# 		Gm_Storage::saveFile( loc=>"$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix", 
		# 			content=>[$entryreturn],'new'=>1, ch_mod=>'0666', 
		# 			errHandler=>\&Gm_Web::displayAdminErrorExit );
		# 	} else {
		# 		unlink( "$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix" );
		# 	}
		
			## Refreshing the previous entry
			if( $newentrynumber ne '1' ){
				$updatepreviousnumber = $newentrynumber - 1;
		# 		&gm_getentryvariables($updatepreviousnumber);
				$entryVars = Gm_Core::getEntryVariables( entryid=>$updatepreviousnumber, 
					errHandler=>\&Gm_Web::displayAdminErrorExit );
		
				if ($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) {
					if ($updatepreviousnumber <= $newarchivenumber) {
						if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
		# 					&gm_formatentry($gmmorearchiveentrypagetemplate);
							$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
								template=>$gmmorearchiveentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
						} else {
		# 					&gm_formatentry($gmarchiveentrypagetemplate);
							$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
								template=>$gmarchiveentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
						}
					} else {
						if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
		# 					&gm_formatentry($gmmoreentrypagetemplate);
							$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
								template=>$gmmoreentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
						} else {
		# 					&gm_formatentry($gmentrypagetemplate);
							$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
								template=>$gmentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
						}
					}

					Gm_Storage::saveFile( loc=>"$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix", 
						content=>[$entryreturn], ch_mod=>'0666', 
						errHandler=>\&Gm_Web::displayAdminErrorExit );			
				} else {
					unlink ("$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix");
				}
			}
		}
			
		#&gm_generatemainindex;
		
		#&gm_readcounter;
		## > 1 ??		
		if (($newarchivenumber ne '0') || ($concurrentmainandarchives eq Gm_Constants::YES)) {
			if (($generateentrypages eq Gm_Constants::YES) && ($newarchivenumber ne '0')) {

		# 		&gm_getentryvariables($newarchivenumber);
				$entryVars = Gm_Core::getEntryVariables( entryid=>$newarchivenumber, 
					errHandler=>\&Gm_Web::displayAdminErrorExit );
				$originaldaymarker = "$entryVars->{'thisentryday'} $entryVars->{'thisentrymonth'}";
				$currentdaymarker = $originaldaymarker;
				$markercount = $newarchivenumber;
				do {
					if ($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) {
						if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
		# 					&gm_formatentry($gmmorearchiveentrypagetemplate);
							$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
								template=>$gmmorearchiveentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
						} else {
		# 					&gm_formatentry($gmarchiveentrypagetemplate);
							$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
								template=>$gmarchiveentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
						}

						Gm_Storage::saveFile( loc=>"$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix", 
							content=>[$entryreturn], ch_mod=>'0666', 
							errHandler=>\&Gm_Web::displayAdminErrorExit );	
					} else {
						unlink ("$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix");
					}
					$markercount--;
					if ($markercount eq '0') {
						$currentdaymarker = "finis";
					} else {
		# 				&gm_getentryvariables($markercount);
						$entryVars = Gm_Core::getEntryVariables( entryid=>$markercount, 
							errHandler=>\&Gm_Web::displayAdminErrorExit );
						$currentdaymarker = "$entryVars->{'thisentryday'} $entryVars->{'thisentrymonth'}";
					}		
				} until $currentdaymarker ne $originaldaymarker;
			}
		
			if ($concurrentmainandarchives eq Gm_Constants::YES) { $newarchivenumber = $newentrynumber; }
			unless ($keepmonthlyarchives eq Gm_Constants::NO) { &gm_generatearchive($newarchivenumber); }
			&gm_readcounter;  ## need?
		
		}
		
		if ($keeparchivemasterindex eq Gm_Constants::YES) {
			if ($newarchivenumber ne '0') {
		# 		&gm_getentryvariables($newarchivenumber);
				$entryVars = Gm_Core::getEntryVariables( entryid=>$newarchivenumber, 
					errHandler=>\&Gm_Web::displayAdminErrorExit );
			} else {
		# 		&gm_getentryvariables($newentrynumber);
				$entryVars = Gm_Core::getEntryVariables( entryid=>$newentrynumber, 
					errHandler=>\&Gm_Web::displayAdminErrorExit );
			}
		# 	&gm_formatentry($gmarchivemasterindextemplate);
			$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
				template=>$gmarchivemasterindextemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);	

			Gm_Storage::saveFile( loc=>"$EntriesPath/$indexfilename", 
				content=>[$entryreturn], ch_mod=>'0666', 
				errHandler=>\&Gm_Web::displayAdminErrorExit );
		}
		
		## Updating total entries by author
		my $gmauthors = Gm_Storage::getAuthors( errHandler=>\&Gm_Web::displayAdminErrorExit );
#		my $selectedauthor = $gmauthors->{$IN{'authorname'}};
		my $selectedauthor = $gmauthors->{$AUTHOR{'author'}};
		my $authorEntries = $selectedauthor->{'posttotal'}++;
		
		Gm_Storage::updateAuthor( key=>$selectedauthor->{'author'}, 
				posttotal=>$authorEntries, 
				errHandler=>\&Gm_Web::displayAdminErrorExit );
			
		if (($otherfilelist ne Gm_Constants::EMPTY) && 
		($otherfilelistentryrebuild eq Gm_Constants::YES) ) {
			$IN{'rebuilding'} = "connectedaftersave";
			$IN{'rebuildfrom'} = "connected";
			&gm_rebuildupdate;
		}	
	
	
	
	}



	#&gm_frontpage;
##	filterEntryList( $message );  ## this will default to filterentryllist
  return( $message ); ## should default to filterEntries
}


## Delete Entry Comments
# Edit a particular entry, or provide the blank form for a new entry
sub deleteEntryComments {
	my $message = Gm_Constants::EMPTY;
#&gm_validate;

	my @del_ids = split("\t",$IN{'multideletecommentselection'});

# 	if ($gmentryeditaccess eq Gm_Constants::NO) {
# 		gm_writetocplog("$IN{'authorname'} attempted to delete a comment from entry #$IN{'revisedentrynumber'} ($IN{'revisedentrysubject'}) without authorization");
# 		$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to delete comments.</FONT></B><P>);
# 		&gm_frontpage;
# 	}

	if( $IN{'multideletecommentselection'} eq Gm_Constants::EMPTY ){
		$message = '<span class="error_msg">You must select a comment to be deleted.</span>';
#		&gm_editthisentry;
		editEntry( $message );	
	}

# if (($IN{'authorname'} ne $IN{'revisedentryauthor'}) && ($gmentryeditaccess eq "mineonly")) {
# 	gm_writetocplog("$IN{'authorname'} attempted to delete a comment from entry #$IN{'entryselectionlist'} (by $IN{'revisedentryauthor'}) without authorization");
# 	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to delete comments from entries you didn't create.</FONT></B><P>);
# 	&gm_editentryselection;
# }

	my $thisentrynumberpadded = Gm_Utils::toEntryPadded( $IN{'entryid'} );

	my $gmEntry = Gm_Storage::getEntry( id=>$IN{'entryid'},
		errHandler=>\&Gm_Web::displayUserErrorExit );

	## TODO: refactor out usage of variables, make work directly off of entry
	my $thisentrynumber = $gmEntry->{'entryinfo'}{'id'};
	my $thisentryauthor = $gmEntry->{'entryinfo'}{'author'};
	my $thisentrysubject = $gmEntry->{'entryinfo'}{'subject'};
	my $thisentryweekdaynumber = $gmEntry->{'entryinfo'}{'weekday'};
	my $thisentrymonth = $gmEntry->{'entryinfo'}{'month'};
	my $thisentryday = $gmEntry->{'entryinfo'}{'day'};
	my $thisentryyearyear = $gmEntry->{'entryinfo'}{'year'};
	my $thisentryhour = $gmEntry->{'entryinfo'}{'hour'};
	my $thisentryminute = $gmEntry->{'entryinfo'}{'minute'};
	my $thisentrysecond = $gmEntry->{'entryinfo'}{'second'};
	my $thisentryampm = $gmEntry->{'entryinfo'}{'ampm'};
	my $thisentrypositivekarma = $gmEntry->{'entryinfo'}{'karmapos'};
	my $thisentrynegativekarma = $gmEntry->{'entryinfo'}{'karmaneg'};
	my $thisentrycommentsnumber = $gmEntry->{'entryinfo'}{'commenttotal'};
	my $thisentryallowkarma = $gmEntry->{'entryinfo'}{'karma'};
	my $thisentryallowcomments = $gmEntry->{'entryinfo'}{'comments'};
	my $thisentryopenstatus = $gmEntry->{'entryinfo'}{'status'};
	my $thisentrymusic = $gmEntry->{'entryinfo'}{'music'};
	my $thisentrymood = $gmEntry->{'entryinfo'}{'mood'};
	my $thisentryemoticonsallowed = $gmEntry->{'entryinfo'}{'emoticons'};

#	if( ($IN{'authorname'} ne $IN{'revisedentryauthor'} ) && ($gmentryeditaccess eq "mineonly")) {
	if( $AUTHOR{'author'} ne $thisentryauthor && $AUTHOR{'editentries'} eq 'O' ){
		Gm_Core::writeToCplog("$AUTHOR{'author'} attempted to delete comments from entry #".
			$IN{'entryid'}." (by $thisentryauthor) without authorization");
		$message = '<span class="error_msg">You don\'t have access to delete entries '.
			'you didn\'t create.</span>';
#		&gm_editentryselection;
		filterEntryList( $message );
	}

	## Figure out which ones go - TODO: REFACTOR THIS, MUST BE A BETTER WAY TO DO THIS
	#$statusnote = Gm_Constants::EMPTY;
	foreach my $del_id (@del_ids){
		$deleteme = $del_id - 1;
		
		$thisentrycommentsnumber--;
	# 	$entrylines[$deleteme] = '*DELETED*';
		$gmEntry->{'comments'}[$deleteme] = '*DELETED*';
		
		$message .= '<span class="status_msg">Comment #'.$del_id.' has been deleted.</span><br />';
	}

	## Make new list
	my @new_comments = ();
	foreach my $ent ( @{$gmEntry->{'comments'}} ){
		push( @new_comments, $ent ) 
			unless( $ent eq '*DELETED*' );
	}
	## Setting comments to new list
	$gmEntry->{'comments'} = \@new_comments;

	Gm_Storage::setEntry( entry=>$gmEntry, errHandler=>\&Gm_Web::displayAdminErrorExit );

	## Updating counter TODO: USE STORAGE DIRECTLY
	&gm_readcounter;
	$newalltimecommentstotalnumber = $newalltimecommentstotalnumber - scalar( @del_ids );
	&gm_writecounter;

	Gm_Core::writeToCplog("$AUTHOR{'author'} deleted a comment(s) \#".
		join(',',@del_ids)." from entry #$IN{'entryid'} ($thisentrysubject)");

#	&gm_editthisentry;
	
	editEntry( $message );
}

## View Entry Comment
# Edit a particular entry's comment
# (opt) ARG1: Message to display to user, could be error or confirmation of action
sub viewEntryComment {
	my $message = shift( @_ ) || Gm_Constants::EMPTY;
#&gm_validate;

# if ($gmentryeditaccess eq Gm_Constants::NO) {
# 	gm_writetocplog("$IN{'authorname'} attempted to edit comment #$IN{'revisedentrycommentselection'} in entry #$IN{'revisedentrynumber'} ($IN{'revisedentrysubject'}) without authorization");
# 	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to edit comments.</FONT></B><P>);
# 	&gm_frontpage;
# }

	if ($IN{'revisedentrycommentselection'} eq Gm_Constants::EMPTY) {
		$message = '<span class="error_msg">You must select a comment to be edited.</span>';
	#	$IN{'entryselectionlist'} = $IN{'revisedentrynumber'};
#		&gm_editthisentry;
		editEntry( $message );
	}

# 	if (($IN{'authorname'} ne $IN{'revisedentryauthor'}) && ($gmentryeditaccess eq "mineonly")) {
# 		gm_writetocplog("$IN{'authorname'} attempted to edit a comment in entry #$IN{'entryid'} (by $IN{'revisedentryauthor'}) without authorization");
# 		$message = qq(<B><FONT COLOR="#FF0000">You don't have access to edit comments in entries you didn't create.</FONT></B><P>);
# 		&gm_editentryselection;
# 	}


#	my $thisentrynumberpadded = Gm_Utils::toEntryPadded( $IN{'revisedentrynumber'} );
	my $thisentrynumberpadded = Gm_Utils::toEntryPadded( $IN{'entryid'} );

# $editme = $IN{'revisedentrycommentselection'} + 3;

#	my $gmEntry = Gm_Storage::getEntry( id=>$IN{'revisedentrynumber'},
	my $gmEntry = Gm_Storage::getEntry( id=>$IN{'entryid'},
		errHandler=>\&Gm_Web::displayUserErrorExit );

	my $thisentryauthor = $gmEntry->{'entryinfo'}{'author'};
	my $thisentrysubject = $gmEntry->{'entryinfo'}{'subject'};
	
	if( $AUTHOR{'author'} ne $thisentryauthor && $AUTHOR{'editentries'} eq 'O' ){
		Gm_Core::writeToCplog( "$AUTHOR{'author'}  attempted to edit a comment in entry ".
			"#$IN{'entryid'} (by $thisentryauthor) without authorization" );
		$message = '<span class="error_msg">You don\'t have access to edit comments '.
			'in entries you didn\'t create.</span>';
		filterEntryList( $message );
	}

	my $comm_index = $IN{'revisedentrycommentselection'} - 1;
	## TODO: refactor out usage of variables, make work directly off of entry
	my $thiscommentauthor =  defined( $IN{'revisedentrycommentauthor'} ) ? 
		$IN{'revisedentrycommentauthor'} : $gmEntry->{'comments'}[$comm_index]{'name'};
	my $thiscommentauthorip = $gmEntry->{'comments'}[$comm_index]{'ip'};
	my $thiscommentauthoremailabsolute =   defined( $IN{'revisedentrycommentauthoremail'} ) ? 
		$IN{'revisedentrycommentauthoremail'} : $gmEntry->{'comments'}[$comm_index]{'email'};
	my $thiscommentauthorhomepageabsolute =   defined( $IN{'revisedentrycommentauthorhomepage'} ) ? 
		$IN{'revisedentrycommentauthorhomepage'} : $gmEntry->{'comments'}[$comm_index]{'homepage'};
	my $thiscommentweekdaynumber = $gmEntry->{'comments'}[$comm_index]{'weekday'};
	my $thiscommentmonth = $gmEntry->{'comments'}[$comm_index]{'month'};
	my $thiscommentday = $gmEntry->{'comments'}[$comm_index]{'day'};
	my $thiscommentyearyear = $gmEntry->{'comments'}[$comm_index]{'year'};
	my $thiscommenthour = $gmEntry->{'comments'}[$comm_index]{'hour'};
	my $thiscommentminute = $gmEntry->{'comments'}[$comm_index]{'minute'};
	my $thiscommentsecond = $gmEntry->{'comments'}[$comm_index]{'second'};
	my $thiscommentampm = $gmEntry->{'comments'}[$comm_index]{'ampm'};
	my $thiscommenttext =   defined( $IN{'revisedentrycommenttext'} ) ? 
		$IN{'revisedentrycommenttext'} : $gmEntry->{'comments'}[$comm_index]{'comment'};

	my $thiscommentmonthmonth = Gm_Utils::toTwoDigit( $thiscommentmonth );
	my $thiscommentdayday = Gm_Utils::toTwoDigit( $thiscommentday );
	my $thiscommenthourhour = Gm_Utils::toTwoDigit( $thiscommenthour );
	my $thiscommentminuteminute = Gm_Utils::toTwoDigit( $thiscommentminute );
	my $thiscommentsecondsecond = Gm_Utils::toTwoDigit( $thiscommentsecond );

	$thiscommenttext = Gm_Utils::toWebSafe($thiscommenttext);

	if( $message eq Gm_Constants::EMPTY ){ 
		$message = "<span class=\"section_title\">Editing Comment #$IN{'revisedentrycommentselection'} ".
			"In Entry #$IN{'entryid'} ($thisentrysubject)</span><br />\nPosted on ".
			"$thiscommentmonthmonth/$thiscommentdayday/$thiscommentyearyear $thiscommenthourhour\:".
			"$thiscommentminuteminute\:$thiscommentsecondsecond $thiscommentampm<P>";
	}


	my $page = "<p>$message</p>\n<form action=\"gm.cgi\" method=post>".
		Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type=hidden name="section" value="'.$IN{'section'}.'">'.
		'<input type=hidden name="revisedentrycommentselection" value="'.
		$IN{'revisedentrycommentselection'}.'">'.
		'<input type=hidden name="entryid" value="'.$IN{'entryid'}.'">'.
		'<input type=hidden name="entryselectionview" value="'.$IN{'entryselectionview'}.'">';

	$page .= '<table width="95%" class="form_table"><tr><th width="20%">Author:</th>'.
		'<td><input type=text class="inputfield" name="revisedentrycommentauthor" value="'.
		$thiscommentauthor.'" size="45"></td></tr>';
	$page .= '<tr><th>E-Mail:</th><td><input type=text class="inputfield" '.
		'name="revisedentrycommentauthoremail" '.
		'value="'.$thiscommentauthoremailabsolute.'" size="45"></td></tr>';
	$page .= '<tr><th>Homepage:</th><td><input type=text class="inputfield" '.
		'name="revisedentrycommentauthorhomepage" '.
		'value="'.$thiscommentauthorhomepageabsolute.'" size="45"></td></tr>';
	$page .= '<tr><th>Comment Text:</th><td><textarea name="revisedentrycommenttext" cols=86 '.
		'rows=10  class="inputfield">'.$thiscommenttext.'</textarea></td></tr>';
	$page .= '<tr><th>&nbsp</th><td><INPUT TYPE=RESET CLASS="button" '.
		'STYLE="background: #FFD0D0" VALUE="Undo Changes Since Last Save"> '.
		'<input type=submit class="button" name="updatecomment" style="background: #D0FFD0" '.
		'value="Save Changes To This Comment"></td></th></table>'."\n";
		
	$page .= '<p><input type=SUBMIT class="button" name="view" '.
		'value="Return To Entry Editing"></form></p>'."\n";		

	$page .= '<form action="gm.cgi" method="post">'.Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type=SUBMIT class="button" name="thomas" value="'.
		Gm_Core::text( Gm_Constants::RETURN_MAIN_MENU ).'" style="background: #C0C0C0"></form>'."\n";

	Gm_Web::displayAdminPageExit( $page );
	## NAVIGATION SHOULD BE DE-BUTTONED
	exit(0); ## will never get here, in theory
}

## Update Entry Comment
# updates a given entry comment, sends a user to the view entry page
## NOTE: should part of this be generized and put in Core?  Something that doesn't presume where its being
# called from so it can be reused with normal user self-registration?
sub updateEntryComment {
	my $message = Gm_Constants::EMPTY;
#&gm_validate;

# if ($gmentryeditaccess eq Gm_Constants::NO) {
# 	gm_writetocplog("$IN{'authorname'} attempted to edit comment #$IN{'revisedentrycommentselection'} in entry #$IN{'revisedentrynumber'} ($IN{'revisedentrysubject'}) without authorization");
# 	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to edit comments.</FONT></B><P>);
# 	&gm_frontpage;
# }
# 
# if (($IN{'authorname'} ne $IN{'revisedentryauthor'}) && ($gmentryeditaccess eq "mineonly")) {
# 	gm_writetocplog("$IN{'authorname'} attempted to edit comment #$IN{'revisedentrycommentselection'} in entry #$IN{'entryselectionlist'} (by $IN{'revisedentryauthor'}) without authorization");
# 	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to edit comments in entries you didn't create.</FONT></B><P>);
# 	&gm_editentryselection;
# }

#	$IN{'entryselectionlist'} = $IN{'revisedentrynumber'};
	
	$IN{'revisedentrycommentauthor'} = Gm_Utils::toConfigSafe($IN{'revisedentrycommentauthor'});
	$IN{'revisedentrycommentauthoremail'} = Gm_Utils::toConfigSafe($IN{'revisedentrycommentauthoremail'});
	$IN{'revisedentrycommentauthorhomepage'} = Gm_Utils::toConfigSafe($IN{'revisedentrycommentauthorhomepage'});
	$IN{'revisedentrycommenttext'} = Gm_Utils::toStoreSafe($IN{'revisedentrycommenttext'});
	
	if( $IN{'revisedentrycommentauthor'} eq Gm_Constants::EMPTY || 
		$IN{'revisedentrycommenttext'} eq Gm_Constants::EMPTY ){
		$message = '<span class="error_msg">You left either the comment author or '.
			'text blank.  Please try again.</span>';
#		&gm_editselectedcomment;
		viewEntryComment( $message );
	}
	
	if( $IN{'revisedentrycommentselection'} eq Gm_Constants::EMPTY ){
		$message = '<span class="error_msg">You must select a comment to edit.</span>';
#		&gm_editselectedcomment;
		editEntry( $message );
	}

#$thisentrynumberpadded = Gm_Utils::toEntryPadded( $IN{'revisedentrynumber'} );
	my $thisentrynumberpadded = Gm_Utils::toEntryPadded( $IN{'entryid'} );

	my $gmEntry = Gm_Storage::getEntry( id=>$IN{'entryid'},
		errHandler=>\&Gm_Web::displayUserErrorExit );

	my $thisentryauthor = $gmEntry->{'entryinfo'}{'author'};
	my $thisentrysubject = $gmEntry->{'entryinfo'}{'subject'};
	
	if( $AUTHOR{'author'} ne $thisentryauthor && $AUTHOR{'editentries'} eq 'O' ){
		Gm_Core::writeToCplog( "$AUTHOR{'author'}  attempted to edit a comment in entry ".
			"#$IN{'entryid'} (by $thisentryauthor) without authorization" );
		$message = '<span class="error_msg">You don\'t have access to edit comments '.
			'in entries you didn\'t create.</span>';
		filterEntryList( $message );
	}

	my $comm_index = $IN{'revisedentrycommentselection'} - 1;

	$gmEntry->{'comments'}[$comm_index]{'name'} = $IN{'revisedentrycommentauthor'};
	$gmEntry->{'comments'}[$comm_index]{'email'} = $IN{'revisedentrycommentauthoremail'};
	$gmEntry->{'comments'}[$comm_index]{'homepage'} = $IN{'revisedentrycommentauthorhomepage'};
	$gmEntry->{'comments'}[$comm_index]{'comment'} = $IN{'revisedentrycommenttext'};

	Gm_Storage::setEntry( entry=>$gmEntry, errHandler=>\&Gm_Web::displayAdminErrorExit );

	Gm_Core::writeToCplog( "$AUTHOR{'author'} edited comment ".
		"#$IN{'revisedentrycommentselection'} in entry #$IN{'entryid'} ($IN{'revisedentrysubject'})");

	$message = '<span class="status_msg">Comment #'.$IN{'revisedentrycommentselection'}.
		' has been edited.  Be sure to rebuild your files to make the changes visible on that '.
		'entry\'s page.</span>';

#	&gm_editthisentry;
	editEntry( $message );

}


## Manage Bookmarklets SECTION #################################################
## Handle all requests for bookmarklets, move to entries?
## and verify that author can access this section
sub viewBookmarklet {
	my $message = Gm_Constants::EMPTY;
	
# if( $gmbookmarkletaccess ne Gm_Constants::YES) {
# 	gm_writetocplog("$IN{'authorname'} attempted to add bookmarklets without authorization");
# 	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to use bookmarklets.</FONT></B><P>);
# 	&gm_frontpage;
# }
	if( $AUTHOR{'bookmarklets'} ne Gm_Constants::Y ){
		Gm_Core::writeToCplog("$AUTHOR{'author'} attempted to add bookmarklets without authorization");
		$message = '<span class="error_msg">You don\'t have access to use bookmarklets.</span>';
		Gm_Web::displayAdminErrorExit( $message );
	}


	&gm_readcounter; ## refactor out

	if( $newentrynumber < 1 ) {
		_checkIfDiagRun('<span class="error_msg">Please run "Diagnostics & Repair" '.
			'in the Configuration screen before adding bookmarklets.</span>');
	}


	if( $message eq Gm_Constants::EMPTY ){ 
		$message = '<span class="section_title">Add Bookmarklets</span>'; 
	}

#	&gm_readconfig; ## already done

	Gm_Core::writeToCplog("$AUTHOR{'author'} added a bookmarklet");

	my $page = "<p>$message</p>\n";	

	$page .= '<p class="text_left">Installing bookmarklets makes for the quickest '.
		'and most convenient way to "blog" new items, allowing you to post new entries to '.
		'Greymatter with one mouse-click while surfing anywhere on the web.<p>';
	$page .= '<p class="text_left">After installing a '.
		'bookmarklet, clicking the new "Post To Greymatter" menu or toolbar button in your browser or '.
		'selecting the bookmark '.
		'will load Greymatter in a pop-up window containing a link to the website you\'re currently '.
		'visiting all ready to go in your new entry, plus any text from the website that you may '.
		'have highlighted.</p>';
	$page .= '<p class="text_left">These bookmarklets currently require that Javascript be enabled in your '.
		'browser.  Also, since bookmarklets contain your Greymatter name and password, you may wish to '.
		'be careful about installing these if you share your computer with others.</p>'."\n";
	$page .= '<p class="text_left">There are several ways to install bookmarklet:<ul class="text_left">'.
		'<li>just drag the following link to your browser\'s menu or toolbar</li>'.
		'<li>right click the link and select "bookmark this link"</li>'.
		'<li>right click the link and select "copy this link location" then paste the '.
		'url into a new bookmark in your browser</li></ul></p>'."\n";
	$page .= '<p><B><A HREF="javascript:var lt;if(window.getSelection){lt=window.getSelection();}'.
		'else if(document.selection){lt=document.selection.createRange();}if(lt.text){lt=userSelection.text;}'.
		'void(gmwindow=window.open(\''.$cgiwebpath.'/gm.cgi?thomas=gmbmpost&'.
		Gm_Security::getUrlAuth(  author=>\%AUTHOR ).'&logtext=\'+escape(lt)+\'&'.
		'loglink=\'+escape(location.href)+\'&loglinktitle=\'+escape(document.title),'.
		'\'gmwindow\',\'scrollbars=yes,width=750,height=460,left=75,top=75,resizable=yes,'.
		'status=yes\'));gmwindow.focus();">Post To Greymatter (bookmarklet)</A></B></p>';
		
	$page .= '<p class="text_left">And that\'s that!  You should now have the bookmarklets '.
		'installed and working correctly, allowing one-click automatic logging to Greymatter from '.
		'anywhere on the web.</p>';
		
	$page .= "\n\n".'<p><form action="gm.cgi" method="post"> '.Gm_Security::getFormAuth( author=>\%AUTHOR ).
		'<input type=submit class="button" name="thomas" VALUE="'.Gm_Core::text( Gm_Constants::RETURN_MAIN_MENU ).
		'" STYLE="background: #C0C0C0"></form></p>';

	Gm_Web::displayAdminPageExit( $page );
	## NAVIGATION SHOULD BE DE-BUTTONED
	exit(0); ## will never get here, in theory

}






########################################### Private
############

## Emoticons Code
# RETURN 1: the emoticon javascript code
# RETURN 2: the emoticon javascript for the extended entry
sub _emoticonsCode {

	&gm_readconfig;
	my $emoticonsmaincode = Gm_Constants::EMPTY;
	my $emoticonsmorecode = Gm_Constants::EMPTY;
	if( ($emoticonsallowed eq Gm_Constants::BOTH) || ($emoticonsallowed eq Gm_Constants::ENTRIES) ) {
	$emoticonsmaincode = "
  <table>
   <tr>
    <td><img alt=\":)\" onclick=\"commentEmoticonMain(':)')\" src=\"$emoticonspath/smile.gif\" title=\":)\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":O\" onclick=\"commentEmoticonMain(':O')\" src=\"$emoticonspath/shocked.gif\" title=\":O\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":(\" onclick=\"commentEmoticonMain(':(')\" src=\"$emoticonspath/sad.gif\" title=\":(\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":D\" onclick=\"commentEmoticonMain(':D')\" src=\"$emoticonspath/biggrin.gif\" title=\":D\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":P\" onclick=\"commentEmoticonMain(':P')\" src=\"$emoticonspath/tongue.gif\" title=\":P\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\";)\" onclick=\"commentEmoticonMain(';)')\" src=\"$emoticonspath/wink.gif\" title=\";)\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":angry:\" onclick=\"commentEmoticonMain(':angry:')\" src=\"$emoticonspath/angry.gif\" title=\":angry:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":blush:\" onclick=\"commentEmoticonMain(':blush:')\" src=\"$emoticonspath/blush.gif\" title=\":blush:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":confused:\" onclick=\"commentEmoticonMain(':confused:')\" src=\"$emoticonspath/confused.gif\" title=\":confused:\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":cool:\" onclick=\"commentEmoticonMain(':cool:')\" src=\"$emoticonspath/cool.gif\" title=\":cool:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":crazy:\" onclick=\"commentEmoticonMain(':crazy:')\" src=\"$emoticonspath/crazy.gif\" title=\":crazy:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":cry:\" onclick=\"commentEmoticonMain(':cry:')\" src=\"$emoticonspath/cry.gif\" title=\":cry:\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":doze:\" onclick=\"commentEmoticonMain(':doze:')\" src=\"$emoticonspath/doze.gif\" title=\":doze:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":hehe:\" onclick=\"commentEmoticonMain(':hehe:')\" src=\"$emoticonspath/hehe.gif\" title=\":hehe:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":laugh:\" onclick=\"commentEmoticonMain(':laugh:')\" src=\"$emoticonspath/laugh.gif\" title=\":laugh:\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":plain:\" onclick=\"commentEmoticonMain(':plain:')\" src=\"$emoticonspath/plain.gif\" title=\":plain:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":rolleyes:\" onclick=\"commentEmoticonMain(':rolleyes:')\" src=\"$emoticonspath/rolleyes.gif\" title=\":rollseyes:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":satisfied:\" onclick=\"commentEmoticonMain(':satisfied:')\" src=\"$emoticonspath/satisfied.gif\" title=\":satisfied:\" width=\"19\" height=\"14\" /></td>
   </tr>
  </table>";

	$emoticonsmorecode = "
  <table>
   <tr>
    <td><img alt=\":)\" onclick=\"commentEmoticonMore(':)')\" src=\"$emoticonspath/smile.gif\" title=\"s:)\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":O\" onclick=\"commentEmoticonMore(':O')\" src=\"$emoticonspath/shocked.gif\" title=\":O\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":(\" onclick=\"commentEmoticonMore(':(')\" src=\"$emoticonspath/sad.gif\" title=\":(\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":D\" onclick=\"commentEmoticonMore(':D')\" src=\"$emoticonspath/biggrin.gif\" title=\":D\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":P\" onclick=\"commentEmoticonMore(':P')\" src=\"$emoticonspath/tongue.gif\" title=\":P\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\";)\" onclick=\"commentEmoticonMore(';)')\" src=\"$emoticonspath/wink.gif\" title=\";)\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":angry:\" onclick=\"commentEmoticonMore(':angry:')\" src=\"$emoticonspath/angry.gif\" title=\":angry:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":blush:\" onclick=\"commentEmoticonMore(':blush:')\" src=\"$emoticonspath/blush.gif\" title=\":blush:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":confused:\" onclick=\"commentEmoticonMore(':confused:')\" src=\"$emoticonspath/confused.gif\" title=\":confused:\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":cool:\" onclick=\"commentEmoticonMore(':cool:')\" src=\"$emoticonspath/cool.gif\" title=\":cool:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":crazy:\" onclick=\"commentEmoticonMore(':crazy:')\" src=\"$emoticonspath/crazy.gif\" title=\":crazy:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":cry:\" onclick=\"commentEmoticonMore(':cry:')\" src=\"$emoticonspath/cry.gif\" title=\":cry:\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":doze:\" onclick=\"commentEmoticonMore(':doze:')\" src=\"$emoticonspath/doze.gif\" title=\":doze:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":hehe:\" onclick=\"commentEmoticonMore(':hehe:')\" src=\"$emoticonspath/hehe.gif\" title=\":hehe:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":laugh:\" onclick=\"commentEmoticonMore(':laugh:')\" src=\"$emoticonspath/laugh.gif\" title=\":laugh:\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":plain:\" onclick=\"commentEmoticonMore(':plain:')\" src=\"$emoticonspath/plain.gif\" title=\":plain:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":rolleyes:\" onclick=\"commentEmoticonMore(':rolleyes:')\" src=\"$emoticonspath/rolleyes.gif\" title=\":rollseyes:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":satisfied:\" onclick=\"commentEmoticonMore(':satisfied:')\" src=\"$emoticonspath/satisfied.gif\" title=\"satisfied:\" width=\"19\" height=\"14\" /></td>
   </tr>
  </table>";
 }
 
 return( $emoticonsmaincode, $emoticonsmorecode );
}

## Hider Code Entry
# ARGS 1: The name of the 'id' to hide
# ARGS 2: The name of the hiding control element
# RETURN: the javascript code to control the hider
sub _hiderCodeEntry {
	my $toHide = shift( @_ ) || '';
	my $doesHide = shift( @_ ) || '';
	
	my $s = '<div class="text_right" id="'.$doesHide.'"><a href="javascript:hider(\''.
		$toHide.'\', \''.$doesHide.'\');">Hide</a>';

	return( $s );
}

## Sizer Code Entry
# ARGS 1: The name of the 'id' to resize
# RETURN: the javascript code to control the element resizing
sub _sizerCodeEntry {
	my $toSize = shift( @_ ) || '';
	
	my $s = '<div class=\'text_right\'>(<a href="javascript:sizer(\''.$toSize.'\', \'s\' );">-</a> '. 
		'<a href="javascript:sizer(\''.$toSize.'\', \'l\' );">+</a>)</div>';

	return( $s );
}



